

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using AcknexWrapper;
using System.Runtime.InteropServices;
using System.Threading;
using System.IO;
using System.Xml.Serialization;
using System.Runtime.Serialization;
using VRPGText;
using System.Drawing.Imaging;
using AcknexWrapper.Native;
using System.Diagnostics;
namespace VRPGText
{


    [Serializable()]
    public partial class Editor : Form
    {
        
        #region Global Variables
        public String pathSave = ".\\";
        public String justTitle = "Test";
        public String returnPath() { return pathSave; }
        public String justProjectTitle() { return justTitle; }

        public MusicForm Form2;
        VRPGText.IniFile ini;
        private bool initialize_Engine = false;
        public Editor_Options YRPGMap_Options = new Editor_Options();
        public String skyTexture = "";
        public Editor_Object current_Map_Object = null;
        public static List<Editor_Object> TileList = new List<Editor_Object>();
        public Editor_Sunlight Sunlight;
        public Editor_EntityPosition EntityPosition;
        public Editor_Fog Fog;
        public List<ENTITY> entityList = new List<ENTITY>();
        public List<Editor_Map> mapList = new List<Editor_Map>();
        public static Editor_Speed Editor_Speed = null;
        public static Editor_Speed_Values Editor_Speed_Values = null;
        ymap ymapObject = new ymap();
        yed yedMainObject = new yed();
        Editor_Sky Editor_Sky;
        Editor yed_Ptr;
        public List<String> allMaps = new List<String>();
        private String ScriptToLoad = "";
        public static bool mapEditorOn = false;
        public static bool initializedMap = false;
        public static int counter = 1;
        List<VRPGText.Events> eventList = null;
        public static ENTITY thisEntity = null;
        public Editor_Flags tempFlag = new Editor_Flags();
        private TEXT welcomeText = null;
        private FONT courierFont = null;
        private static PANEL loadPanel = null;
        private static FONT loadFont = null;
        public static Boolean freeCamera = false;
    
        public Dictionary<string, BMAP> BMAP_DICTIONARY = null;
        public Dictionary<string, BMAP> BMAP_NORMAL_DICTIONARY = null;
        public Dictionary<string, BMAP> BMAP_SKY_DICTIONARY = null;
        public Editor_Entity_Custom_Skin customSkin = null; 
        MATERIAL gras_Mat = null;
        public void setSkyTexture(String texture)
        {
            skyTexture = texture;
            if (current_Map_Object != null)
            {
                current_Map_Object.skyTexture = skyTexture;
                current_Map_Object.skyAttributes.texture_Sky = skyTexture;
            }
        }
        MATERIAL selectEntityPicture;
        MATERIAL markedEntityPicture;
        BMAP cursor_pcx = BMAP.bmap_create("cursor_pcx.pcx");
        BMAP crosshair_pcx = BMAP.bmap_create("crosshair_pcx.pcx");
        Vector temp = new Vector();
        String[] models = new String[6];
        double tempmodell = 0;
        Vector mouse_click = new Vector();
        int i = 0;
        int entityZaehler = 0;
        String modelToChoose = "";
        String mapToChoose = "";
        public bool tempEntityFromBlockMode = false;
        String currentMap;
        bool saveNow = false;
        bool loadNow = false;
        int scale = 0;
        bool modelCreate = false;
        #endregion

        #region WinAPI constants / definitions
        private const int WS_VISIBLE = 0x10000000;
        private const UInt32 SWP_SHOWWINDOW = 0x0040;

        [DllImport("user32.dll")]
        private static extern IntPtr SetParent(
            IntPtr hWndChild, IntPtr hWndNewParent);

        [DllImport("user32.dll")]
        private static extern bool SetWindowPos(
            IntPtr hWnd, IntPtr hWndInsertAfter,
            int X, int Y, int cx, int cy, uint uFlags);

        [DllImport("user32.dll")]
        private static extern int SetWindowLong(
            IntPtr hWnd, int nIndex, int dwNewLong);
        #endregion

        #region Engine and Embedded Window Initialization
        public void StartEngine() // open the acknex engine
        {

           
            EngFun.engine_open(null, null);


            if (!ini.IniReadValue("Map Editor", "fps").Equals(""))
            EngVar.fps_max = Convert.ToDouble(ini.IniReadValue("Map Editor", "fps"));
            else
                EngVar.fps_max = 60;
            DummyEntity = ENTITY.ent_create(null, null, null);
            EngVar.d3d_lodfactor.vec_set(new Vector(5, 10, 20));

            EngVar.camera.clip_near = 1;
            EngVar.camera.clip_far = 50000;
            EngVar.camera.arc = 60;
            EngVar.max_entities = 10000;
            mapList.Add(new Editor_Map("Editor"));
            EngVar.preload_mode = 1;
            if (!ini.IniReadValue("Map Editor", "Antialias").Equals(""))
                EngVar.d3d_antialias = Convert.ToDouble(ini.IniReadValue("Map Editor", "Antialias"));
            else
            EngVar.d3d_antialias = 9;
            if (!ini.IniReadValue("Map Editor", "Anisotropy").Equals(""))
                EngVar.d3d_anisotropy = Convert.ToDouble(ini.IniReadValue("Map Editor", "Anisotropy"));
            else
                EngVar.d3d_anisotropy = 3;
            
            if (!ini.IniReadValue("Map Editor", "Mipmapping").Equals(""))
                EngVar.d3d_mipmapping = Convert.ToDouble(ini.IniReadValue("Map Editor", "Mipmapping"));
            else
            EngVar.d3d_mipmapping = 3;
            EngFun.video_window(null, null, 256, null);
            EngFun.video_set(engine_Window.Width,engine_Window.Height, 0,0);
           

            EmbedWindow();
            initialize_Engine = true;
            Scheduler.StartScheduler(myMainMethod);
        }
        private delegate void EmbedWindowDelegate();
        private void EmbedWindow()
        {
            if (engine_Window.InvokeRequired)
            {
                engine_Window.BeginInvoke(
                    new EmbedWindowDelegate(this.EmbedWindow));
            }
            else
            {
                SetParent(EngVar.hWnd, engine_Window.Handle);
                SetWindowLong(EngVar.hWnd, -16, WS_VISIBLE);
                SetWindowPos(
                    EngVar.hWnd,
                    IntPtr.Zero,
                    0,
                    0,
                    engine_Window.Width,
                    engine_Window.Height,
                    SWP_SHOWWINDOW);
            }
        }

        #endregion

        private IEnumerable<ScheduleMethod> sky_Mode(IntPtr p)
        {
            skyEntity = ENTITY.createFromPointer(p);
            skyEntity.group = 3;
            skyEntity.PASSABLE = true;
            skyEntity.OVERLAY = true;
            skyEntity.ENABLE_ENTITY = true;
            skyEntity.ENABLE_FRAME = true;

            yield return ScheduleMethod.wait(1);
        }

        #region Scheduler Method block_Mode
        static double scaleGlobalBlock = 1;
        MATERIAL abc = MATERIAL.mtl_create();
        BMAP a;
        int tileType = 0;
        public static double preparedDouble = -1;
        public List<Editor_Tile> blockUndoList = new List<Editor_Tile>();
        private IEnumerable<ScheduleMethod> block_Mode(IntPtr p)
        {
            thisEntity = ENTITY.createFromPointer(p);
            thisEntity.group = 1;
            thisEntity.skills[19] = 3;
            thisEntity.scale_z = Convert.ToDouble(scaleGlobalBlock);
            thisEntity.ent_cloneskin();
            thisEntity.ent_setskin(BMAP_DICTIONARY[textureString.Replace("\\","")], 1);
            thisEntity.skills[21] = 0;
            if (useNormalMap_checkBox.Checked == true)
            {
               String tempTextureNormal = textureString.Substring(0, textureString.LastIndexOf(".")) + "_n.png";
               current_Map_Object.addNewTile(textureString, true, thisEntity.xyz, tileType,thisEntity.scale_z,thisEntity.pan);
               thisEntity.ent_setskin(BMAP_NORMAL_DICTIONARY[tempTextureNormal.Replace("\\","")], 2);
               thisEntity.material = abc;
               thisEntity.skills[21] = 1;
            }
            else
            {
                thisEntity.material = MATERIAL.mtl_create();
                current_Map_Object.addNewTile(textureString, false, thisEntity.xyz, tileType, thisEntity.scale_z,thisEntity.pan);
            }
          
                thisEntity.skills[18] = (current_Map_Object.tileList[current_Map_Object.tileList.Count - 1].id);
                blockUndoList.Add(current_Map_Object.tileList[current_Map_Object.tileList.Count - 1]);
                blockUndoList[blockUndoList.Count-1].marked = "Create";
                undo_button.BeginInvoke(new Action(() =>
                {
                    undo_button.Enabled = true;
                })
                );
               
                if (ent_WavingGras_checkBox.Checked == true)
                {
                    thisEntity.material = gras_Mat;
                }
            thisEntity.DYNAMIC = true;
            thisEntity.OVERLAY = true;
            if (tileType == 1 || tileType == 3 || tileType == 5 || tileType == 7)
            {
                thisEntity.SHADOW = true;
            }
            if (preparedDouble > -1)
            {
                thisEntity.pan = preparedDouble;
            }
           
            yield break;
        }
        private IEnumerable<ScheduleMethod> block_Mode_Recreate(IntPtr p)
        {

            thisEntity = ENTITY.createFromPointer(p);
            thisEntity.group = 1;
            thisEntity.skills[19] = 3;
            thisEntity.scale_z = tempTile.tileZ;
            thisEntity.ent_cloneskin();
            thisEntity.ent_setskin(BMAP_DICTIONARY[tempTile.picture.Replace("\\", "")], 1);

            thisEntity.skills[21] = 0;
            if (tempTile.normalMap == true)
            {
                String tempTextureNormal = tempTile.picture.Substring(0, tempTile.picture.LastIndexOf(".")) + "_n.png";
                current_Map_Object.addNewTile(tempTile.picture, true, new Vector((double)tempTile.position.x, (double)tempTile.position.y, (double)tempTile.position.z), tempTile.tileType, tempTile.tileZ, tempTile.pan);
                thisEntity.ent_setskin(BMAP_NORMAL_DICTIONARY[tempTextureNormal.Replace("\\", "")], 2);

                thisEntity.material = abc;
                thisEntity.skills[21] = 1;
            }
            else
            {
                thisEntity.material = MATERIAL.mtl_create();
                current_Map_Object.addNewTile(tempTile.picture, false, new Vector((double)tempTile.position.x, (double)tempTile.position.y, (double)tempTile.position.z), tempTile.tileType, tempTile.tileZ, tempTile.pan);
            }

            thisEntity.skills[18] = (current_Map_Object.tileList[current_Map_Object.tileList.Count - 1].id);
            thisEntity.DYNAMIC = true;
            thisEntity.OVERLAY = true;
            if (tempTile.tileType == 1 || tempTile.tileType == 3 || tempTile.tileType == 5 || tempTile.tileType == 7)
            {
                thisEntity.SHADOW = true;
            }
            yield break;
        }
        private IEnumerable<ScheduleMethod> block_Mode_Load(IntPtr p)
       { 
            {
                thisEntity = ENTITY.createFromPointer(p);
                thisEntity.group = 1;
                thisEntity.skills[19] = 3;
                thisEntity.scale_z = tempTile.tileZ;
                thisEntity.ent_cloneskin();
                thisEntity.skills[21] = 0;
                thisEntity.ent_setskin(BMAP_DICTIONARY[tempTile.picture.Replace("\\", "")], 1);
                if (tempTile.normalMap == true)
                {
                    String tempString = tempTile.picture.Replace("\\", "");
                    thisEntity.ent_cloneskin();
                    thisEntity.ent_setskin(BMAP_NORMAL_DICTIONARY[tempString.Substring(0, tempString.Length - 4) + "_n.png"], 2);
                    thisEntity.material = abc;
                    thisEntity.skills[21] = 1;

                }
                else
                thisEntity.material = MATERIAL.mtl_create();
                thisEntity.skills[18] = tempTile.id;
                thisEntity.DYNAMIC = true;
                thisEntity.OVERLAY = true;
                if (tempTile.tileType == 1 || tempTile.tileType == 3 || tempTile.tileType == 5 || tempTile.tileType == 7)
                {
                    thisEntity.SHADOW = true;
                }
                thisEntity.pan = tempTile.pan;
            }
            yield break;
        }



        #endregion
        Editor_Entity tempUndoEntity = null;
        private IEnumerable<ScheduleMethod> recreate_click_and_move(IntPtr p)
        {
           
            tempFlag = new Editor_Flags();
            tempUndoEnt = ENTITY.createFromPointer(p);
            tempUndoEntity = entityUndoList[entityUndoList.Count - 1];
            tempUndoEnt.FLAG2 = true;
            tempUndoEnt.POLYGON = true;

            tempUndoEnt.DYNAMIC = true;
            tempUndoEnt.red = (double)tempUndoEntity.lightRange_Value.x;
            tempUndoEnt.green = (double)tempUndoEntity.lightRange_Value.y;
            tempUndoEnt.blue = (double)tempUndoEntity.lightRange_Value.z;
            if(tempUndoEntity.selfColor_Active == true)
            tempUndoEnt.LIGHT = true;
            tempUndoEnt.scale_x = (double)tempUndoEntity.scale;
            tempUndoEnt.scale_y = (double)tempUndoEntity.scale;
            tempUndoEnt.scale_z = (double)tempUndoEntity.scale;
            tempUndoEnt.pan = (double)tempUndoEntity.pan;
            if (tempUndoEntity.lightRange_Active)
                tempUndoEnt.lightrange = (double)tempUndoEntity.lightStrength;
            
            tempUndoEnt.group = 2;


            if (tempUndoEntity.flags.overlay == 1)
            {
                tempUndoEnt.OVERLAY = true;
                tempFlag.overlay = 1;
            }
            else
            {
                tempUndoEnt.OVERLAY = false;
                tempFlag.overlay = 0;
            }
            if (tempUndoEntity.flags.passable == 1)
            {
                tempUndoEnt.PASSABLE = true;
                tempFlag.passable = 1;
            }
            else
            {
                tempUndoEnt.PASSABLE = false;
            }
            if (tempUndoEntity.flags.bright == 1)
            {
                tempUndoEnt.BRIGHT = true;
                tempFlag.bright = 1;
            }
            else
            {
                tempUndoEnt.BRIGHT = false;
                tempFlag.bright = 0;
            }
            if (tempUndoEntity.flags.translucent == 1)
            {
                tempUndoEnt.TRANSLUCENT = true;
                tempFlag.translucent = 1;
            }
            else
            {
                tempUndoEnt.TRANSLUCENT = false;
                tempFlag.translucent = 0;
            }
            if (tempUndoEntity.flags.shadow == 1)
            {
                tempUndoEnt.SHADOW = true;
                tempFlag.shadow = 1;
            }
            else
            {
                tempUndoEnt.SHADOW = false;
                tempFlag.shadow = 0;
            }
            if (tempUndoEntity.flags.unlit == 1)
            {
                tempUndoEnt.UNLIT = true;
                tempFlag.unlit = 1;
            }
            else
            {
                tempUndoEnt.UNLIT = false;
                tempFlag.unlit = 0;
            }
            if (tempUndoEntity.flags.gras == 1)
            {
                tempUndoEnt.skills[16] = 1;
                tempFlag.gras = 1;
                tempUndoEnt.material = gras_Mat;
            }
            else
            {
                tempUndoEnt.skills[16] = 0;
                tempFlag.gras = 0;
                tempUndoEnt.material = MATERIAL.mtl_create();
            }
            tempUndoEnt.skills[19] = 2;
            current_Map_Object.addNewEntity(entityUndoList[entityUndoList.Count - 1].model, entityUndoList[entityUndoList.Count - 1].lightRange_Active, entityUndoList[entityUndoList.Count - 1].selfColor_Active, entityUndoList[entityUndoList.Count - 1].lightStrength, entityUndoList[entityUndoList.Count - 1].lightRange_Value, entityUndoList[entityUndoList.Count - 1].position, entityUndoList[entityUndoList.Count - 1].pan, entityUndoList[entityUndoList.Count - 1].scale, entityUndoList[entityUndoList.Count - 1].flags, entityUndoList[entityUndoList.Count - 1].event_);
            entityUndoList.RemoveAt(entityUndoList.Count-1);
            
            entityUndo_button.BeginInvoke(new Action(() =>
            {
                if (entityUndoList.Count > 0)
                    entityUndo_button.Enabled = true;
            
            })
            );
            yield break;
        }

        #region Scheduler Method Click_And_Move
        private IEnumerable<ScheduleMethod> click_and_move(IntPtr p)
        {

            tempFlag = new Editor_Flags();
            thisEntity = ENTITY.createFromPointer(p);
            thisEntity.FLAG2 = true;
            thisEntity.POLYGON = true;
            
            thisEntity.DYNAMIC = true;
            thisEntity.red = 0;
            thisEntity.green = 0;
            thisEntity.blue = 0;
            thisEntity.group = 2;
    
            int zaehler = 0;
            for (zaehler = 0; zaehler < 11; zaehler++)
            {
                thisEntity.skills[zaehler] = whichEvent[zaehler];
            }
            if (entityOverlay.Checked == true)
            {
                thisEntity.OVERLAY = true;
                tempFlag.overlay = 1;
            }
            else
            {
                thisEntity.OVERLAY = false;
                tempFlag.overlay = 0;
            }
            if (entityPassable.Checked == true)
            {
                thisEntity.PASSABLE = true;
                tempFlag.passable = 1;
            }
            else
            {
                thisEntity.PASSABLE = false;
            }
            if (entityBright.Checked == true)
            {
                thisEntity.BRIGHT = true;
                tempFlag.bright = 1;
            }
            else
            {
                thisEntity.BRIGHT = false;
                tempFlag.bright = 0;
            }
            if (entityTranslucent.Checked == true)
            {
                thisEntity.TRANSLUCENT = true;
                tempFlag.translucent = 1;
            }
            else
            {
                thisEntity.TRANSLUCENT = false;
                tempFlag.translucent = 0;
            }
            if (entityShadow.Checked == true)
            {
                thisEntity.SHADOW = true;
                tempFlag.shadow = 1;
            }
            else{
                thisEntity.SHADOW = false;
                tempFlag.shadow = 0;
            }
            if (ent_Unlit_CheckBox.Checked == true)
            {
                thisEntity.UNLIT = true;
                tempFlag.unlit = 1;
            }
            else{
                thisEntity.UNLIT = false;
                tempFlag.unlit = 0;
            }
            if (ent_WavingGras_checkBox.Checked == true)
            {
                thisEntity.skills[16] = 1;
                tempFlag.gras = 1;
                thisEntity.material = gras_Mat;
            }
            else
            {
                thisEntity.skills[16] = 0;
                tempFlag.gras = 0;
                thisEntity.material = MATERIAL.mtl_create();
            }            
            thisEntity.skills[19] = 2;
            yield break;
        }


        bool entityCreationMode = false;
        private IEnumerable<ScheduleMethod> click_and_move_Load(IntPtr p)
        {
            thisEntity = ENTITY.createFromPointer(p);
           // thisEntity.FLAG2 = true;
            thisEntity.POLYGON = true;
            thisEntity.DYNAMIC = true;
            thisEntity.group = 2;

            int zaehler = 0;
            if (tempEnt.event_.Length > 0)
            {
                for (zaehler = 0; zaehler < tempEnt.event_.Length; zaehler++)
                {
                    thisEntity.skills[zaehler] = tempEnt.event_[zaehler];
                }
            }
            if (tempEnt.flags.overlay == 1)
            {
                thisEntity.OVERLAY = true;
            }
            else
                thisEntity.OVERLAY = false;
            if (tempEnt.flags.passable == 1)
            {
                thisEntity.PASSABLE = true;
            }
            else
                thisEntity.PASSABLE = false;
            if (tempEnt.flags.bright == 1)
            {
                thisEntity.BRIGHT = true;
            }
            else
                thisEntity.BRIGHT = false;
            if (tempEnt.flags.translucent == 1)
            {
                thisEntity.TRANSLUCENT = true;
            }
            else thisEntity.TRANSLUCENT = false;
            if (tempEnt.flags.shadow == 1)
            {
                thisEntity.SHADOW = true;
            }
            else
                thisEntity.SHADOW = false;

            if (tempEnt.flags.unlit == 1)
            {
                thisEntity.UNLIT = true;
            }
            else
                thisEntity.UNLIT = false;

            if (tempEnt.flags.gras == 1)
            {
                thisEntity.skills[16] = 1;
            }
            else
            {
                thisEntity.skills[16] = 0;
            }

            if (tempEnt.flags.invisible == 1)
            {
                thisEntity.skills[14] = 1;
            }
            else
                thisEntity.skills[14] = 0;
            
            thisEntity.skills[19] = 2;
            thisEntity.skills[18] = tempEnt.id;
            if(tempEnt.lightRange_Active == true)
            {
                thisEntity.lightrange = tempEnt.lightStrength;
                thisEntity.red = (double)tempEnt.lightRange_Value.x;
                thisEntity.green = (double)tempEnt.lightRange_Value.y;
                thisEntity.blue = (double)tempEnt.lightRange_Value.z;
                thisEntity.LIGHT = tempEnt.selfColor_Active;
            }
            thisEntity.pan = tempEnt.pan;
            thisEntity.scale_x = tempEnt.scale;
            thisEntity.scale_y = tempEnt.scale;
            thisEntity.scale_z = tempEnt.scale;
            if (tempEnt.flags.gras == 1)
            {
                thisEntity.material = gras_Mat;
                thisEntity.raw_skill41 = EngFun.floatv(50);
                thisEntity.raw_skill42 = EngFun.floatv(50);
                thisEntity.raw_skill43 = EngFun.floatv(50);
                thisEntity.raw_skill44 = EngFun.floatv(50);

            }
            readEntityMode = false;
            yield return ScheduleMethod.wait(1);
        }


        #endregion

 
        public double GetRandomNumber(double minimum, double maximum)
        {
            Random random = new Random();
            return random.NextDouble() * (maximum - minimum) + minimum;
        }
   

      
        String fillEntity_Name = "";
        double fillEntity_Z = 0;
        #region Scheduler Method mouseTo3D
        private IEnumerable<ScheduleMethod> mouseTo3D()
        {
            ENTITY markinTile = null;
            while (true)
            {
                EngVar.mouse_pos.x = EngVar.mouse_cursor.x;
                EngVar.mouse_pos.y = EngVar.mouse_cursor.y;
                while (EngVar.mouse_cursor.x > EngVar.screen_size.x || EngVar.mouse_cursor.y > EngVar.screen_size.y || EngVar.mouse_cursor.x < 0 || EngVar.mouse_cursor.y < 0) yield return ScheduleMethod.wait(1);

                if (blockMode == true)
                {
                    mouse_click.vec_set(EngVar.mouse_dir3d);
                    mouse_click.vec_normalize(4000);
                    mouse_click.vec_add(EngVar.mouse_pos3d);

                    ENTITY.c_ignore(2, 3, 0);
                    ENTITY.c_trace(EngVar.camera.xyz, mouse_click, 0);
                    if (EngVar.you != null)
                    {
                        if (EngVar.you.skills[22] == 1) EngVar.you.material = selectEntityPicture;

                        if (EngVar.you.skills[22] == 0)
                        {
                            if (markinTile != null)
                            {
                                if (markinTile.skills[22] == 0)
                                {
                                    if (markinTile != EngVar.you)
                                    {
                                        if (markinTile.skills[21] == 1)
                                        {
                                            markinTile.material = abc;
                                        }
                                        else
                                        {
                                            markinTile.material = MATERIAL.mtl_create();
                                        }
                                    }
                                }
                            }
                            if (EngVar.you.skills[22] == 0 && !EngVar.you.str_for_entname().Contains("x"))
                            {
                                markinTile = EngVar.you;
                                markinTile.material = markedEntityPicture;
                            }
                        }
                    }
                }
                else
                {
                    if (markinTile != null)
                    {
                        if (markinTile.skills[21] == 1)
                        {
                            markinTile.material = abc;
                        }
                        else
                        {
                            markinTile.material = MATERIAL.mtl_create();
                        }
                        markinTile = null;
                    }
                }
             
                if (EngVar.mouse_left && modelCreate == false && initializedMap == true && fillEmptySpace_ON == false)
                {
                    fillEntity_Name = "";
                    fillEntity_Z = 0;
                    {
                        if (EngVar.mouse_ent != null)
                        {
                            fillEntity_Name = EngVar.mouse_ent.str_for_entname();
                            fillEntity_Z = EngVar.mouse_ent.z;
                        }
                        mouse_click.vec_set(EngVar.mouse_dir3d); 
                        mouse_click.vec_normalize(4000); 
                        mouse_click.vec_add(EngVar.mouse_pos3d); 
                        if (ignoreEntities.Checked == true && blockMode == false)
                        {
                            ENTITY.c_ignore(2, 3, 0);
                            ENTITY.c_trace(EngVar.camera.xyz, mouse_click,0);
                        }
                        else if (ignoreEntities.Checked == false && blockMode == false)
                        {
                            ENTITY.c_ignore(3, 0);
                            ENTITY.c_trace(EngVar.camera.xyz, mouse_click, Flags.IGNORE_FLAG2 | Flags.IGNORE_YOU);
                        }
                        else if (blockMode == true)
                        {
                        }
                    }



                    yield return ScheduleMethod.wait(5);
                    #region Entitymode

                    if (blockMode == false && flatCylinderTile.Checked == false && CylinderTile.Checked == false && flatCubeTile.Checked == false && CubeTile.Checked == false && Place_Mode_checkBox.Checked == true)
                    {
                        entityCreationMode = true;
                        thisEntity = ENTITY.ent_create(modelToChoose, EngVar.target, click_and_move);
                        thisEntity.FLAG2 = false;
                        thisEntity.skills[17] = flyingEntity.skills[17];
                        thisEntity.skills[14] = flyingEntity.skills[14];
                       double entScale;
                        if (randomScale_Checkbox.Checked == true)
                        {
                            entScale = GetRandomNumber(Convert.ToDouble(entityScale.Value), Convert.ToDouble(entityMaxScale.Value));
                        }
                        else
                        {
                            entScale = Convert.ToDouble(entityScale.Value);
                        }
                        thisEntity.scale_xyz.vec_set(new Vector(entScale, entScale, entScale));
                        double entPan = 0;
                        if (ent_Pan.Checked == true)
                        {
                            entPan  = GetRandomNumber(1, 360);
                            thisEntity.pan = entPan ;
                        }
                        else{
                            thisEntity.pan = flyingEntity.pan; 
                            entPan  = thisEntity.pan;
                        }
                        vector tempVec = new vector();
                        entityRedVecTrack.BeginInvoke(new Action(() =>
                        {
                            tempVec.x =    entityRedVecTrack.Value;
                        })
                        );
                         entityGreenVecTrack.BeginInvoke(new Action(() =>
                        {
                            tempVec.y =    entityGreenVecTrack.Value;
                        })
                        );
                         entityBlueVecTrack.BeginInvoke(new Action(() =>
                        {
                            tempVec.z =    entityBlueVecTrack.Value;
                        })
                        );
                        int tempLight  = 0;
                         entityBlueVecTrack.BeginInvoke(new Action(() =>
                         {
                             tempLight = entityLightrange_trackbar.Value;
                         })
                         );
                         entity_Player.BeginInvoke(new Action(() =>
                         {
                             if (entity_Player.Checked == true)
                             {
                                 tempFlag.player = 1;
                             }
                             else
                             {
                                 tempFlag.player = 0;
                             }
                         })
                         );
                        current_Map_Object.addNewEntity(thisEntity.str_for_entfile(), lightRange_checkBox.Checked, changeOwnColor_checkBox.Checked, tempLight, new vector(tempVec.x, tempVec.y, tempVec.z), new vector((decimal)thisEntity.x, (decimal)thisEntity.y, (decimal)thisEntity.z), entPan, entScale, tempFlag, selectedEvent);
                        entityUndoList.Add(current_Map_Object.entityList[current_Map_Object.entityList.Count - 1]);
                        entityUndoList[entityUndoList.Count - 1].marked = "Create";

                        entityUndo_button.BeginInvoke(new Action(() => {
                            entityUndo_button.Enabled = true;
                        })
                        );
                        thisEntity.skills[18] = (current_Map_Object.entityList[current_Map_Object.entityList.Count - 1].id);
                        entityCreationMode = false;
                        yield return ScheduleMethod.wait(10);
                    }
                    #endregion

                    #region Blockmode
                    if (blockMode == true && TextureNow != null && brushTiles == true)
                    {
                        if (!TextureNow.Equals(""))
                        {
                            ENTITY.c_ignore(2, 3, 0);
                            ENTITY.c_trace(EngVar.mouse_pos3d, mouse_click, Flags.USE_POLYGON);
                            double tileX = Math.Round((EngVar.target.x / 128), 0, MidpointRounding.AwayFromZero);
                            double tileY = Math.Round((EngVar.target.y / 128), 0, MidpointRounding.AwayFromZero); 
                                if (CubeTile.Checked == true)
                                {
                                    tileType = 1;
                                    thisEntity = ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Tiles\\Tile.mdl", new Vector(tileX * 128, tileY * 128, EngVar.target.z), block_Mode);
                                }
                                else
                                    if (flatCubeTile.Checked == true)
                                    {
                                        tileType = 2;
                                        ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Tiles\\TileFlat.mdl", new Vector(tileX * 128, tileY * 128, EngVar.target.z), block_Mode);
                                    }
                                    else
                                        if (CylinderTile.Checked == true)
                                        {
                                            tileType = 3;
                                            ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Tiles\\Cylinder.mdl", new Vector(tileX * 128, tileY * 128, EngVar.target.z), block_Mode);
                                        }
                                        else
                                            if (flatCylinderTile.Checked == true)
                                            {
                                                tileType = 4;
                                                ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Tiles\\FlatCylinder.mdl", new Vector(tileX * 128, tileY * 128, EngVar.target.z), block_Mode);
                                            }
                                            else
                                                if (stepTile.Checked == true)
                                                {
                                                    tileType = 5;
                                                    tileX = Math.Round((EngVar.target.x / 64), 0, MidpointRounding.AwayFromZero);
                                                    tileY = Math.Round((EngVar.target.y / 64), 0, MidpointRounding.AwayFromZero);
                                                    yield return ScheduleMethod.wait(1);
                                                    ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Tiles\\Step.mdl", new Vector(tileX * 64, tileY * 64, EngVar.target.z), block_Mode);
                                                }
                                                else
                                                    if (flatStepTile.Checked == true)
                                                    {
                                                        tileType = 6;
                                                        tileX = Math.Round((EngVar.target.x / 64), 0, MidpointRounding.AwayFromZero);
                                                        tileY = Math.Round((EngVar.target.y / 64), 0, MidpointRounding.AwayFromZero);
                                                        ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Tiles\\StepFlat.mdl", new Vector(tileX * 64, tileY * 64, EngVar.target.z), block_Mode);
                                                    }
                                                    else if (obstacleTile.Checked == true)
                                                    {
                                                        tileType = 7;
                                                        ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Tiles\\Obstacle.mdl", new Vector(tileX * 128, tileY * 128, EngVar.target.z), block_Mode);
                                                    }
                            yield return ScheduleMethod.wait(2);
                        }
                    }
                    else if (EngVar.mouse_ent != null && blockMode == true && TextureNow != null && brushTiles == false)
                        if (!TextureNow.Equals(""))
                        {
                            mouse_click.vec_set(EngVar.mouse_dir3d); 
                            mouse_click.vec_normalize(5000); 
                            mouse_click.vec_add(EngVar.mouse_pos3d);
                            ENTITY.c_ignore(2, 3, 0);
                            ENTITY.c_trace(EngVar.camera.xyz, mouse_click, Flags.USE_BOX);
                            fillEntity_Z = EngVar.hit.z;
                            double tileX = Math.Round((EngVar.target.x / 128), 0, MidpointRounding.AwayFromZero);
                            double tileY = Math.Round((EngVar.target.y / 128), 0, MidpointRounding.AwayFromZero);
                            fillEmptySpace(tileX, tileY);
                        }
                    #endregion
                }
                yield return ScheduleMethod.wait(1);
            }
        }
        #endregion

        #region test
        void saveEntity()
        {
        }
        void loadEntity()
        {
        }
        #endregion

        #region myMainMethod
        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        private delegate void WMBSaver(string a, string b);
        double loadProcess = 0;
        private IEnumerable<ScheduleMethod> myMainMethod()
        {
            EngVar.warn_level = 0;
            EngVar.tex_share = 1;
            EngFun.add_folder(yed_Ptr.returnPath() + "\\Models\\");
            EngFun.add_folder(yed_Ptr.returnPath() + "\\Models\\Skins\\");
            EngFun.add_folder(yed_Ptr.returnPath() + "\\Maps\\");
            EngFun.add_folder(yed_Ptr.returnPath() + "\\Maps\\Templates\\");
            EngFun.add_folder(yed_Ptr.returnPath() + "\\Maps\\Tiles\\");
            EngFun.add_folder(yed_Ptr.returnPath() + "\\Textures\\");
            EngFun.add_folder(yed_Ptr.returnPath() + "\\Textures\\Skymap\\");
            EngFun.add_folder(".\\code\\");
            EngFun.add_folder(".\\include\\");
       

            if(!ini.IniReadValue("Map Editor","Shadow").Equals(""))
            EngVar.shadow_stencil = Convert.ToDouble(ini.IniReadValue("Map Editor","Shadow"));
            else
            EngVar.shadow_stencil = 1;
           
              if(ini.IniReadValue("Map Editor","Shadow_Blur").Equals("true")){
            	MATERIAL mtl_shadow = MATERIAL.mtl_create();
	            mtl_shadow.skill1 = EngFun.floatv(1* 4);	// blur factor
		        mtl_shadow.effect_load("st_stencilBlur.fx"); // poisson blur

              }


            EngVar.shadow_lod = 0; 
            if (!ini.IniReadValue("Map Editor", "Threshold").Equals(""))
                EngVar.shadow_threshold = Convert.ToDouble(ini.IniReadValue("Map Editor", "Threshold"));
            else
            EngVar.shadow_threshold = 50;
            if (ini.IniReadValue("Map Editor", "Shader_NormalMap").Equals("true"))
            abc.effect_load("bump.fx");
            if (ini.IniReadValue("Map Editor", "Shader_Gras").Equals("true"))
            gras_Mat = MATERIAL.mtl_create();
            gras_Mat.effect_load("animTree.fx");
            EngVar.fps_max = 60;
            EngVar.sky_color.blue = 0;
            EngVar.sky_color.green = 0;
            EngVar.sky_color.blue = 0;
            EngFun.level_load(null);
            current_Map_Object = new Editor_Object();
            this.Sunlight.reloadSun();
            EngVar.camera.x = 0;
            EngVar.camera.y = 0;
            EngVar.camera.z = 150;
            EngVar.camera.pan = 0;
            EngVar.camera.tilt = -90;
            EngVar.camera.roll = 0;
            EngVar.mouse_range = 2000;
            EngVar.mouse_pointer = 2; 
            EngVar.mouse_mode = 2; // 
            EngVar.mouse_map = cursor_pcx;
            Scheduler.AddEventVoidThreadSafe(mouseTo3D);
            BMAP_DICTIONARY = new Dictionary<string, BMAP>();
            BMAP_NORMAL_DICTIONARY = new Dictionary<string, BMAP>();
            string[] dirs = Directory.GetFiles(yed_Ptr.returnPath() + "\\Textures\\", "*.png");
            foreach (var file in dirs)
            {
                if (!file.EndsWith("_n.png"))
                {
                    Bitmap bmp = new Bitmap(texture_width, texture_width);
                    using (Graphics g = Graphics.FromImage(bmp))
                    {
                        g.DrawImage(Image.FromFile(file), new Rectangle(0, 0, bmp.Width, bmp.Height));
                    }
                    imageList1.Images.Add(bmp);
                    textureView.Items.Add(file.Substring(file.LastIndexOf('\\') + 1, file.Length - file.LastIndexOf('\\') - 1), i);
                    customSkin.textureSky_listView.Items.Add(file.Substring(file.LastIndexOf('\\') + 1, file.Length - file.LastIndexOf('\\') - 1), i);
                    i++;
                    BMAP_DICTIONARY.Add(file.Substring(file.LastIndexOf('\\') + 1, file.Length - file.LastIndexOf('\\') - 1), BMAP.bmap_create(file.Substring(file.LastIndexOf('\\') + 1, file.Length - file.LastIndexOf('\\') - 1)));
                }
                if (File.Exists(file.Substring(0, file.Length - 4) + "_n.png"))
                {
                    string normal_map = file.Substring(file.LastIndexOf('\\') + 1, file.Length - file.LastIndexOf('\\') - 1);
                    BMAP_NORMAL_DICTIONARY.Add(normal_map.Substring(0, normal_map.Length - 4) + "_n.png", BMAP.bmap_create(normal_map.Substring(0, normal_map.Length - 4) + "_n.png"));
                }
            }
            BMAP_DICTIONARY.Add("YRPG_Template_Grid_Line.png", BMAP.bmap_create("YRPG_Template_Grid_Line.png"));
            yed_Ptr.BMAP_SKY_DICTIONARY = new Dictionary<string, BMAP>();
             dirs = Directory.GetFiles(yed_Ptr.returnPath() + "\\Textures\\Skymap\\", "*.png");
            foreach (var file in dirs)
            {
                if (!file.EndsWith("_n.png"))
                {
                    yed_Ptr.BMAP_SKY_DICTIONARY.Add(file.Substring(file.LastIndexOf('\\') + 1, file.Length - file.LastIndexOf('\\') - 1), BMAP.bmap_create(file.Substring(file.LastIndexOf('\\') + 1, file.Length - file.LastIndexOf('\\') - 1)));
                }
            }


            Vector mouse_move = new Vector();

            while (EngFun.engine_frame() == 1)
            {
                yield return ScheduleMethod.wait(1);

                
                #region Model On Ground
                if (flyingEntity != null && blockMode == false && modelCreate == false && Place_Mode_checkBox.Checked == true)
                    if ((EngVar.mouse_cursor.x < 1 || EngVar.mouse_cursor.y < 1) || ((EngVar.mouse_cursor.x >= EngVar.screen_size.x) || (EngVar.mouse_cursor.y >= EngVar.screen_size.y)))
                    {
                        EngVar.you = flyingEntity;
                        mouse_move.vec_set(new Vector(EngVar.screen_size.x / 2, EngVar.screen_size.y / 2, 0));
                        mouse_move.vec_for_screen(EngVar.camera);

                        if (ignoreEntities.Checked == true)
                        {
                            ENTITY.c_ignore(2, 3, 0);
                            ENTITY.c_trace(EngVar.camera.xyz, mouse_move, 0);
                        }
                        else
                        {
                            ENTITY.c_ignore(3, 0);
                            ENTITY.c_trace(EngVar.camera.xyz, mouse_move, Flags.IGNORE_YOU | Flags.IGNORE_FLAG2);
                        }
                        flyingEntity.xyz.vec_set(EngVar.target);
                        flyingEntity.pan = entity_Rotation;
                    }
                    else
                        if ((EngVar.mouse_cursor.x > -1 || EngVar.mouse_cursor.y > -1) && (EngVar.mouse_cursor.x < EngVar.screen_size.x && EngVar.mouse_cursor.y < EngVar.screen_size.y))
                        {
                            if (tempEntityFromBlockMode == true)
                            {
                                Scheduler.AddEventVoid(resetTempEntity);
                                tempEntityFromBlockMode = false;
                            }
                            
                            yield return ScheduleMethod.wait(1);
                            mouse_move.vec_set(EngVar.mouse_dir3d); 
                            mouse_move.vec_normalize(4000); 
                            mouse_move.vec_add(EngVar.camera.xyz); 
                            if (ignoreEntities.Checked == true)
                            {
                                ENTITY.c_ignore(2, 3, 0);
                                ENTITY.c_trace(EngVar.camera.xyz, mouse_move, 0);
                            }
                            else
                            {
                                ENTITY.c_ignore(3, 0);
                                ENTITY.c_trace(EngVar.camera.xyz, mouse_move, Flags.IGNORE_FLAG2 | Flags.IGNORE_YOU);
                            }
                            flyingEntity.xyz.vec_set(EngVar.target);
                            flyingEntity.pan = entity_Rotation;
                        }



                #endregion

                #region Execute Select Entity Handle
              
                    if (Place_Mode_checkBox.Checked == false)
                        if (EngVar.key_shiftl == false && EngVar.mouse_right && EngVar.mouse_ent != null)
                            if (readEntityMode == false && entityCreationMode == false)
                            if ((IntPtr.Equals(EngVar.mouse_ent.getIntPtr(), IntPtr.Zero) == false))
                            {
                                if (EngVar.mouse_ent.skills[19] == 2 || EngVar.mouse_ent.skills[19] == 3)
                                {
                                    Scheduler.AddEventVoid(deselectEntityMethod);
                                    mouse_click.vec_set(EngVar.mouse_dir3d); 
                                    mouse_click.vec_normalize(6000); 
                                    mouse_click.vec_add(EngVar.mouse_pos3d); 
                                    tempEntity = null;
                                    if (tempEntity == null && EngVar.mouse_ent.group == 1 && blockMode == true) tempEntity = EngVar.mouse_ent;
                                    if (tempEntity == null)
                                    {
                                        if (blockMode == true)
                                        {
                                            ENTITY.c_ignore(2, 3, 4, 0);
                                            tempEntity = EngVar.hit.entity;
                                        }
                                        else
                                        {
                                            ENTITY.c_ignore(1, 3, 4, 0);
                                            ENTITY.c_trace(EngVar.camera.xyz, mouse_click, 0);
                                            tempEntity = EngVar.you;
                                        }
                                    }
                                    if (tempEntity == null)
                                    {
                                        whichEventForMapEditor.BeginInvoke(new Action(()=>{
                                            whichEventForMapEditor.Enabled = false;  
                                        })
                                        );
                                        Scheduler.AddEventVoidThreadSafe(removeFlyingEntity);
                                        Scheduler.AddEventVoidThreadSafe(resetTempEntity);
                                        entityLight_Groupbox.BeginInvoke(new Action(()=>{
                                            entityLight_Groupbox.Enabled = false;  
                                        })
                                        );
                                        entityFlags_Group.BeginInvoke(new Action(() =>
                                        {
                                            entityFlags_Group.Enabled = false;
                                        })
                                        );

                                        ent_Pan.BeginInvoke(new Action(() =>
                                        {
                                            ent_Pan.Enabled = false;
                                        })
                                      );
                                        entity_Scale.BeginInvoke(new Action(() =>
                                        {
                                            entity_Scale.Enabled = false;
                                        })
                                        );
                                        selectedEntity.BeginInvoke(new Action(() =>
                                        {
                                            selectedEntity.Text = "NONE";
                                        })
                                   );
                                      
                                       

                                        if (tempEntity_YRPGObject != null)
                                            tempEntity_YRPGObject = null;
                                 

                                    }
                                    if (tempEntity != null)
                                        Scheduler.AddEventVoidThreadSafe(saveEntityHandle);
                                    readEntityMode = false;
                                }
                                


                            }

                    if (EngVar.key_shiftl && EngVar.key_del && selectedEntity.Text != "NONE" && readEntityMode == false)
                        if ((IntPtr.Equals(EngVar.mouse_ent.getIntPtr(), IntPtr.Zero) == false))
                            if (EngVar.mouse_ent.skills[19] == 2 || EngVar.mouse_ent.skills[19] == 3)
                            {
                                EngVar.you = ENTITY.ent_next(null);
                                while (EngVar.you != null)
                                {
                                    ENTITY tempEntity_ = null;
                                    if (EngVar.you.skills[19] == 2)
                                    {
                                        if (selectedEntity.Text == EngVar.you.str_for_entfile())
                                        {
                                            tempEntity_ = EngVar.you;
                                        }
                                    }
                                    EngVar.you = ENTITY.ent_next(EngVar.you);
                                    if (tempEntity_ != null)
                                    {
                                        tempEntity_.INVISIBLE = true;
                                        tempEntity_.ent_purge();
                                        tempEntity_.ent_remove();
                                    }
                                }
                            }
                #endregion
                #region Key Actions
                if (EngVar.key_0)
                {
                    Vector positionTile = new Vector();
                    mouse_click.vec_set(EngVar.mouse_dir3d);
                    mouse_click.vec_normalize(4000); 
                    mouse_click.vec_add(EngVar.camera.xyz);
                    ENTITY.c_trace(EngVar.camera.xyz, mouse_click, Flags.IGNORE_MODELS | Flags.ENABLE_FRAME);
                    double tileX = Math.Round((EngVar.target.x / 128), 0, MidpointRounding.AwayFromZero);
                    double tileY = Math.Round((EngVar.target.x / 128), 0, MidpointRounding.AwayFromZero);
                    fillEmptySpace(tileX, tileY);
                    yield return ScheduleMethod.wait(20);
                }
                if (EngVar.key_9) { }
                if (EngVar.key_8) { }
                if (EngVar.key_w == true && EngVar.key_shiftl)
                {
                    if(rotateCamera == 0)
                    EngVar.camera.x += Editor_Speed_Values.map_MoveFast;
                    else if (rotateCamera == 2)
                        EngVar.camera.x -= Editor_Speed_Values.map_MoveFast;
                            else if (rotateCamera == 3)
                                EngVar.camera.y -= Editor_Speed_Values.map_MoveFast;
                                            else if (rotateCamera == 1)
                                                EngVar.camera.y += Editor_Speed_Values.map_MoveFast;
                }
                else
                    if (EngVar.key_w == true && !EngVar.key_shiftl)
                    {
                        if (rotateCamera == 0)
                        EngVar.camera.x += Editor_Speed_Values.map_Move;
                        else if (rotateCamera == 2)
                            EngVar.camera.x -= Editor_Speed_Values.map_Move;
                        else if (rotateCamera == 3)
                            EngVar.camera.y -= Editor_Speed_Values.map_MoveFast;
                      
                        else if (rotateCamera == 1)
                            EngVar.camera.y += Editor_Speed_Values.map_MoveFast;
                    }
                if (EngVar.key_home == true && EngVar.key_shiftl && EngVar.camera.tilt < 90)
                {
                    EngVar.camera.tilt += Editor_Speed_Values.map_MoveFast;
                    if (EngVar.camera.tilt > 90) EngVar.camera.tilt = 90;
                }
                else
                    if (EngVar.key_home == true && EngVar.camera.tilt < 90)
                    {
                        EngVar.camera.tilt += Editor_Speed_Values.map_Move;
                        if (EngVar.camera.tilt > 90) EngVar.camera.tilt = 90;
                    }

                if (EngVar.key_end == true && EngVar.key_shiftl && EngVar.camera.tilt > -91)
                {
                    EngVar.camera.tilt -= Editor_Speed_Values.map_MoveFast;
                    if (EngVar.camera.tilt < -90) EngVar.camera.tilt = -90;
                }
                else
                    if (EngVar.key_end == true && EngVar.camera.tilt > -91)
                    {
                        EngVar.camera.tilt -= Editor_Speed_Values.map_Move;
                        if (EngVar.camera.tilt < -90) EngVar.camera.tilt = -90;
                    }
                if (EngVar.key_s == true && EngVar.key_shiftl)
                {
                    if (rotateCamera == 0)
                    EngVar.camera.x -= Editor_Speed_Values.map_MoveFast;
                    else if (rotateCamera == 2)
                        EngVar.camera.x += Editor_Speed_Values.map_MoveFast;
                    else if (rotateCamera == 3)
                        EngVar.camera.y += Editor_Speed_Values.map_MoveFast;
            
                    else if (rotateCamera == 1)
                        EngVar.camera.y -= Editor_Speed_Values.map_MoveFast;
                }
                else
                    if (EngVar.key_s == true && !EngVar.key_shiftl)
                    {
                        if (rotateCamera == 0)
                        EngVar.camera.x -= Editor_Speed_Values.map_Move;
                        else if (rotateCamera == 2)
                            EngVar.camera.x += Editor_Speed_Values.map_Move;
                        else if (rotateCamera == 3)
                            EngVar.camera.y += Editor_Speed_Values.map_MoveFast;
              
                        else if (rotateCamera == 1)
                            EngVar.camera.y -= Editor_Speed_Values.map_MoveFast;
                    }
                if (EngVar.key_a == true && EngVar.key_shiftl)
                {
                    if (rotateCamera == 0)
                    EngVar.camera.y += Editor_Speed_Values.map_MoveFast;
                    else if (rotateCamera == 2)
                        EngVar.camera.y -= Editor_Speed_Values.map_MoveFast;
                    else if (rotateCamera == 3)
                        EngVar.camera.x += Editor_Speed_Values.map_MoveFast;
            
                    else if (rotateCamera == 1)
                        EngVar.camera.x -= Editor_Speed_Values.map_MoveFast;
                }
                else
                    if (EngVar.key_a == true && !EngVar.key_shiftl)
                    {
                        if (rotateCamera == 0)
                        EngVar.camera.y += Editor_Speed_Values.map_Move;
                        else if (rotateCamera == 2)
                            EngVar.camera.y -= Editor_Speed_Values.map_Move;
                        else if (rotateCamera == 3)
                            EngVar.camera.x += Editor_Speed_Values.map_MoveFast;
          
                        else if (rotateCamera == 1)
                            EngVar.camera.x -= Editor_Speed_Values.map_MoveFast;
                    }

                if (EngVar.key_d == true && EngVar.key_shiftl)
                {
                    if (rotateCamera == 0)
                    EngVar.camera.y -= Editor_Speed_Values.map_MoveFast;
                    else if (rotateCamera == 2)
                        EngVar.camera.y += Editor_Speed_Values.map_MoveFast;
                    else if (rotateCamera == 3)
                        EngVar.camera.x -= Editor_Speed_Values.map_MoveFast;
             
                    else if (rotateCamera == 1)
                        EngVar.camera.x+= Editor_Speed_Values.map_MoveFast;
                }
                else
                    if (EngVar.key_d == true && !EngVar.key_shiftl)
                    {
                        if (rotateCamera == 0)
                        EngVar.camera.y -= Editor_Speed_Values.map_Move;
                        else if (rotateCamera == 2)
                            EngVar.camera.y += Editor_Speed_Values.map_Move;
                        else if (rotateCamera == 1)
                            EngVar.camera.x += Editor_Speed_Values.map_Move;
                        else if (rotateCamera == 3)
                            EngVar.camera.x -= Editor_Speed_Values.map_MoveFast;
                    }
                if (EngVar.key_pgdn == true && EngVar.key_shiftr)
                {
                    EngVar.camera.z -= Editor_Speed_Values.map_LiftFast;
                }
                else
                    if (EngVar.key_pgdn == true && !EngVar.key_shiftr)
                    {
                        EngVar.camera.z -= Editor_Speed_Values.map_Lift;
                    }

                if (EngVar.key_pgup == true && EngVar.key_shiftr)
                {
                    EngVar.camera.z += Editor_Speed_Values.map_LiftFast;
                }
                else
                    if (EngVar.key_pgup == true && !EngVar.key_shiftr)
                    {
                        EngVar.camera.z += Editor_Speed_Values.map_Lift;
                    }

                if (EngVar.key_pgup == true && EngVar.key_shiftr)
                {
                    EngVar.camera.z += Editor_Speed_Values.map_LiftFast;
                }
                else
                    if (EngVar.key_pgup == true && !EngVar.key_shiftr)
                    {
                        EngVar.camera.z += Editor_Speed_Values.map_Lift;
                    }
                if (EngVar.mickey.z != 0)
                {
                    EngVar.camera.z += EngVar.mickey.z;
                }
              
                if (tempEntity != null && Place_Mode_checkBox.Checked == false)
                {
                    if (EngVar.key_plus && tempEntity != null && EngVar.key_shiftr)
                    {
                        tempEntity.z += Editor_Speed_Values.ent_LiftFast;
                        if(tempEntity.skills[19] == 2)
                        searchEntity(tempEntity.skills[18], current_Map_Object).position.z += (decimal)Editor_Speed_Values.ent_LiftFast;
                        if (tempEntity.skills[19] == 3)
                            searchTile(tempEntity.skills[18], current_Map_Object).position.z += (decimal)Editor_Speed_Values.ent_LiftFast;
                    }
                    else
                        if (EngVar.key_plus && tempEntity != null && !EngVar.key_shiftr)
                        {
                            tempEntity.z += Editor_Speed_Values.ent_Lift;
                            if (tempEntity.skills[19] == 2)
                            searchEntity(tempEntity.skills[18], current_Map_Object).position.z += (decimal)Editor_Speed_Values.ent_Lift;
                            if (tempEntity.skills[19] == 3)
                                searchTile(tempEntity.skills[18], current_Map_Object).position.z += (decimal)Editor_Speed_Values.ent_Lift;
                        }

                 

                    if (EngVar.key_slash && tempEntity != null && EngVar.key_shiftr)
                    {
                        tempEntity.z -= Editor_Speed_Values.ent_LiftFast;
                        if (tempEntity.skills[19] == 2)
                        searchEntity(tempEntity.skills[18], current_Map_Object).position.z -= (decimal)Editor_Speed_Values.ent_LiftFast;
                        if (tempEntity.skills[19] == 3)
                            searchTile(tempEntity.skills[18], current_Map_Object).position.z -= (decimal)Editor_Speed_Values.ent_LiftFast;
                    }
                    else
                        if (EngVar.key_slash && tempEntity != null && !EngVar.key_shiftr)
                        {
                            tempEntity.z -= Editor_Speed_Values.ent_Lift;
                            if (tempEntity.skills[19] == 2)
                            searchEntity(tempEntity.skills[18], current_Map_Object).position.z -= (decimal)Editor_Speed_Values.ent_Lift;
                            if (tempEntity.skills[19] == 3)
                                searchTile(tempEntity.skills[18], current_Map_Object).position.z -= (decimal)Editor_Speed_Values.ent_Lift;
                        }
                    if (EngVar.key_cuu && tempEntity != null && EngVar.key_shiftr)
                    {
                        if (rotateCamera == 0)
                        {
                            tempEntity.x += Editor_Speed_Values.ent_PushFast;
                            if (tempEntity.skills[19] == 2)
                                searchEntity(tempEntity.skills[18], current_Map_Object).position.x += (decimal)Editor_Speed_Values.ent_PushFast;
                            if (tempEntity.skills[19] == 3)
                                searchTile(tempEntity.skills[18], current_Map_Object).position.x += (decimal)Editor_Speed_Values.ent_PushFast;
                        }
                        if (rotateCamera == 1)
                        {
                            tempEntity.y += Editor_Speed_Values.ent_PushFast;
                            if (tempEntity.skills[19] == 2)
                                searchEntity(tempEntity.skills[18], current_Map_Object).position.y += (decimal)Editor_Speed_Values.ent_PushFast;
                            if (tempEntity.skills[19] == 3)
                                searchTile(tempEntity.skills[18], current_Map_Object).position.y += (decimal)Editor_Speed_Values.ent_PushFast;
                        }
                        if (rotateCamera == 2)
                        {
                            tempEntity.x -= Editor_Speed_Values.ent_PushFast;
                            if (tempEntity.skills[19] == 2)
                                searchEntity(tempEntity.skills[18], current_Map_Object).position.x -= (decimal)Editor_Speed_Values.ent_PushFast;
                            if (tempEntity.skills[19] == 3)
                                searchTile(tempEntity.skills[18], current_Map_Object).position.x -= (decimal)Editor_Speed_Values.ent_PushFast;
                        }
                        if (rotateCamera == 3)
                        {
                            tempEntity.y -= Editor_Speed_Values.ent_PushFast;
                            if (tempEntity.skills[19] == 2)
                                searchEntity(tempEntity.skills[18], current_Map_Object).position.y -= (decimal)Editor_Speed_Values.ent_PushFast;
                            if (tempEntity.skills[19] == 3)
                                searchTile(tempEntity.skills[18], current_Map_Object).position.y -= (decimal)Editor_Speed_Values.ent_PushFast;
                        }
                    }
                    else
                        if (EngVar.key_cuu && tempEntity != null && !EngVar.key_shiftr)
                        {
                            if (rotateCamera == 0)
                            {
                                tempEntity.x += Editor_Speed_Values.ent_Push;
                                if (tempEntity.skills[19] == 2)
                                    searchEntity(tempEntity.skills[18], current_Map_Object).position.x += (decimal)Editor_Speed_Values.ent_Push;
                                if (tempEntity.skills[19] == 3)
                                    searchTile(tempEntity.skills[18], current_Map_Object).position.x += (decimal)Editor_Speed_Values.ent_Push;
                            }
                            if (rotateCamera == 1)
                            {
                                tempEntity.y += Editor_Speed_Values.ent_Push;
                                if (tempEntity.skills[19] == 2)
                                    searchEntity(tempEntity.skills[18], current_Map_Object).position.y += (decimal)Editor_Speed_Values.ent_Push;
                                if (tempEntity.skills[19] == 3)
                                    searchTile(tempEntity.skills[18], current_Map_Object).position.y += (decimal)Editor_Speed_Values.ent_Push;
                            }
                            if (rotateCamera == 2)
                            {
                                tempEntity.x -= Editor_Speed_Values.ent_Push;
                                if (tempEntity.skills[19] == 2)
                                    searchEntity(tempEntity.skills[18], current_Map_Object).position.x -= (decimal)Editor_Speed_Values.ent_Push;
                                if (tempEntity.skills[19] == 3)
                                    searchTile(tempEntity.skills[18], current_Map_Object).position.x -= (decimal)Editor_Speed_Values.ent_Push;
                            }
                            if (rotateCamera == 3)
                            {
                                tempEntity.y -= Editor_Speed_Values.ent_Push;
                                if (tempEntity.skills[19] == 2)
                                    searchEntity(tempEntity.skills[18], current_Map_Object).position.y -= (decimal)Editor_Speed_Values.ent_Push;
                                if (tempEntity.skills[19] == 3)
                                    searchTile(tempEntity.skills[18], current_Map_Object).position.y -= (decimal)Editor_Speed_Values.ent_Push;
                            }
                        }
                    if (EngVar.key_cud && tempEntity != null && EngVar.key_shiftr)
                    {
                        if (rotateCamera == 0)
                        {
                            tempEntity.x -= Editor_Speed_Values.ent_PushFast;
                            if (tempEntity.skills[19] == 2)
                                searchEntity(tempEntity.skills[18], current_Map_Object).position.x -= (decimal)Editor_Speed_Values.ent_PushFast;
                            if (tempEntity.skills[19] == 3)
                                searchTile(tempEntity.skills[18], current_Map_Object).position.x -= (decimal)Editor_Speed_Values.ent_PushFast;
                        }
                        if (rotateCamera == 1)
                        {
                            tempEntity.y -= Editor_Speed_Values.ent_PushFast;
                            if (tempEntity.skills[19] == 2)
                                searchEntity(tempEntity.skills[18], current_Map_Object).position.y -= (decimal)Editor_Speed_Values.ent_PushFast;
                            if (tempEntity.skills[19] == 3)
                                searchTile(tempEntity.skills[18], current_Map_Object).position.y -= (decimal)Editor_Speed_Values.ent_PushFast;
                        }
                        if (rotateCamera == 2)
                        {
                            tempEntity.x += Editor_Speed_Values.ent_PushFast;
                            if (tempEntity.skills[19] == 2)
                                searchEntity(tempEntity.skills[18], current_Map_Object).position.x += (decimal)Editor_Speed_Values.ent_PushFast;
                            if (tempEntity.skills[19] == 3)
                                searchTile(tempEntity.skills[18], current_Map_Object).position.x += (decimal)Editor_Speed_Values.ent_PushFast;
                        }
                        if (rotateCamera == 3)
                        {
                            tempEntity.y += Editor_Speed_Values.ent_PushFast;
                            if (tempEntity.skills[19] == 2)
                                searchEntity(tempEntity.skills[18], current_Map_Object).position.y += (decimal)Editor_Speed_Values.ent_PushFast;
                            if (tempEntity.skills[19] == 3)
                                searchTile(tempEntity.skills[18], current_Map_Object).position.y += (decimal)Editor_Speed_Values.ent_PushFast;
                        }
                    }
                    else
                        if (EngVar.key_cud && tempEntity != null && !EngVar.key_shiftr)
                        {
                            if (rotateCamera == 0)
                            {
                                tempEntity.x -= Editor_Speed_Values.ent_Push;
                                if (tempEntity.skills[19] == 2)
                                    searchEntity(tempEntity.skills[18], current_Map_Object).position.x -= (decimal)Editor_Speed_Values.ent_Push;
                                if (tempEntity.skills[19] == 3)
                                    searchTile(tempEntity.skills[18], current_Map_Object).position.x -= (decimal)Editor_Speed_Values.ent_Push;
                            }
                            if (rotateCamera == 1)
                            {
                                tempEntity.y -= Editor_Speed_Values.ent_Push;
                                if (tempEntity.skills[19] == 2)
                                    searchEntity(tempEntity.skills[18], current_Map_Object).position.y -= (decimal)Editor_Speed_Values.ent_Push;
                                if (tempEntity.skills[19] == 3)
                                    searchTile(tempEntity.skills[18], current_Map_Object).position.y -= (decimal)Editor_Speed_Values.ent_Push;
                            }
                            if (rotateCamera == 2)
                            {
                                tempEntity.x += Editor_Speed_Values.ent_Push;
                                if (tempEntity.skills[19] == 2)
                                    searchEntity(tempEntity.skills[18], current_Map_Object).position.x += (decimal)Editor_Speed_Values.ent_Push;
                                if (tempEntity.skills[19] == 3)
                                    searchTile(tempEntity.skills[18], current_Map_Object).position.x += (decimal)Editor_Speed_Values.ent_Push;
                            }
                            if (rotateCamera == 3)
                            {
                                tempEntity.y += Editor_Speed_Values.ent_Push;
                                if (tempEntity.skills[19] == 2)
                                    searchEntity(tempEntity.skills[18], current_Map_Object).position.y += (decimal)Editor_Speed_Values.ent_Push;
                                if (tempEntity.skills[19] == 3)
                                    searchTile(tempEntity.skills[18], current_Map_Object).position.y += (decimal)Editor_Speed_Values.ent_Push;
                            }
                        }

                    if (EngVar.key_cul && tempEntity != null && EngVar.key_shiftr)
                    {
                        if (rotateCamera == 0)
                        {
                            tempEntity.y += Editor_Speed_Values.ent_PushFast;
                            if (tempEntity.skills[19] == 2)
                                searchEntity(tempEntity.skills[18], current_Map_Object).position.y += (decimal)Editor_Speed_Values.ent_PushFast;
                            if (tempEntity.skills[19] == 3)
                                searchTile(tempEntity.skills[18], current_Map_Object).position.y += (decimal)Editor_Speed_Values.ent_PushFast;
                        }
                        if (rotateCamera == 1)
                        {
                            tempEntity.x -= Editor_Speed_Values.ent_PushFast;
                            if (tempEntity.skills[19] == 2)
                                searchEntity(tempEntity.skills[18], current_Map_Object).position.x -= (decimal)Editor_Speed_Values.ent_PushFast;
                            if (tempEntity.skills[19] == 3)
                                searchTile(tempEntity.skills[18], current_Map_Object).position.x -= (decimal)Editor_Speed_Values.ent_PushFast;
                        }
                        if (rotateCamera == 2)
                        {
                            tempEntity.y -= Editor_Speed_Values.ent_PushFast;
                            if (tempEntity.skills[19] == 2)
                                searchEntity(tempEntity.skills[18], current_Map_Object).position.y -= (decimal)Editor_Speed_Values.ent_PushFast;
                            if (tempEntity.skills[19] == 3)
                                searchTile(tempEntity.skills[18], current_Map_Object).position.y -= (decimal)Editor_Speed_Values.ent_PushFast;
                        }
                        if (rotateCamera == 3)
                        {
                            tempEntity.x += Editor_Speed_Values.ent_PushFast;
                            if (tempEntity.skills[19] == 2)
                                searchEntity(tempEntity.skills[18], current_Map_Object).position.x += (decimal)Editor_Speed_Values.ent_PushFast;
                            if (tempEntity.skills[19] == 3)
                                searchTile(tempEntity.skills[18], current_Map_Object).position.x += (decimal)Editor_Speed_Values.ent_PushFast;
                        }
                    }
                    else
                        if (EngVar.key_cul && tempEntity != null && !EngVar.key_shiftr)
                        {
                            if (rotateCamera == 0)
                            {
                                tempEntity.y += Editor_Speed_Values.ent_Push;
                                if (tempEntity.skills[19] == 2)
                                    searchEntity(tempEntity.skills[18], current_Map_Object).position.y += (decimal)Editor_Speed_Values.ent_Push;
                                if (tempEntity.skills[19] == 3)
                                    searchTile(tempEntity.skills[18], current_Map_Object).position.y += (decimal)Editor_Speed_Values.ent_Push;
                            }
                            if (rotateCamera == 1)
                            {
                                tempEntity.x -= Editor_Speed_Values.ent_Push;
                                if (tempEntity.skills[19] == 2)
                                    searchEntity(tempEntity.skills[18], current_Map_Object).position.x -= (decimal)Editor_Speed_Values.ent_Push;
                                if (tempEntity.skills[19] == 3)
                                    searchTile(tempEntity.skills[18], current_Map_Object).position.x -= (decimal)Editor_Speed_Values.ent_Push;
                            }
                            if (rotateCamera == 2)
                            {
                                tempEntity.y -= Editor_Speed_Values.ent_Push;
                                if (tempEntity.skills[19] == 2)
                                    searchEntity(tempEntity.skills[18], current_Map_Object).position.y -= (decimal)Editor_Speed_Values.ent_Push;
                                if (tempEntity.skills[19] == 3)
                                    searchTile(tempEntity.skills[18], current_Map_Object).position.y -= (decimal)Editor_Speed_Values.ent_Push;
                            }
                            if (rotateCamera == 3)
                            {
                                tempEntity.x += Editor_Speed_Values.ent_Push;
                                if (tempEntity.skills[19] == 2)
                                    searchEntity(tempEntity.skills[18], current_Map_Object).position.x += (decimal)Editor_Speed_Values.ent_Push;
                                if (tempEntity.skills[19] == 3)
                                    searchTile(tempEntity.skills[18], current_Map_Object).position.x += (decimal)Editor_Speed_Values.ent_Push;
                            }
                        }

                    if (EngVar.key_cur && tempEntity != null && EngVar.key_shiftr)
                    {
                        if (rotateCamera == 0)
                        {
                            tempEntity.y -= Editor_Speed_Values.ent_PushFast;
                            if (tempEntity.skills[19] == 2)
                                searchEntity(tempEntity.skills[18], current_Map_Object).position.y -= (decimal)Editor_Speed_Values.ent_PushFast;
                            if (tempEntity.skills[19] == 3)
                                searchTile(tempEntity.skills[18], current_Map_Object).position.y -= (decimal)Editor_Speed_Values.ent_PushFast;
                        }
                        if (rotateCamera == 1)
                        {
                            tempEntity.x += Editor_Speed_Values.ent_PushFast;
                            if (tempEntity.skills[19] == 2)
                                searchEntity(tempEntity.skills[18], current_Map_Object).position.x += (decimal)Editor_Speed_Values.ent_PushFast;
                            if (tempEntity.skills[19] == 3)
                                searchTile(tempEntity.skills[18], current_Map_Object).position.x += (decimal)Editor_Speed_Values.ent_PushFast;
                        }
                        if (rotateCamera == 2)
                        {
                            tempEntity.y += Editor_Speed_Values.ent_PushFast;
                            if (tempEntity.skills[19] == 2)
                                searchEntity(tempEntity.skills[18], current_Map_Object).position.y += (decimal)Editor_Speed_Values.ent_PushFast;
                            if (tempEntity.skills[19] == 3)
                                searchTile(tempEntity.skills[18], current_Map_Object).position.y += (decimal)Editor_Speed_Values.ent_PushFast;
                        }
                        if (rotateCamera == 3)
                        {
                            tempEntity.x -= Editor_Speed_Values.ent_PushFast;
                            if (tempEntity.skills[19] == 2)
                                searchEntity(tempEntity.skills[18], current_Map_Object).position.x -= (decimal)Editor_Speed_Values.ent_PushFast;
                            if (tempEntity.skills[19] == 3)
                                searchTile(tempEntity.skills[18], current_Map_Object).position.x -= (decimal)Editor_Speed_Values.ent_PushFast;
                        }
                    }
                    else
                        if (EngVar.key_cur && tempEntity != null && !EngVar.key_shiftr)
                        {
                            if (rotateCamera == 0)
                            {
                                tempEntity.y -= Editor_Speed_Values.ent_Push;
                                if (tempEntity.skills[19] == 2)
                                    searchEntity(tempEntity.skills[18], current_Map_Object).position.y -= (decimal)Editor_Speed_Values.ent_Push;
                                if (tempEntity.skills[19] == 3)
                                    searchTile(tempEntity.skills[18], current_Map_Object).position.y -= (decimal)Editor_Speed_Values.ent_Push;
                            }
                            if (rotateCamera == 1)
                            {
                                tempEntity.x += Editor_Speed_Values.ent_Push;
                                if (tempEntity.skills[19] == 2)
                                    searchEntity(tempEntity.skills[18], current_Map_Object).position.x += (decimal)Editor_Speed_Values.ent_Push;
                                if (tempEntity.skills[19] == 3)
                                    searchTile(tempEntity.skills[18], current_Map_Object).position.x += (decimal)Editor_Speed_Values.ent_Push;
                            }
                            if (rotateCamera == 2)
                            {
                                tempEntity.y += Editor_Speed_Values.ent_Push;
                                if (tempEntity.skills[19] == 2)
                                    searchEntity(tempEntity.skills[18], current_Map_Object).position.y += (decimal)Editor_Speed_Values.ent_Push;
                                if (tempEntity.skills[19] == 3)
                                    searchTile(tempEntity.skills[18], current_Map_Object).position.y += (decimal)Editor_Speed_Values.ent_Push;
                            }
                            if (rotateCamera == 3)
                            {
                                tempEntity.x -= Editor_Speed_Values.ent_Push;
                                if (tempEntity.skills[19] == 2)
                                    searchEntity(tempEntity.skills[18], current_Map_Object).position.x -= (decimal)Editor_Speed_Values.ent_Push;
                                if (tempEntity.skills[19] == 3)
                                    searchTile(tempEntity.skills[18], current_Map_Object).position.x -= (decimal)Editor_Speed_Values.ent_Push;
                            }
                        }

                    if (EngVar.key_r && tempEntity != null && EngVar.key_shiftl)
                    {
                        tempEntity.pan -= Editor_Speed_Values.ent_PanFast;
                        if (tempEntity.skills[19] == 2)
                        searchEntity(tempEntity.skills[18], current_Map_Object).pan -= Editor_Speed_Values.ent_PanFast;
                        if (tempEntity.skills[19] == 3)
                            searchTile(tempEntity.skills[18], current_Map_Object).pan -= Editor_Speed_Values.ent_PanFast;
                    }
                    else
                        if (EngVar.key_r && tempEntity != null && !EngVar.key_shiftl)
                        {
                            tempEntity.pan -= Editor_Speed_Values.ent_Pan;
                            if (tempEntity.skills[19] == 2)
                            searchEntity(tempEntity.skills[18], current_Map_Object).pan -= Editor_Speed_Values.ent_Pan;
                            if (tempEntity.skills[19] == 3)
                            searchTile(tempEntity.skills[18], current_Map_Object).pan -= Editor_Speed_Values.ent_Pan; 
                        }
                    if (EngVar.key_del && tempEntity != null) 
                        if(activateDelOption == true) 
                            if(readEntityMode == false) 
                            if(EngVar.mouse_right == false)
                        if (IntPtr.Equals(tempEntity.getIntPtr(), 0) == false)
                        {

                            if (tempEntity.skills[19] == 2 && blockMode == false)
                            {
                                for (int i = 0; i < current_Map_Object.entityList.Count; i++)
                                {
                                    if (current_Map_Object.entityList[i].id == tempEntity.skills[18])
                                    {
                                        //  Editor_Entity tempEditorEntity = new Editor_Entity((int)tempEntity.skills[18],tempEntity
                                        entityUndoList.Add(current_Map_Object.entityList[i]);
                                        entityUndoList[entityUndoList.Count - 1].marked = "Delete";
                                        entityUndo_button.BeginInvoke(new Action(() =>
                                         {
                                             entityUndo_button.Enabled = true;
                                         })
                                         );




                                        removeEntity(tempEntity.skills[18], current_Map_Object);
                                        tempEntity.INVISIBLE = true;
                                        tempEntity.ent_purge();
                                        yield return ScheduleMethod.waitForFrames(1);
                                        tempEntity.ent_remove();
                                        yield return ScheduleMethod.waitForFrames(1);

                                        Scheduler.AddEventVoidThreadSafe(resetTempEntity);

                                        selectedEntity.BeginInvoke(new Action(() =>
                                        {

                                            selectedEntity.Text = "NONE";
                                        })
                                        );

                                        entityLight_Groupbox.BeginInvoke(new Action(() =>
                                        {
                                            entityLight_Groupbox.Enabled = false;

                                        })
                                             );

                                        entityFlags_Group.BeginInvoke(new Action(() =>
                                        {
                                            entityFlags_Group.Enabled = false;

                                        })
                                             );

                                        entity_Scale.BeginInvoke(new Action(() =>
                                        {
                                            entity_Scale.Enabled = false;

                                        })
                                             );

                                        ent_Pan.BeginInvoke(new Action(() =>
                                        {
                                            ent_Pan.Enabled = false;

                                        })
                                             );

                                        entityMaxScale.BeginInvoke(new Action(() =>
                                        {
                                            entityMaxScale.Enabled = false;

                                        })
                                             );
                                        lightRange_checkBox.BeginInvoke(new Action(() =>
                                        {
                                            lightRange_checkBox.Enabled = false;
                                            lightRange_checkBox.Checked = false;
                                        })
                                       );

                                        changeOwnColor_checkBox.BeginInvoke(new Action(() =>
                                        {
                                            changeOwnColor_checkBox.Enabled = false;

                                        })
                                          );
                                        lightRange_GroupBox.BeginInvoke(new Action(() =>
                                        {
                                            lightRange_GroupBox.Enabled = false;

                                        })
                                          );
                                        color_GroupBox.BeginInvoke(new Action(() =>
                                        {
                                            color_GroupBox.Enabled = false;

                                        })
                                         );
                                        activateDelOption = false;
                                    }
                                }
                                yield return ScheduleMethod.wait(1);

                            }
                            else
                                if (tempEntity.skills[19] == 3 && blockMode == true && tempEntity != null && activateDelOption == true && readEntityMode == false && EngVar.mouse_right == false)
                                    if (IntPtr.Equals(tempEntity.getIntPtr(), 0) == false)
                                    {
                                        for (int x = 0; x < current_Map_Object.tileList.Count; x++)
                                        {
                                            if (current_Map_Object.tileList[x].id == (tempEntity.skills[18]))
                                            {
                                                blockUndoList.Add(current_Map_Object.tileList[x]);
                                                blockUndoList[blockUndoList.Count-1].marked = "Delete";
                                                undo_button.BeginInvoke(new Action(() =>
                                                {
                                                    undo_button.Enabled = true;
                                                })
                                                );
                                                current_Map_Object.removeExistingTile(Convert.ToInt32(tempEntity.skills[18]));
                                                tempEntity.INVISIBLE = true;
                                                tempEntity.ent_purge();
                                                yield return ScheduleMethod.waitForFrames(1);
                                                tempEntity.ent_remove();
                                                yield return ScheduleMethod.waitForFrames(1);
                                                Scheduler.AddEventVoidThreadSafe(resetTempEntity);
                                                x = current_Map_Object.tileList.Count;
                                                activateDelOption = false;
                                                yield return ScheduleMethod.wait(1);
                                            }
                                        }

                                    }
                            yield return ScheduleMethod.wait(10);
                        }
                }
                else if (flyingEntity != null && Place_Mode_checkBox.Checked == true)
                {
                    if (EngVar.key_plus && flyingEntity != null && EngVar.key_shiftr)
                        flyingEntity.z += Editor_Speed_Values.ent_LiftFast;
                    else
                        if (EngVar.key_plus && flyingEntity != null)
                            flyingEntity.z += Editor_Speed_Values.ent_Lift;
                    if (EngVar.key_slash && flyingEntity != null && EngVar.key_shiftr)
                        flyingEntity.z -= Editor_Speed_Values.ent_LiftFast;
                    else
                        if (EngVar.key_slash && flyingEntity != null)
                            flyingEntity.z -= Editor_Speed_Values.ent_Lift;
                    if (EngVar.key_cuu && flyingEntity != null && EngVar.key_shiftr)
                        flyingEntity.x += Editor_Speed_Values.ent_PushFast;
                    else
                        if (EngVar.key_cuu && flyingEntity != null)
                            flyingEntity.x += Editor_Speed_Values.ent_Push;
                    if (EngVar.key_cud && flyingEntity != null && EngVar.key_shiftr)
                        flyingEntity.x -= Editor_Speed_Values.ent_PushFast;
                    else
                        if (EngVar.key_cud && flyingEntity != null)
                            flyingEntity.x -= Editor_Speed_Values.ent_Push;
                    if (EngVar.key_cul && flyingEntity != null && EngVar.key_shiftr)
                        flyingEntity.y += Editor_Speed_Values.ent_PushFast;
                    else
                        if (EngVar.key_cul && flyingEntity != null)
                            flyingEntity.y += Editor_Speed_Values.ent_Push;
                    if (EngVar.key_cur && flyingEntity != null && EngVar.key_shiftr)
                        flyingEntity.y -= Editor_Speed_Values.ent_PushFast;
                    else
                        if (EngVar.key_cur && flyingEntity != null)
                            flyingEntity.y -= Editor_Speed_Values.ent_Push;
                    if (EngVar.key_r && flyingEntity != null && EngVar.key_shiftr)
                        entity_Rotation -= Editor_Speed_Values.ent_PanFast;
                    else
                        if (EngVar.key_r && flyingEntity != null)
                            entity_Rotation -= Editor_Speed_Values.ent_Pan;
                    if (EngVar.key_r && flyingEntity != null && EngVar.key_shiftr)
                        flyingEntity.pan -= Editor_Speed_Values.ent_PanFast;
                    else
                        if (EngVar.key_r && flyingEntity != null)
                            flyingEntity.pan -= Editor_Speed_Values.ent_Pan;
                }
                #endregion

                #region Compile Map to WMB
                if (saveNow == true)
                {
                    foreach (String map_ in allMaps)
                    {
                        if (File.Exists(yed_Ptr.returnPath() + "\\Maps\\temp_" + map_ + ".ymp"))
                        {
                           ymap transferMap = DeserializeXmlToYMAP(yed_Ptr.returnPath() + "\\Maps\\temp_" + map_ + ".ymp");
                           SerializeYMAPToXML(transferMap, yed_Ptr.returnPath() + "\\Maps\\" + map_ + ".ymp");
                           File.Delete(yed_Ptr.returnPath() + "\\Maps\\temp_" + map_ + ".ymp");
                        }
                    }
                    if(current_Map_Object != null)
                    if (File.Exists(yed_Ptr.returnPath() + "\\Maps\\"+current_Map_Object.mapDesignation+".ymp"))
                    {
                        ymap transferMap = new ymap();
                        transferMap.Editor_Object_Save = current_Map_Object;
                        SerializeYMAPToXML(transferMap, yed_Ptr.returnPath() + "\\Maps\\" + current_Map_Object.mapDesignation+ ".ymp");
                    }
                    yedMainObject.Editor_Options_Save = YRPGMap_Options;
                    yedMainObject.Editor_Speed_Values_Save = Editor_Speed_Values;
                    yedMainObject.YMAP_LIST = allMaps;
                    SerializeYEDToXML(yedMainObject, yed_Ptr.returnPath() + "\\Maps\\" + justProjectTitle() + ".yed");
                    writeTextureScript();
                    saveOptions();
                    saveNow = false;
                 
                }
                #endregion

                #region Load Map WMB
                if (loadNow == true)
                {
                    blockUndoList.Clear();
                    undo_button.BeginInvoke(new Action(() =>
                    {
                        undo_button.Enabled = false;
                    })
                    );
                    PlaceMode_GroupBox.BeginInvoke(new Action(() =>{
                        PlaceMode_GroupBox.Enabled = true;  
                    })
                    );
                    loadNow = false;
                    initializedMap = true;
                    if (current_Map_Object != null)
                        if (current_Map_Object.mapDesignation != null)
                        if(!current_Map_Object.mapDesignation.Equals(""))
                    {
                            ymap tempMap = new ymap();
                            tempMap.Editor_Object_Save = current_Map_Object;
                            SerializeYMAPToXML(tempMap, yed_Ptr.returnPath() + "\\Maps\\temp_" + tempMap.Editor_Object_Save.mapDesignation + ".ymp");
                    }
                    current_Map_Object = null;
                
                        mapTree.BeginInvoke(new Action(() =>
                        {
                            if (mapTree.SelectedNode.Text.Contains(".ymp"))
                             
                                {
                                    if (File.Exists(yed_Ptr.returnPath() + "\\Maps\\temp_" + mapTree.SelectedNode.Text.Substring(0, mapTree.SelectedNode.Text.IndexOf(".")) + ".ymp"))
                                    {
                                        ymap tempMapLoad = DeserializeXmlToYMAP(yed_Ptr.returnPath() + "\\Maps\\temp_" + mapTree.SelectedNode.Text.Substring(0, mapTree.SelectedNode.Text.IndexOf(".")) + ".ymp");

                                        current_Map_Object =tempMapLoad.Editor_Object_Save;
                                        Scheduler.AddEventVoidThreadSafe(createNewMap);
                                        if (checkEntitiesForHeroes == true)
                                        {
                                            Scheduler.AddEventVoid(checkEntForPlayerFlag);
                                            checkEntitiesForHeroes = false;
                                        }
                                    }
                                    else if (File.Exists(yed_Ptr.returnPath() + "\\Maps\\" + mapTree.SelectedNode.Text.Substring(0, mapTree.SelectedNode.Text.IndexOf(".")) + ".ymp"))
                                    {
                                        ymap tempMapLoad = DeserializeXmlToYMAP(yed_Ptr.returnPath() + "\\Maps\\" + mapTree.SelectedNode.Text.Substring(0, mapTree.SelectedNode.Text.IndexOf(".")) + ".ymp");
                                        current_Map_Object = tempMapLoad.Editor_Object_Save;
                                  
                                    Scheduler.AddEventVoidThreadSafe(createNewMap);
                                    if (checkEntitiesForHeroes == true)
                                    {
                                        Scheduler.AddEventVoid(checkEntForPlayerFlag);
                                        checkEntitiesForHeroes = false;
                              
                                    }
                                    }
                                }

                        })
                        );
                        mapTree.BeginInvoke(new Action(() =>{
                            mapTree.Enabled = true;  
                        })
                        );
                }
                #endregion
                yield return ScheduleMethod.wait(1);
            }
            yield return ScheduleMethod.wait(1);
        }
        #endregion

        private IEnumerable<ScheduleMethod> deselectEntityMethod(){

         if (tempEntity != null)
                                    {
                                        if (tempEntity.ent_getskin(2) != null && tempEntity.skills[19] == 3 && tempEntity.skills[16] == 0) tempEntity.material = abc;
                                        if (tempEntity.skills[19] == 2 && tempEntity.skills[16] == 0) tempEntity.material = MATERIAL.mtl_create();
                                        else if (tempEntity.skills[19] == 2 && tempEntity.skills[16] == 1) tempEntity.material = gras_Mat;
             tempEntity.skills[22] = 0;
                                    }
         yield return ScheduleMethod.wait(1);
    }

        public Editor_Entity searchEntity(double id, Editor_Object editor_Object)
        {
            foreach (Editor_Entity ent_ in editor_Object.entityList)
            {
                if (id == ent_.id)
                {
                    return ent_;
                }
            }
            return null;
        }
        public Editor_Tile searchTile(double id, Editor_Object editor_Object)
        {
            foreach (Editor_Tile ent_ in editor_Object.tileList)
            {
                if (id == ent_.id)
                {
                    return ent_;
                }
            }
            return null;
        }
        public void removeEntity(double id, Editor_Object editor_Object)
        {
            for (int i = 0; i < editor_Object.entityList.Count; i++)
            {
                if (id == editor_Object.entityList[i].id)
                {
                    editor_Object.entityList.RemoveAt(i);
                    return;
                }
            }
        }

        private IEnumerable<ScheduleMethod> cleanTextureChache()
        {
            EngVar.you = ENTITY.ent_next(null);
            while (EngVar.you != null)
            {
                if (EngVar.you.CLIP1 == true)
                {
                    EngVar.you.INVISIBLE = true;
                    EngVar.you.ent_purge();
                }
                else
                {
                    EngVar.you.INVISIBLE = false;
                }
                yield return ScheduleMethod.wait(1);
            }
            ScheduleMethod.executeEventVoid(cleanTextureChache);
        }
        bool fillEmptySpace_ON = false;
        ENTITY tileEntity = null;
        public void fillEmptySpace(double x, double y)
        {
            if (EngVar.num_entities > 9000) return;
            ENTITY.c_ignore(2, 3, 0);
            if (fillEntity_Name != null)
                if (!fillEntity_Name.Equals(""))
                    if (ENTITY.c_trace(new Vector(x * 128, y * 128, 10000), new Vector(x * 128, y * 128, fillEntity_Z - 0.3), Flags.IGNORE_FLAG2) > 0)
                    {
                        if (EngVar.you.skills[19] == 3 || EngVar.you.skills[19] == 1)
                        {
                            if (EngVar.mouse_ent.str_for_entname().Equals(fillEntity_Name) && (EngVar.hit.z >= fillEntity_Z - 0.2 && EngVar.hit.z <= fillEntity_Z + 0.2))
                            {
                                try
                                {
                                    fillEmptySpace_ON = true;
                                    if (CubeTile.Checked == true)
                                    {
                                            tileType = 1;
                                            tileEntity = ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Tiles\\Tile.mdl", new Vector(x * 128, y * 128, EngVar.target.z), block_Mode);
                                    }
                                    else
                                        if (flatCubeTile.Checked == true)
                                        {
                                            tileType = 2;
                                            ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Tiles\\TileFlat.mdl", new Vector(x * 128, y * 128, EngVar.target.z), block_Mode);
                                        }
                                        else
                                            if (CylinderTile.Checked == true)
                                            {
                                                tileType = 3;
                                                ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Tiles\\Cylinder.wmb", new Vector(x * 128, y * 128, EngVar.target.z), block_Mode);
                                            }
                                            else
                                                if (flatCylinderTile.Checked == true)
                                                {
                                                    tileType = 4;
                                                    ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Tiles\\FlatCylinder.wmb", new Vector(x * 128, y * 128, EngVar.target.z), block_Mode);
                                                }

                                }
                                catch (NullReferenceException E)
                                {

                                }
                            }
                            else
                            {
                                fillEmptySpace_ON = false;
                                return;
                            }
                        }
                        else
                        {
                            fillEmptySpace_ON = false;
                            return;
                        }
                        fillEmptySpace((x + 1.00), y);
                        fillEmptySpace((x - 1.00), y);
                        fillEmptySpace(x, (y + 1.00));
                        fillEmptySpace(x, (y - 1.00));
                    }
        }
        bool activateDelOption = false;
        bool startWithCleaningService = true;
        #region Editor Loop
        public IEnumerable<ScheduleMethod> editor_loop()
        {

            Vector mouse_move = new Vector();
            while (EngFun.engine_frame() == 1)
            {
                yield return ScheduleMethod.wait(1);

                mouse_move = new Vector();
                #region Model On Ground
                if (flyingEntity != null && blockMode == false && modelCreate == false && Place_Mode_checkBox.Checked == true)
                    if ((EngVar.mouse_cursor.x < 1 || EngVar.mouse_cursor.y < 1) || ((EngVar.mouse_cursor.x >= EngVar.screen_size.x) || (EngVar.mouse_cursor.y >= EngVar.screen_size.y)))
                    {
                        EngVar.you = flyingEntity;
                        mouse_move.vec_set(new Vector(EngVar.screen_size.x / 2, EngVar.screen_size.y / 2, 0));
                        mouse_move.vec_for_screen(EngVar.camera);
                        if (ignoreEntities.Checked == true)
                        {
                            ENTITY.c_ignore(2, 3, 0);
                            ENTITY.c_trace(EngVar.camera.xyz, mouse_move, Flags.IGNORE_YOU);
                        }
                        else
                        {
                            ENTITY.c_ignore(3, 0);
                            ENTITY.c_trace(EngVar.camera.xyz, mouse_move, Flags.IGNORE_YOU | Flags.IGNORE_FLAG2);
                        }
                        flyingEntity.xyz.vec_set(EngVar.target);
                        flyingEntity.pan = entity_Rotation;
                    }
                    else
                        if ((EngVar.mouse_cursor.x > -1 || EngVar.mouse_cursor.y > -1) && (EngVar.mouse_cursor.x < EngVar.screen_size.x && EngVar.mouse_cursor.y < EngVar.screen_size.y))
                        {

                            if (tempEntityFromBlockMode == true)
                            {
                                Scheduler.AddEventVoid(resetTempEntity);
                                tempEntityFromBlockMode = false;
                            }

                            yield return ScheduleMethod.wait(1);
                            mouse_move.vec_set(EngVar.mouse_dir3d);
                            mouse_move.vec_normalize(4000); 
                            mouse_move.vec_add(EngVar.camera.xyz); 

                            if (ignoreEntities.Checked == true)
                            {
                                ENTITY.c_ignore(2, 3, 0);
                                ENTITY.c_trace(EngVar.camera.xyz, mouse_move, Flags.IGNORE_MODELS);
                            }
                            else
                            {
                                ENTITY.c_ignore(3, 0);
                                ENTITY.c_trace(EngVar.camera.xyz, mouse_move, Flags.IGNORE_FLAG2 | Flags.IGNORE_YOU);
                            }
                            flyingEntity.xyz.vec_set(EngVar.target);
                            flyingEntity.pan = entity_Rotation;
                        }
                #endregion

                #region Execute Select Entity Handle
                try
                {
                    if (Place_Mode_checkBox.Checked == false)
                        if (EngVar.key_shiftl == false && EngVar.mouse_right && EngVar.mouse_ent != null && readEntityMode == false)
                            if ((IntPtr.Equals(EngVar.mouse_ent.getIntPtr(), IntPtr.Zero) == false))
                            {
                                if (EngVar.mouse_ent.skills[19] == 2 || EngVar.mouse_ent.skills[19] == 3)
                                {
                                    mouse_click.vec_set(EngVar.mouse_dir3d);
                                    mouse_click.vec_normalize(6000); 
                                    mouse_click.vec_add(EngVar.camera.xyz); 

                                    ENTITY.c_trace(EngVar.camera.xyz, mouse_click, Flags.IGNORE_FLAG2);
                                    readEntityMode = true;
                                    tempEntity = EngVar.hit.entity;
                               
                                    if (tempEntity != null)
                                    Scheduler.AddEventVoidThreadSafe(saveEntityHandle);
                                }
                            }
                    if (EngVar.key_shiftl && EngVar.key_del && selectedEntity.Text != "NONE" && readEntityMode == false)
                        if ((IntPtr.Equals(EngVar.mouse_ent.getIntPtr(), IntPtr.Zero) == false))
                            if (EngVar.mouse_ent.skills[19] == 2 || EngVar.mouse_ent.skills[19] == 3)
                            {
                                int y = 0;
                                EngVar.you = ENTITY.ent_next(null);
                                while (EngVar.you != null)
                                {
                                    ENTITY tempEntity_ = null;
                                    if (EngVar.you.skills[19] == 2)
                                    {
                                        if (selectedEntity.Text == EngVar.you.str_for_entfile())
                                        {
                                            tempEntity_ = EngVar.you;
                                        }
                                    }
                                    EngVar.you = ENTITY.ent_next(EngVar.you);
                                    if (tempEntity_ != null)
                                    {
                                        tempEntity_.INVISIBLE = true;
                                        tempEntity_.ent_purge();
                                        tempEntity_.ent_remove();
                                    }
                                }
                            }
                }
                catch (NullReferenceException ea)
                {

                }
                #endregion


                #region Key Actions
                if (EngVar.key_0)
                {
                    Vector positionTile = new Vector();
                    mouse_click.vec_set(EngVar.mouse_dir3d); 
                    mouse_click.vec_normalize(4000);
                    mouse_click.vec_add(EngVar.camera.xyz); 
                    ENTITY.c_trace(EngVar.camera.xyz, mouse_click, Flags.IGNORE_MODELS | Flags.ENABLE_FRAME);
                    double tileX = Math.Round((EngVar.target.x / 128), 0, MidpointRounding.AwayFromZero);
                    double tileY = Math.Round((EngVar.target.x / 128), 0, MidpointRounding.AwayFromZero);
                    fillEmptySpace(tileX, tileY);
                    yield return ScheduleMethod.wait(20);


                }

                if (EngVar.key_9)
                {
                    EngVar.mouse_ent.ent_cloneskin();
                    EngVar.mouse_ent.ent_setskin(Texture, 1);
                }

                if (EngVar.key_8){}
                if (EngVar.key_w == true && EngVar.key_shiftl)
                    EngVar.camera.x += Editor_Speed_Values.map_MoveFast;
                else
                    if (EngVar.key_w == true)
                        EngVar.camera.x += Editor_Speed_Values.map_Move;

                if (EngVar.key_home == true && EngVar.key_shiftl && EngVar.camera.tilt < 90)
                {
                    EngVar.camera.tilt += Editor_Speed_Values.map_MoveFast;
                    if (EngVar.camera.tilt > 90) EngVar.camera.tilt = 90;
                }
                else
                    if (EngVar.key_home == true && EngVar.camera.tilt < 90)
                    {
                        EngVar.camera.tilt += Editor_Speed_Values.map_Move;
                        if (EngVar.camera.tilt > 90) EngVar.camera.tilt = 90;
                    }
                if (EngVar.key_end == true && EngVar.key_shiftl && EngVar.camera.tilt > -91)
                {
                    EngVar.camera.tilt -= Editor_Speed_Values.map_MoveFast;
                    if (EngVar.camera.tilt < -90) EngVar.camera.tilt = -90;
                }
                else
                    if (EngVar.key_end == true && EngVar.camera.tilt > -91)
                    {
                        EngVar.camera.tilt -= Editor_Speed_Values.map_Move;
                        if (EngVar.camera.tilt < -90) EngVar.camera.tilt = -90;
                    }
                if (EngVar.key_s == true && EngVar.key_shiftl)
                    EngVar.camera.x -= Editor_Speed_Values.map_MoveFast;
                else
                    if (EngVar.key_s == true)
                        EngVar.camera.x -= Editor_Speed_Values.map_Move;
                if (EngVar.key_a == true && EngVar.key_shiftl)
                    EngVar.camera.y += Editor_Speed_Values.map_MoveFast;
                else
                    if (EngVar.key_a == true)
                        EngVar.camera.y += Editor_Speed_Values.map_Move;
                if (EngVar.key_d == true && EngVar.key_shiftl)
                    EngVar.camera.y -= Editor_Speed_Values.map_MoveFast;
                else
                    if (EngVar.key_d == true)
                        EngVar.camera.y -= Editor_Speed_Values.map_Move;
                if (EngVar.key_pgdn == true && EngVar.key_shiftr)
                    EngVar.camera.z -= Editor_Speed_Values.map_LiftFast;
                else
                    if (EngVar.key_pgdn == true)
                        EngVar.camera.z -= Editor_Speed_Values.map_Lift;
                if (EngVar.key_pgup == true && EngVar.key_shiftr)
                    EngVar.camera.z += Editor_Speed_Values.map_LiftFast;
                else
                    if (EngVar.key_pgup == true)
                        EngVar.camera.z += Editor_Speed_Values.map_Lift;
                if (EngVar.key_pgup == true && EngVar.key_shiftr)
                    EngVar.camera.z += Editor_Speed_Values.map_LiftFast;
                else
                    if (EngVar.key_pgup == true)
                        EngVar.camera.z += Editor_Speed_Values.map_Lift;
                if (EngVar.mickey.z != 0)
                {
                    EngVar.camera.z += EngVar.mickey.z;
                }
                if (tempEntity != null && Place_Mode_checkBox.Checked == false)
                {
                    if (EngVar.key_plus && tempEntity != null && EngVar.key_shiftr)
                        tempEntity.z += Editor_Speed_Values.ent_LiftFast;
                    else
                        if (EngVar.key_plus && tempEntity != null)
                            tempEntity.z += Editor_Speed_Values.ent_Lift;

                    if (EngVar.key_slash && tempEntity != null && EngVar.key_shiftr)
                        tempEntity.z -= Editor_Speed_Values.ent_LiftFast;
                    else
                        if (EngVar.key_slash && tempEntity != null)
                            tempEntity.z -= Editor_Speed_Values.ent_Lift;


                    if (EngVar.key_cuu && tempEntity != null && EngVar.key_shiftr)
                        tempEntity.x += Editor_Speed_Values.ent_PushFast;
                    else
                        if (EngVar.key_cuu && tempEntity != null)
                            tempEntity.x += Editor_Speed_Values.ent_Push;

                    if (EngVar.key_cud && tempEntity != null && EngVar.key_shiftr)
                        tempEntity.x -= Editor_Speed_Values.ent_PushFast;
                    else
                        if (EngVar.key_cud && tempEntity != null)
                            tempEntity.x -= Editor_Speed_Values.ent_Push;


                    if (EngVar.key_cul && tempEntity != null && EngVar.key_shiftr)
                        tempEntity.y += Editor_Speed_Values.ent_PushFast;
                    else
                        if (EngVar.key_cul && tempEntity != null)
                            tempEntity.y += Editor_Speed_Values.ent_Push;


                    if (EngVar.key_cur && tempEntity != null && EngVar.key_shiftr)
                        tempEntity.y -= Editor_Speed_Values.ent_PushFast;
                    else
                        if (EngVar.key_cur && tempEntity != null)
                            tempEntity.y -= Editor_Speed_Values.ent_Push;


                    if (EngVar.key_r && tempEntity != null && EngVar.key_shiftl)
                        tempEntity.pan -= Editor_Speed_Values.ent_PanFast;
                    else
                        if (EngVar.key_r && tempEntity != null)
                            tempEntity.pan -= Editor_Speed_Values.ent_Pan;


                    if (EngVar.key_del && tempEntity != null && activateDelOption == true && readEntityMode == false && EngVar.mouse_right == false)
                        if (IntPtr.Equals(tempEntity.getIntPtr(), 0) == false)
                        {

                            if (tempEntity.skills[19] == 2 && blockMode == false)
                            {
                                tempEntity.INVISIBLE = true;
                                tempEntity.ent_purge();
                                yield return ScheduleMethod.waitForFrames(1);
                                tempEntity.ent_remove();
                                yield return ScheduleMethod.waitForFrames(1);

                                Scheduler.AddEventVoidThreadSafe(resetTempEntity);

                                selectedEntity.BeginInvoke(new Action(() =>
                                {

                                    selectedEntity.Text = "NONE";
                                })
                                );


                                entityLight_Groupbox.BeginInvoke(new Action(() =>
                                {
                                    entityLight_Groupbox.Enabled = false;

                                })
                                     );

                                entityFlags_Group.BeginInvoke(new Action(() =>
                                {
                                    entityFlags_Group.Enabled = false;

                                })
                                     );

                                entity_Scale.BeginInvoke(new Action(() =>
                                {
                                    entity_Scale.Enabled = false;

                                })
                                     );

                                ent_Pan.BeginInvoke(new Action(() =>
                                {
                                    ent_Pan.Enabled = false;

                                })
                                     );

                                entityMaxScale.BeginInvoke(new Action(() =>
                                {
                                    entityMaxScale.Enabled = false;

                                })
                                     );
                                lightRange_checkBox.BeginInvoke(new Action(() =>
                               {
                                   lightRange_checkBox.Enabled = false;
                                   lightRange_checkBox.Checked = false;
                               })
                               );

                                changeOwnColor_checkBox.BeginInvoke(new Action(() =>
                                {
                                    changeOwnColor_checkBox.Enabled = false;

                                })
                                  );
                                lightRange_GroupBox.BeginInvoke(new Action(() =>
                                {
                                    lightRange_GroupBox.Enabled = false;

                                })
                                  );
                                color_GroupBox.BeginInvoke(new Action(() =>
                                {
                                    color_GroupBox.Enabled = false;

                                })
                                 );
                                activateDelOption = false;

                                yield return ScheduleMethod.wait(10);

                            }
                            else
                                if (tempEntity.skills[19] == 3 && blockMode == true && tempEntity != null && activateDelOption == true && readEntityMode == false && EngVar.mouse_right == false)
                                    if (IntPtr.Equals(tempEntity.getIntPtr(), 0) == false)
                                    {
                                        for (int x = 0; x < current_Map_Object.tileList.Count; x++)
                                        {
                                            if (current_Map_Object.tileList[x].id == (tempEntity.skills[18]))
                                            {
                                                current_Map_Object.removeExistingTile(Convert.ToInt32(tempEntity.skills[18]));
                                                tempEntity.INVISIBLE = true;
                                                tempEntity.ent_purge();
                                                yield return ScheduleMethod.waitForFrames(1);
                                                tempEntity.ent_remove();
                                                yield return ScheduleMethod.waitForFrames(1);
                                                Scheduler.AddEventVoidThreadSafe(resetTempEntity);
                                                x = current_Map_Object.tileList.Count;
                                                activateDelOption = false;
                                                yield return ScheduleMethod.wait(1);
                                            }
                                        }

                                    }
                            yield return ScheduleMethod.wait(10);
                        }
                }
                else if (flyingEntity != null && Place_Mode_checkBox.Checked == true)
                {
                    if (EngVar.key_plus && flyingEntity != null && EngVar.key_shiftr)
                        flyingEntity.z += Editor_Speed_Values.ent_LiftFast;
                    else
                        if (EngVar.key_plus && flyingEntity != null)
                            flyingEntity.z += Editor_Speed_Values.ent_Lift;

                    if (EngVar.key_slash && flyingEntity != null && EngVar.key_shiftr)
                        flyingEntity.z -= Editor_Speed_Values.ent_LiftFast;
                    else
                        if (EngVar.key_slash && flyingEntity != null)
                            flyingEntity.z -= Editor_Speed_Values.ent_Lift;


                    if (EngVar.key_cuu && flyingEntity != null && EngVar.key_shiftr)
                        flyingEntity.x += Editor_Speed_Values.ent_PushFast;
                    else
                        if (EngVar.key_cuu && flyingEntity != null)
                            flyingEntity.x += Editor_Speed_Values.ent_Push;

                    if (EngVar.key_cud && flyingEntity != null && EngVar.key_shiftr)
                        flyingEntity.x -= Editor_Speed_Values.ent_PushFast;
                    else
                        if (EngVar.key_cud && flyingEntity != null)
                            flyingEntity.x -= Editor_Speed_Values.ent_Push;


                    if (EngVar.key_cul && flyingEntity != null && EngVar.key_shiftr)
                        flyingEntity.y += Editor_Speed_Values.ent_PushFast;
                    else
                        if (EngVar.key_cul && flyingEntity != null)
                            flyingEntity.y += Editor_Speed_Values.ent_Push;


                    if (EngVar.key_cur && flyingEntity != null && EngVar.key_shiftr)
                        flyingEntity.y -= Editor_Speed_Values.ent_PushFast;
                    else
                        if (EngVar.key_cur && flyingEntity != null)
                            flyingEntity.y -= Editor_Speed_Values.ent_Push;

                    if (EngVar.key_r && flyingEntity != null && EngVar.key_shiftr)
                        entity_Rotation -= Editor_Speed_Values.ent_PanFast;
                    else
                        if (EngVar.key_r && flyingEntity != null)
                            entity_Rotation -= Editor_Speed_Values.ent_Pan;


                    if (EngVar.key_r && flyingEntity != null && EngVar.key_shiftr)
                        flyingEntity.pan -= Editor_Speed_Values.ent_PanFast;
                    else
                        if (EngVar.key_r && flyingEntity != null)
                            flyingEntity.pan -= Editor_Speed_Values.ent_Pan;


                }
                #endregion

                #region Compile Map to WMB
                if (saveNow == true)
                {
                }
                #endregion

                #region Load Map WMB
                if (loadNow == true)
                {
                    initializedMap = true;
                    if (File.Exists(yed_Ptr.returnPath() + "\\Maps\\" + justProjectTitle() + ".ymp") == true)
                    {
                    }
                    Scheduler.AddEventVoidThreadSafe(createNewMap);
                    loadNow = false;
                }

                if (checkEntitiesForHeroes == true)
                {
                    Scheduler.AddEventVoid(checkEntForPlayerFlag);
                    checkEntitiesForHeroes = false;
                    yield return ScheduleMethod.wait(1);
                }
                #endregion
                yield return ScheduleMethod.wait(1);
            }

            EngFun.engine_close();
            yield break;
        }
        #endregion

        private IEnumerable<ScheduleMethod> loadEmptyLevel()
        {
            EngVar.you = ENTITY.ent_next(null);
            EngFun.level_mark();
            while (EngVar.you != null)
            {
                EngVar.you.INVISIBLE = true;
                EngVar.you.ent_purge();
                EngVar.you.ent_remove();
                EngVar.you = ENTITY.ent_next(EngVar.you);

            }
            EngFun.level_free();
            yield return ScheduleMethod.wait(5);
        }

        public IEnumerable<ScheduleMethod> loadSavedLevel()
        {
            Scheduler.AddEventVoid(createNewMap);

            yield return ScheduleMethod.wait(1);


        }
        public void saveTempTile()
        {
            if (tempTile_YRPGObject != null)
                for (int i = 0; i < current_Map_Object.tileList.Count; i++)
                {
                    if (current_Map_Object.tileList[i].id == tempTile_YRPGObject.id)
                    {
                        current_Map_Object.tileList[i] = tempTile_YRPGObject;
                    }
                }

        }
        public void saveTempEntity()
        {
            if (tempEntity_YRPGObject != null)
                for (int i = 0; i < current_Map_Object.entityList.Count; i++)
                {
                    if (current_Map_Object.entityList[i].id == tempEntity_YRPGObject.id)
                    {
                        current_Map_Object.entityList[i] = tempEntity_YRPGObject;
                    }
                }

        }
        public Editor_Entity tempEntity_YRPGObject = null;
        public Editor_Tile tempTile_YRPGObject = null;
        #region SelectEntityHandle
        public ENTITY tempEntity;
        bool readEntityMode = false;
        public static Boolean validEntity = false;
        private delegate void saveEntityHndl();

        IEnumerable<ScheduleMethod> saveEntityHandle()
        {
            tempEntity.material = selectEntityPicture;
            tempEntity.skills[22] = 1;
                    if (blockMode == true) tempEntityFromBlockMode = true;


                    selectedEntity.BeginInvoke(new Action(() =>
                    {
                        selectedEntity.Text = EngVar.mouse_ent.str_for_entfile();
                    })
                           );

                    if (tempEntity.OVERLAY == true)
                        entityOverlay.BeginInvoke(new Action(() =>
                      {
                          entityOverlay.Checked = true;
                      })
                      );
                    else if (tempEntity.OVERLAY == false)
                        entityOverlay.BeginInvoke(new Action(() =>
                        {
                            entityOverlay.Checked = false;
                        })
                                     );
                    if (tempEntity.TRANSLUCENT == true)
                        entityTranslucent.BeginInvoke(new Action(() =>
                        {
                            entityTranslucent.Checked = true;
                        })
                        );
                    else if (tempEntity.TRANSLUCENT == false)
                        entityTranslucent.BeginInvoke(new Action(() =>
                        {
                            entityTranslucent.Checked = false;
                        })
                  );
                    if (tempEntity.PASSABLE == true)
                        entityPassable.BeginInvoke(new Action(() =>
                        {
                            entityPassable.Checked = true;
                        })
                  );
                    else if (tempEntity.PASSABLE == false)
                        entityPassable.BeginInvoke(new Action(() =>
                        {
                            entityPassable.Checked = false;
                        })
                 );

                    if (tempEntity.BRIGHT == true)
                        entityBright.BeginInvoke(new Action(() =>
                       {
                           entityBright.Checked = true;
                       })
                 );
                    else if (tempEntity.BRIGHT == false)
                        entityBright.BeginInvoke(new Action(() =>
                        {
                            entityBright.Checked = false;
                        })
                 );
                    if (tempEntity.SHADOW == true)
                        entityShadow.BeginInvoke(new Action(() =>
                        {
                            entityShadow.Checked = true;
                        })
                );
                    else if (tempEntity.SHADOW == false)
                        entityShadow.BeginInvoke(new Action(() =>
                        {
                            entityShadow.Checked = false;
                        })
                );
                    if (tempEntity.UNLIT == true)
                        ent_Unlit_CheckBox.BeginInvoke(new Action(() =>
                        {
                            ent_Unlit_CheckBox.Checked = true;
                        })
                );
                    else if (tempEntity.UNLIT == false)
                        ent_Unlit_CheckBox.BeginInvoke(new Action(() =>
                        {
                            ent_Unlit_CheckBox.Checked = false;
                        })
                );
                    if (tempEntity.skills[17] == 1)
                    {

                        entity_Player.BeginInvoke(new Action(() =>
                        {
                            entity_Player.Checked = true;
                        })
                );
                        whichEventForMapEditor.BeginInvoke(new Action(() =>
                        {
                            whichEventForMapEditor.Enabled = false;
                        })
                );

                    }
                    else if (tempEntity.skills[17] == 0)
                    {
                        entity_Player.BeginInvoke(new Action(() =>
                        {
                            entity_Player.Checked = false;
                        })
               );
                        whichEventForMapEditor.BeginInvoke(new Action(() =>
                        {
                            whichEventForMapEditor.Enabled = true;
                        })
                );
                    }

                    if (tempEntity.skills[14] == 1)
                    {

                        entityInvisible_CheckBox.BeginInvoke(new Action(() =>
                        {
                            entityInvisible_CheckBox.Checked = true;
                        })
                );
                    }
                    else
                    {
                        entityInvisible_CheckBox.BeginInvoke(new Action(() =>
                        {
                            entityInvisible_CheckBox.Checked = false;
                        })
                                      );
                    }















                    decimal scaleZ_ = 1;
                    if (tempEntity.skills[19] == 3)
                    {
                        scaleZ_ = Math.Round(Convert.ToDecimal(tempEntity.scale_z), 2);
                    }
                    double scale = Convert.ToDouble(entityScale.Value);
                    scale = tempEntity.scale_x;
                    if (scale == 0) scale = 1;

                    entityScale.BeginInvoke(new Action(() =>
                    {
                        entityScale.Value = (decimal)scale;
                    })
                             );
                    if (tempEntity.skills[16] == 1)
                    {

                        ent_WavingGras_checkBox.BeginInvoke(new Action(() =>
                        {
                            if(ent_WavingGras_checkBox.Checked != true)
                            ent_WavingGras_checkBox.Checked = true;
                        })
                              );

                    }
                    else
                    {
                        ent_WavingGras_checkBox.BeginInvoke(new Action(() =>
                        {
                            ent_WavingGras_checkBox.Checked = false;
                        })
                            );
                    }


                   

                    if (tempEntity.skills[19] == 2)
                    {
                        entityLight_Groupbox.BeginInvoke(new Action(() =>
                        {
                            entityLight_Groupbox.Enabled = true;
                        })
                              );

                        entityFlags_Group.BeginInvoke(new Action(() =>
                        {
                            entityFlags_Group.Enabled = true;
                        })
                              );

                        entity_Scale.BeginInvoke(new Action(() =>
                        {
                            entity_Scale.Enabled = true;
                        })
                              );

                        ent_Pan.BeginInvoke(new Action(() =>
                        {
                            ent_Pan.Enabled = true;
                        })
                              );

                        entityMaxScale.BeginInvoke(new Action(() =>
                        {
                            entityMaxScale.Enabled = true;
                        })
                              );



                        lightRange_GroupBox.BeginInvoke(new Action(() =>
                        {
                            lightRange_GroupBox.Enabled = true;

                        })
                          );
                        color_GroupBox.BeginInvoke(new Action(() =>
                        {
                            color_GroupBox.Enabled = true;

                        })
                         );

                        changeOwnColor_checkBox.BeginInvoke(new Action(() =>
                        {
                            changeOwnColor_checkBox.Enabled = true;

                        })
                                    );
                        lightRange_GroupBox.BeginInvoke(new Action(() =>
                        {
                            lightRange_GroupBox.Enabled = true;

                        })
                          );
                        lightRange_checkBox.BeginInvoke(new Action(() =>
                        {
                            lightRange_checkBox.Enabled = true;


                        })
                         );
                                     
            String tempEventName = "";
            String id_to_name = "";
                        if (tempEntity.skills[19] == 2)

            for (int i = 0; i < current_Map_Object.entityList.Count; i++ )
            {
                if (tempEntity.skills[18] == current_Map_Object.entityList[i].id && tempEntity.skills[19] == 2)
                {
                    tempEntity_YRPGObject = current_Map_Object.entityList[i];

                    tempEventName = tempEntity_YRPGObject.event_;
                    selectingEvent = true;

                  

                    foreach (VRPGText.Events event_ in eventList)
                    {
                        if (tempEventName.Trim().Equals(event_.fullID))
                        {
                            id_to_name = event_.name;
                        }
                    }
                    whichEventForMapEditor.BeginInvoke(new Action(() =>
                    {
                        whichEventForMapEditor.SelectedItem = tempEntity_YRPGObject.event_;

                    })
                          );

                 
                    selectingEvent = false;


                    if (current_Map_Object.entityList[i].lightRange_Active == true)
                    {
                        lightRange_checkBox.BeginInvoke(new Action(() =>
                        {
                            lightRange_checkBox.Checked = true;
                        })
                       );
                    }
                    else
                    {
                        lightRange_checkBox.BeginInvoke(new Action(() =>
                        {
                            lightRange_checkBox.Checked = false;
                        })
                   );
                    }


                    if (current_Map_Object.entityList[i].selfColor_Active == true)
                    {
                        changeOwnColor_checkBox.BeginInvoke(new Action(() =>
                        {
                            changeOwnColor_checkBox.Checked = true;

                        })
                       );
                    }
                    else
                    {
                        changeOwnColor_checkBox.BeginInvoke(new Action(() =>
                        {
                            changeOwnColor_checkBox.Checked = false;
                        })
                    );
                    }
                    entityRedVecTrack.BeginInvoke(new Action(() =>
                    {
                        entityRedVecTrack.Value = (int)current_Map_Object.entityList[i].lightRange_Value.x;

                    })
                    );
                    entityRedValue.BeginInvoke(new Action(() =>
                    {
                        entityRedValue.Text = current_Map_Object.entityList[i].lightRange_Value.x.ToString();

                    })
                    );


                    entityGreenVecTrack.BeginInvoke(new Action(() =>
                    {
                        entityGreenVecTrack.Value = (int)current_Map_Object.entityList[i].lightRange_Value.y;

                    })
                    );
                    entityGreenValue.BeginInvoke(new Action(() =>
                    {

                        entityGreenValue.Text = current_Map_Object.entityList[i].lightRange_Value.y.ToString();
                    })
                    );
                    entityBlueVecTrack.BeginInvoke(new Action(() =>
                    {
                        entityBlueVecTrack.Value = (int)current_Map_Object.entityList[i].lightRange_Value.z;

                    })
                    );
                    entityBlueValue.BeginInvoke(new Action(() =>
                    {
                        entityBlueValue.Text = current_Map_Object.entityList[i].lightRange_Value.z.ToString();

                    })
                    );


                    entityLightrange_trackbar.BeginInvoke(new Action(() =>
                    {
                        entityLightrange_trackbar.Value = current_Map_Object.entityList[i].lightStrength;
                    })
                    );

                    entityLightrange_Label.BeginInvoke(new Action(() =>
                    {
                        entityLightrange_Label.Text = current_Map_Object.entityList[i].lightStrength.ToString();
                    })
                    );


                    break;
                }
            }
                    }
                    if (tempEntity.skills[19] == 3)
                    {
                        foreach (Editor_Tile tile_ in current_Map_Object.tileList)
                        {
                            if (tempEntity.skills[18] == tile_.id && tempEntity.skills[19] == 3)
                            {
                                tempTile_YRPGObject = tile_;
                            }

                            try
                            {
                                scaleZ_Block.BeginInvoke(new Action(() =>
                                {
                                    scaleZ_Block.Value = scaleZ_;
                                })
                                );

                            }
                            finally{

                            }
                        }
                    }
                  

                    readEntityMode = false;
                    activateDelOption = true;

                    yield return ScheduleMethod.wait(1);
        }


        #endregion
    
        #region Directory Check for WinForms
        public static void check_CbItems(ComboBox Box, string targetPath, string fileEnding)
        {
            Box.Items.Clear();
            DirectoryInfo dinfo = new DirectoryInfo(targetPath);
            FileInfo[] Files = dinfo.GetFiles(fileEnding);

            foreach (FileInfo file in Files)
            {
                Box.Items.Add(file.Name);
            }
        }
        public static void check_LbItems(ListBox Box, string targetPath, string fileEnding)
        {

            Box.Items.Clear();
            DirectoryInfo dinfo = new DirectoryInfo(targetPath);
            FileInfo[] Files = dinfo.GetFiles(fileEnding);

            foreach (FileInfo file in Files)
            {
                Box.Items.Add(file.Name);
            }
        }



 
        #endregion

   
        ENTITY DummyEntity;

        Thread EngineThread;
      
        public Editor()
        {
            try
            {


             
                InitializeComponent();
                whichEventForMapEditor.SelectedIndex = 0;
            

                ini = new VRPGText.IniFile(".\\YED.ini");
                justTitle = StringHelper.StringAfterLast(ini.IniReadValue("Executable Path", "Single_Start_Project_Path"), '\\');
                pathSave = ini.IniReadValue("Executable Path", "Single_Start_Project_Path");
                this.Text = "YED - " + justTitle;
                eventList = new List<VRPGText.Events>();
                string[] dire = Directory.GetFiles(pathSave + "\\", "*.c");
                foreach (var file in dire)
                {
                    TextDatei text = new TextDatei();
                    int index = 0;

                    String tempString;
                    String tempAction = "";
                    tempString = text.ReadFile(file);
                    while (tempString.IndexOf("action") != -1)
                    {
                        index = tempString.IndexOf("action");
                        tempString = tempString.Substring(index, tempString.Length - index);
                    
                        if(!tempString.Contains("/action")){
                        
                        tempAction = StringHelper.betweenTwoStringsFirst(tempString, "action", "()").Trim(); tempAction = tempAction.Replace("\r", ""); tempAction= tempAction.Replace("\n", "");
                        if (tempAction.Contains("enemy_Battle_03")) tempString.Trim();
                        if(!tempAction.Contains("/") && tempAction.Length < 25 && tempAction.Length> 0){
                        whichEventForMapEditor.Items.Add(StringHelper.betweenTwoStringsFirst(tempString, "action", "()").Trim());
                        eventList.Add(new Events(tempAction, tempAction, 0));
                        }
                        }
                        if (6 <= tempString.Length) {tempString = tempString.Substring(6, tempString.Length - 6); }
                    }
            
                    

                }
                whichEventForMapEditor.Enabled = false;

                 Sunlight = new Editor_Sunlight(this);
                Form2 = new MusicForm(this);
                yed_Ptr = this;
                mapTree.ImageList = imageList2;
                fillTiles_Button.FlatStyle = FlatStyle.Flat;
                #region Initialize Global Variables
                int i = 0;
                blockMode = false;  flatCylinderTile.Checked = false; CylinderTile.Checked = false; flatCubeTile.Checked = false; CubeTile.Checked = false;
                    EditMode.Visible = true;
            EntityMode.Visible = false;
            BlockMo.Visible = false;

            blockMode = false;
                #endregion

                Editor_Speed_Values = new Editor_Speed_Values();
                Editor_Speed = new Editor_Speed(Editor_Speed_Values, this);

                Editor_Sky = new Editor_Sky(yed_Ptr);
                Fog = new Editor_Fog(yed_Ptr);
                EntityPosition =  new Editor_EntityPosition(this);
                customSkin = new Editor_Entity_Custom_Skin(this);
                #region Initialize Editor Components
                if(eventList != null)eventList.Clear();
                brushTiles_Button.ForeColor = System.Drawing.SystemColors.Highlight;
                fillTiles_Button.ForeColor = System.Drawing.SystemColors.ControlText;
                selectEntityPicture = MATERIAL.mtl_create();
                selectEntityPicture.ambient_blue = 20;
                selectEntityPicture.ambient_green = 20;
                selectEntityPicture.ambient_red = 255;
                selectEntityPicture.diffuse_blue = 20;
                    selectEntityPicture.diffuse_green = 20;
                    selectEntityPicture.diffuse_red = 255;
                    selectEntityPicture.diffuse_blue = 20;    
                selectEntityPicture.emissive_blue = 20;
                    selectEntityPicture.emissive_green = 20;
                    selectEntityPicture.emissive_red = 255;
                    markedEntityPicture = MATERIAL.mtl_create();
                    markedEntityPicture.ambient_blue = 255;
                    markedEntityPicture.ambient_green = 20;
                    markedEntityPicture.ambient_red = 20;
                    markedEntityPicture.diffuse_blue = 255;
                    markedEntityPicture.diffuse_green = 20;
                    markedEntityPicture.diffuse_red = 20;
                    
                    markedEntityPicture.emissive_blue = 255;
                    markedEntityPicture.emissive_green = 20;
                    markedEntityPicture.emissive_red = 20;
                check_LbItems(listBox1, yed_Ptr.returnPath() + "\\Models", "*.mdl");

                yed blogFromXml = null;
                   if (File.Exists(yed_Ptr.returnPath() + "\\Maps\\" + justProjectTitle() + ".yed"))
                {

                     blogFromXml = DeserializeXmlToYED(yed_Ptr.returnPath() + "\\Maps\\" + justProjectTitle() + ".yed");
                    allMaps = blogFromXml.YMAP_LIST;
                   }
                bool foundMap = false;
                  if (allMaps != null)
                if (allMaps.Count > 0)
                    foreach (String map in allMaps)
                    {
                        if (File.Exists(yed_Ptr.returnPath() + "\\Maps\\temp_" + map + ".ymp"))
                        {
                            File.Delete(yed_Ptr.returnPath() + "\\Maps\\temp_" + map + ".ymp");
                        }




                    }
                else
                {
                    string[] dirs = Directory.GetFiles(yed_Ptr.returnPath() + "\\Maps\\", "*.ymp");
                    foreach (var file in dirs)
                    {
                        File.Delete(file);
                    }
                }
                string[] dir = Directory.GetFiles(yed_Ptr.returnPath() + "\\Maps\\", "*.ymp");
                foreach (var file in dir)
                {
                    foreach (String map in allMaps)
                    {
                       
                        if (map.Equals(separateSlash(separateMimeType(file))))
                        {
                            found = true;
                            break;
                        }
                    }
                    if (found == false) File.Delete(file);
                    found = false;
                }

                       
        
                if (blogFromXml != null)
                {
             
                    Editor_Speed_Values = blogFromXml.Editor_Speed_Values_Save;
                    YRPGMap_Options = blogFromXml.Editor_Options_Save;
                    bool foundTree = false;
                    Editor_Speed_Values.ent_Lift = YRPGMap_Options.entity_lift;
                    Editor_Speed_Values.ent_LiftFast = YRPGMap_Options.entity_lift_fast;
                    Editor_Speed_Values.ent_Push = YRPGMap_Options.entity_move;
                    Editor_Speed_Values.ent_PushFast = YRPGMap_Options.entity_move_fast;
                    Editor_Speed_Values.ent_Pan = YRPGMap_Options.entity_pan;
                    Editor_Speed_Values.ent_PanFast = YRPGMap_Options.entity_pan_fast;
                    Editor_Speed_Values.map_Lift = YRPGMap_Options.map_lift;
                    Editor_Speed_Values.map_LiftFast = YRPGMap_Options.map_Lift_fast;
                    Editor_Speed_Values.map_Move = YRPGMap_Options.map_move;
                    Editor_Speed_Values.map_MoveFast = YRPGMap_Options.map_move_fast;
                    Editor_Speed.lift.Value = (decimal)YRPGMap_Options.entity_lift;
                    Editor_Speed.liftFast.Value = (decimal)YRPGMap_Options.entity_lift_fast;
                    Editor_Speed.push.Value = (decimal)YRPGMap_Options.entity_move;
                    Editor_Speed.pushFast.Value = (decimal)YRPGMap_Options.entity_move_fast;
                    Editor_Speed.pan.Value = (decimal)YRPGMap_Options.entity_pan;
                    Editor_Speed.panFast.Value = (decimal)YRPGMap_Options.entity_pan_fast;
                    Editor_Speed.mLift.Value = (decimal)YRPGMap_Options.map_lift;
                    Editor_Speed.mLiftFast.Value = (decimal)YRPGMap_Options.map_Lift_fast;
                    Editor_Speed.move.Value = (decimal)YRPGMap_Options.map_move;
                    Editor_Speed.moveFast.Value = (decimal)YRPGMap_Options.map_move_fast;

                    TreeNodeCollection nodes = mapTree.Nodes;
                    String lastNode = "";
                   
           

                    foreach (String map in allMaps)
                    {
                        ymap ymapObject = DeserializeXmlToYMAP(yed_Ptr.returnPath() + "\\Maps\\" + map + ".ymp");
                        Editor_Object tempYMAP = ymapObject.Editor_Object_Save;
                        CreateTrees(mapTree, tempYMAP);
                        foundTree_ = false;
                    }

                      foreach (String map in allMaps)
                        {
                            ymap ymapObject = DeserializeXmlToYMAP(yed_Ptr.returnPath() + "\\Maps\\" + map + ".ymp");
                        Editor_Object tempYMAP = ymapObject.Editor_Object_Save;
                        foundTree = false;
                        checkMapExists(mapTree, tempYMAP.mapDesignation, tempYMAP.mapContainer[tempYMAP.mapContainer.Count - 1]);
                        foundTree = false;
                        }

                   

                }

            }
            catch (OutOfMemoryException Memory)
            {
                MessageBox.Show("An unexpected error occured - not enough memory. YED was not able to load the texture folder.", "Out of memory", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
                #endregion
            setTreeIcons();
       
            EngineThread = new Thread(StartEngine);
            EngineThread.Start();
        }
       public  String separateSlash(String object_)
        {
            if (object_.Contains("\\"))
                return object_.Substring(object_.LastIndexOf('\\') + 1, object_.Length - object_.LastIndexOf('\\') - 1);
            else
                return object_;

        }
       public String separateFromFirst(String object_, char sign)
       {
           if (object_.Contains(sign))
               return object_.Substring(object_.LastIndexOf(sign) + 1, object_.Length - object_.LastIndexOf(sign) - 1);
           else
               return object_;

       }
       public String separateFromLast(String object_, char sign)
       {
           if (object_.Contains(sign))
               return object_.Substring(0, object_.LastIndexOf(sign));
           else
               return object_;

       }
        public  String separateMimeType(String object_)
        {
            if(object_.Contains("."))
            return object_.Substring(0, object_.LastIndexOf("."));
            else
                return object_;
        }
        private void checkMapExists(TreeView tree, String nameMap, String container)
        {

            foreach (TreeNode child in tree.Nodes)
            {


                if (child.Text.Equals(container))
                {
                    child.Nodes.Add(nameMap + ".ymp");
                    foundTree = true;
                    return;

                }
                else
                    if (checkMapExists(child.Nodes, nameMap, container) == true) { foundTree = false; return; }
            }
            foundTree = false;

        }
        private bool checkMapExists(TreeNodeCollection tree, String nameMap, String container)
        {

            foreach (TreeNode child in tree)
            {
                if (foundTree) return true;
                if (child.Text.Equals(container))
                {
                    child.Nodes.Add(nameMap + ".ymp");
                    foundTree = true;
                    return true;

                }
                else
                    if (checkMapExists(child.Nodes, nameMap, container) == true) { foundTree = false; return true; }
            }
            return false;

        }




        bool foundTree_ = false;

        private void CreateTrees(TreeView tree, Editor_Object object_)
        {
            int j = 0;
            bool foundTree_ = false;
            for (j = 0; j < object_.mapContainer.Count; j++)
            {
                foreach (TreeNode node in tree.Nodes)
                {
                    if (node.Text.Equals(object_.mapContainer[j]))
                    {
                        CreateNodes(node, object_, j + 1);
                        foundTree_ = true;
                    }
                }
                if (j == 0 && foundTree_ == false && object_.mapContainer.Count == 1)
                {
                    tree.Nodes.Add(object_.mapContainer[j]);
                    return;
                }
                if (foundTree_ == false && object_.mapContainer.Count > 1)
                {

                    CreateNodes(tree.Nodes.Add(object_.mapContainer[j]), object_, j + 1);
                    return;
                }
            }

        }
        private void CreateNodes(TreeNode nodes, Editor_Object object_, int z)
        {
            bool foundTree_ = false;

            foreach (TreeNode node in nodes.Nodes)
            {
                if (node.Text.Equals(object_.mapContainer[z]))
                {
                    if (object_.mapContainer.Count - 1 < z + 1) return;
                    CreateNodes(node, object_, z + 1);
                    return;
                }
            }
            if (object_.mapContainer.Count - 1 == z)
            {
                nodes.Nodes.Add(object_.mapContainer[z]);
                return;
            }
            else
            {
                if (z + 1 > object_.mapContainer.Count - 1)
                    return;
                else
                    CreateNodes(nodes.Nodes.Add(object_.mapContainer[z]), object_, z + 1);
            }


        }

        int numberOfCalls = 0;
        private void Form1_Load(object sender, EventArgs e)
        {
        }

        private void button1_Click(object sender, EventArgs e)
        {
            welcomeText.strings =
                new String[] { 
            mapToChoose};
        }
        public static double entity_Rotation = 0;
        public static ENTITY flyingEntity;
        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            modelCreate = true;




        }
        private IEnumerable<ScheduleMethod> selectModel()
        {

            yield return ScheduleMethod.wait(-0.5);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            saveNow = true;
        }
        TreeNode tempNode_;
        private void button3_Click(object sender, EventArgs e)
        {
            if (mapTree.SelectedNode == null) return;
            if (mapTree.SelectedNode.Text.Equals("")) return;
            if (!mapTree.SelectedNode.Text.Contains(".ymp")) return;
            button3.Enabled = false;
            if (tempNode_ != null)
            {
                tempNode_.ForeColor = SystemColors.ControlText;
            }
            tempNode_ = mapTree.SelectedNode;
            mapTree.SelectedNode.ForeColor = SystemColors.Highlight;
            loadNow = true;
            Place_Mode_checkBox.Checked = false;

        }

        private void mapTree_AfterSelect(object sender, TreeViewEventArgs e)
        {

            if (mapTree.SelectedNode == null)
            {
                button3.Enabled = false;
                mapTree.SelectedImageIndex = 0;
                return;
            }
            if (mapTree.SelectedNode.Text.Contains(".ymp"))
            {
                button3.Enabled = true;
                mapTree.SelectedImageIndex = 1;

            }
            else
            {
                button3.Enabled = false;
                mapTree.SelectedImageIndex = 0;
            }
            mapToChoose = "";
            mapToChoose = mapTree.SelectedNode.Text;


        }

        private void toolTip1_Popup(object sender, PopupEventArgs e)
        {
        }

        private void saveMapToolStripMenuItem_Click(object sender, EventArgs e)
        {
            saveNow = true;
        }

        private void newMapToolStripMenuItem_Click(object sender, EventArgs e)
        {
            {
                string value = " ";
                if (Editor_Input.InputBox("Map Creation", "Designation:", ref value) == DialogResult.OK)
                {
                    mapTree.Nodes.Add(value + ".ymp");
                    mapList.Add(new Editor_Map(value));
                    File.Copy(yed_Ptr.returnPath() + "\\Maps\\Templates\\" + "EMPTY.wmb", value + ".wmb");
                    File.Copy(yed_Ptr.returnPath() + "\\Maps\\Templates\\" + "EMPTY.wmp", value + ".wmp");
                    File.Copy(yed_Ptr.returnPath() + "\\Maps\\Templates\\" + "EMPTY.wmp", value + ".$$m");
                    File.Copy(yed_Ptr.returnPath() + "\\Maps\\Templates\\" + "EMPTY.wmp", value + ".ymp");
                    File.Copy(yed_Ptr.returnPath() + "\\Maps\\Templates\\" + "EMPTY.wmp", value + ".$$w");
                }
            }
        }

        private void deleteMapToolStripMenuItem_Click(object sender, EventArgs e)
        {
            var result = MessageBox.Show("Do you really want to delete this map?", "Delete Map", MessageBoxButtons.OKCancel);
            if (result == DialogResult.OK)
            {

                File.Delete(yed_Ptr.returnPath() + "\\Maps\\" + mapToChoose);
                File.Delete(yed_Ptr.returnPath() + "\\Maps\\" + mapToChoose.Substring(0, mapToChoose.Length - 4) + ".wmp");

                for (int x = 0; x < mapTree.Nodes.Count; x++)
                {
                    if (mapTree.Nodes[x].Text == mapToChoose)
                        mapTree.Nodes.RemoveAt(x);
                }
            }
        }
        
        private void compileMapToolStripMenuItem_Click(object sender, EventArgs e)
        {
        }
        static char[] whichEvent = new char[11];
        bool selectingEvent = false;
        String selectedEvent = "";
        private void whichEventForMapEditor_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (whichEventForMapEditor.SelectedIndex > -1)
            {
                selectedEvent = whichEventForMapEditor.Text;
            }
            if (tempEntity != null && selectingEvent == false)
            {
                
                int zaehler = 0;
                string event_ID = "";
                foreach (VRPGText.Events event_ in eventList)
                {
                    if (event_.name.Equals(whichEventForMapEditor.Text))
                    {
                        event_ID = event_.fullID; break;
                    }
                }
                for (zaehler = 0; zaehler < whichEvent.Length; zaehler++)
                {
                    whichEvent[zaehler] = ' ';
                }
                zaehler = 0;
                foreach (char a in event_ID)
                {
                    whichEvent[zaehler] = a;
                    zaehler++;
                }
                if (tempEntity.skills[19] == 2 && Place_Mode_checkBox.Checked == false)
                {
                    zaehler = 0;
                    for (zaehler = 0; zaehler < 11; zaehler++)
                    {
                        tempEntity.skills[zaehler] = whichEvent[zaehler];
                    }
                }

                
                
          
                if (tempEntity_YRPGObject != null)
                {

                    tempEntity_YRPGObject.event_ = whichEventForMapEditor.Text;
                    saveTempEntity();
                }
            }
        }

        private void button1_Click_1(object sender, EventArgs e)
        {

        }

        private void entityRedVecTrack_Scroll(object sender, EventArgs e)
        {
            entityRedValue.Text = "" + entityRedVecTrack.Value;
            if (selectedEntity.Text != "NONE")
            {
                if (flyingEntity != null && Place_Mode_checkBox.Checked == true)
                {
                    flyingEntity.red = entityRedVecTrack.Value;
                }
                if (tempEntity != null && Place_Mode_checkBox.Checked == false)
                {
                    if (tempEntity_YRPGObject != null) tempEntity_YRPGObject.lightRange_Value.x = entityRedVecTrack.Value;
                    tempEntity.red = entityRedVecTrack.Value;
                    saveTempEntity();
                }
            }
            lightRange_Red = (double)entityRedVecTrack.Value;
        }

        private void entityBlueVecTrack_Scroll(object sender, EventArgs e)
        {
            entityBlueValue.Text = "" + entityBlueVecTrack.Value;
            if (selectedEntity.Text != "NONE")
            {
                if (flyingEntity != null && Place_Mode_checkBox.Checked == true)
                {
                    flyingEntity.blue = entityBlueVecTrack.Value;
                }
                if (tempEntity != null && Place_Mode_checkBox.Checked == false)
                {
                    tempEntity.blue = entityBlueVecTrack.Value;
                    if (tempEntity_YRPGObject != null) tempEntity_YRPGObject.lightRange_Value.z = entityBlueVecTrack.Value;

                    saveTempEntity();
                }
            }
            lightRange_Blue = (double)entityBlueVecTrack.Value;
        }

        private void entityGreenVecTrack_Scroll(object sender, EventArgs e)
        {
            entityGreenValue.Text = "" + entityGreenVecTrack.Value;
            if (selectedEntity.Text != "NONE")
            {
                if (flyingEntity != null && Place_Mode_checkBox.Checked == true)
                {
                    flyingEntity.green = entityGreenVecTrack.Value;
                }
                if (tempEntity != null && Place_Mode_checkBox.Checked == false)
                {
                    tempEntity.green = entityGreenVecTrack.Value;
                    if (tempEntity_YRPGObject != null) tempEntity_YRPGObject.lightRange_Value.y = entityGreenVecTrack.Value;

                    saveTempEntity();

                }
            }
            lightRange_Green = (double)entityGreenVecTrack.Value;

        }

        private void entityScale_Scroll(object sender, EventArgs e)
        {


        }
        private IEnumerable<ScheduleMethod> entityTranslucent_Scheduling()
        {
            if (selectedEntity.Text != "NONE")
            {
                if (flyingEntity != null && Place_Mode_checkBox.Checked == true)
                {
                    if (entityTranslucent.Checked == true)
                        flyingEntity.TRANSLUCENT = true;
                    else
                        if (entityTranslucent.Checked == false)
                            flyingEntity.TRANSLUCENT = false;
                }
                if (tempEntity != null && Place_Mode_checkBox.Checked == false)
                {
                    if (entityTranslucent.Checked == true)
                    {
                        tempEntity.TRANSLUCENT = true;
                        if (tempEntity_YRPGObject != null)
                        {
                            tempEntity_YRPGObject.flags.translucent = 1;
                            saveTempEntity();
                        }
                    }
                    else
                        if (entityTranslucent.Checked == false)
                        {
                            tempEntity.TRANSLUCENT = false;
                            if (tempEntity_YRPGObject != null)
                            {
                                tempEntity_YRPGObject.flags.translucent = 0;
                                saveTempEntity();
                            }
                        }
                }
            }

            entityTranslucent.BeginInvoke(new Action(() =>
            {
                entityTranslucent.Enabled = true;
            })
            );
            yield break;
        }
        private void entityTranslucent_CheckedChanged(object sender, EventArgs e)
        {
            entityTranslucent.Enabled = false;
            Scheduler.AddEventVoidThreadSafe(entityTranslucent_Scheduling);
        }

        private void sunlightToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Sunlight.Visible = true;
        }

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {

            if (entityMaxScale.Value < entityScale.Value)
            {
                entityMaxScale.Value = entityScale.Value;
            }
            if (tempEntity != null && Place_Mode_checkBox.Checked == false)
            {
                tempEntity.scale_x = Convert.ToDouble(entityScale.Value);
                tempEntity.scale_y = Convert.ToDouble(entityScale.Value);
                if (tempEntity.skills[19] == 2)
                    tempEntity.scale_z = Convert.ToDouble(entityScale.Value);

                if (tempEntity_YRPGObject != null)
                {
                    tempEntity_YRPGObject.scale = Convert.ToDouble(entityScale.Value);
                    saveTempEntity();
                }
            }

            if (flyingEntity != null && Place_Mode_checkBox.Checked == true)
            {
                flyingEntity.scale_x = Convert.ToDouble(entityScale.Value);
                flyingEntity.scale_y = Convert.ToDouble(entityScale.Value);
                if (flyingEntity.skills[19] == 2)
                    flyingEntity.scale_z = Convert.ToDouble(entityScale.Value);
            }
        }
        private IEnumerable<ScheduleMethod> entityOverlay_Scheduling()
        {
            if (selectedEntity.Text != "NONE")
            {
                if (flyingEntity != null && Place_Mode_checkBox.Checked == true)
                {
                    if (entityOverlay.Checked == true)
                        flyingEntity.OVERLAY = true;
                    else
                        if (entityOverlay.Checked == false)
                            flyingEntity.OVERLAY = false;
                }
                if (tempEntity != null && Place_Mode_checkBox.Checked == false)
                {
                    if (entityOverlay.Checked == true)
                    {
                        tempEntity.OVERLAY = true;
                        if (tempEntity_YRPGObject != null)
                        {
                            tempEntity_YRPGObject.flags.overlay = 1;
                            saveTempEntity();
                        }
                    }
                    else
                        if (entityOverlay.Checked == false)
                        {
                            tempEntity.OVERLAY = false;
                            if (tempEntity_YRPGObject != null)
                            {
                                tempEntity_YRPGObject.flags.overlay = 0;
                                saveTempEntity();
                            }
                        }
                }
            }
            entityOverlay.BeginInvoke(new Action(() =>
            {
                entityOverlay.Enabled = true;

            })
            );

            yield break;
        }
        private void entityOverlay_CheckedChanged(object sender, EventArgs e)
        {
            entityOverlay.Enabled = false;
            Scheduler.AddEventVoidThreadSafe(entityOverlay_Scheduling);
        }

        private void button1_Click_2(object sender, EventArgs e)
        {
          
            saveNow = true;
        }

        private void DeleteMapButton_Click(object sender, EventArgs e)
        {
            var result = MessageBox.Show("Do you really want to delete this map?", "Delete Map", MessageBoxButtons.OKCancel);
            if (result == DialogResult.OK)
            {

                for (int x = 0; x < allMaps.Count; x++)
                {
                    if (allMaps[x].Equals(mapTree.SelectedNode.Text.Substring(0, mapTree.SelectedNode.Text.Length - 5)))
                    {
                        allMaps.RemoveAt(x);
                    }
                }
                if (currentMap != null)
                    if ((currentMap).Equals(mapTree.SelectedNode.Text))
                    {
                        Editor_Object EmptyMap = new Editor_Object("Empty", "null");
                        current_Map_Object = EmptyMap;
                        initializedMap = false;
                        Scheduler.AddEventVoid(createNewMap);
                    }
                if (currentMap == null)
                {
                    Editor_Object EmptyMap = new Editor_Object("Empty", "null");
                    current_Map_Object = EmptyMap;
                    initializedMap = false;
                    Scheduler.AddEventVoid(createNewMap);
                }

                File.Delete(yed_Ptr.returnPath() + "\\Maps\\" + mapTree.SelectedNode.Text);
                File.Delete(yed_Ptr.returnPath() + "\\Maps\\" + mapTree.SelectedNode.Text.Substring(0, mapToChoose.Length - 5) + ".wmp");
                File.Delete(yed_Ptr.returnPath() + "\\Maps\\" + mapTree.SelectedNode.Text.Substring(0, mapToChoose.Length - 5) + ".wmb");
                File.Delete(yed_Ptr.returnPath() + "\\Maps\\" + mapTree.SelectedNode.Text.Substring(0, mapToChoose.Length - 5) + ".$$m");
                File.Delete(yed_Ptr.returnPath() + "\\Maps\\" + mapTree.SelectedNode.Text.Substring(0, mapToChoose.Length - 5) + ".$$w");
                File.Delete(yed_Ptr.returnPath() + "\\Maps\\" + mapTree.SelectedNode.Text.Substring(0, mapToChoose.Length - 5) + ".ymp");

                mapTree.SelectedNode.Remove();
                yedMainObject.YMAP_LIST = allMaps;
                SerializeYEDToXML(yedMainObject, yed_Ptr.returnPath() + "\\Maps\\" + justProjectTitle() + ".yed");

            }
        }

        private void mapToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void entityPositionToolStripMenuItem_Click(object sender, EventArgs e)
        {
            EntityPosition.Visible = true;
        }
        private IEnumerable<ScheduleMethod> entityPassable_Scheduling()
        {
            if (selectedEntity.Text != "NONE")
            {
                if (flyingEntity != null && Place_Mode_checkBox.Checked == true)
                {
                    if (entityPassable.Checked == true)
                        flyingEntity.PASSABLE = true;
                    else
                        if (entityPassable.Checked == false)
                            flyingEntity.PASSABLE = false;
                }
                if (tempEntity != null && Place_Mode_checkBox.Checked == false)
                {
                    if (entityPassable.Checked == true)
                    {
                        tempEntity.PASSABLE = true;
                        if (tempEntity_YRPGObject != null)
                        {
                            tempEntity_YRPGObject.flags.passable = 1;
                            saveTempEntity();
                        }
                    }
                    else
                        if (entityPassable.Checked == false)
                        {
                            tempEntity.PASSABLE = false;
                            if (tempEntity_YRPGObject != null)
                            {
                                tempEntity_YRPGObject.flags.passable = 0;
                                saveTempEntity();
                            }
                        }
                }
            }
            entityPassable.BeginInvoke(new Action(() =>
            {
                entityPassable.Enabled = true;

            })
            );
            yield break;
        }
        private void entityPassable_CheckedChanged(object sender, EventArgs e)
        {
            entityPassable.Enabled = false;
            Scheduler.AddEventVoidThreadSafe(entityPassable_Scheduling);
        }

        private IEnumerable<ScheduleMethod> entityBright_Scheduling()
        {
            if (selectedEntity.Text != "NONE")
            {
                if (flyingEntity != null && Place_Mode_checkBox.Checked == true)
                {
                    if (entityBright.Checked == true)
                        flyingEntity.BRIGHT = true;
                    else
                        if (entityBright.Checked == false)
                            flyingEntity.BRIGHT = false;
                }
                if (tempEntity != null && Place_Mode_checkBox.Checked == false)
                {
                    if (entityBright.Checked == true)
                    {
                        tempEntity.BRIGHT = true;
                        if (tempEntity_YRPGObject != null)
                        {
                            tempEntity_YRPGObject.flags.bright = 1;
                            saveTempEntity();
                        }
                    }
                    else
                        if (entityBright.Checked == false)
                        {
                            tempEntity.BRIGHT = false;
                            if (tempEntity_YRPGObject != null)
                            {
                                tempEntity_YRPGObject.flags.bright = 0;
                                saveTempEntity();
                            }
                        }
                }
            }


            entityBright.BeginInvoke(new Action(() =>
            {
                entityBright.Enabled = true;
            })
            );

            yield break;
        }
        private void entityBright_CheckedChanged(object sender, EventArgs e)
        {
            entityBright.Enabled = false;
            Scheduler.AddEventVoidThreadSafe(entityBright_Scheduling);
                
        }
        private IEnumerable<ScheduleMethod> entitiyShadow_Scheduling()
        {

            if (selectedEntity.Text != "NONE")
            {
                if (flyingEntity != null && Place_Mode_checkBox.Checked == true)
                {
                    if (entityShadow.Checked == true)
                        flyingEntity.SHADOW = true;
                    else
                        if (entityShadow.Checked == false)
                            flyingEntity.SHADOW = false;
                }
                if (tempEntity != null && Place_Mode_checkBox.Checked == false)
                {
                    if (entityShadow.Checked == true)
                    {
                        tempEntity.SHADOW = true;
                        if (tempEntity_YRPGObject != null)
                        {
                            tempEntity_YRPGObject.flags.shadow = 1;
                            saveTempEntity();
                        }
                    }
                    else
                        if (entityShadow.Checked == false)
                        {
                            tempEntity.SHADOW = false;
                            if (tempEntity_YRPGObject != null)
                            {
                                tempEntity_YRPGObject.flags.shadow = 0;
                                saveTempEntity();
                            }
                        }
                }
            }


            entityShadow.BeginInvoke(new Action(() =>
            {

                entityShadow.Enabled = true;
            })
            );
            yield break;
        }
        private void entityShadow_CheckedChanged(object sender, EventArgs e)
        {
            entityShadow.Enabled = false;
            Scheduler.AddEventVoid(entitiyShadow_Scheduling);
        }

        private void fogToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void embeddedEnginePanel_Paint(object sender, PaintEventArgs e)
        {

        }

        private void entitySettingsToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void closeMapEditorToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Scheduler.AddEventVoidThreadSafe(testload);

        }
        private IEnumerable<ScheduleMethod> testload()
        {


            // 
            try
            {
          
             
            }
            catch (Exception e)
            {
            }

            groundEntity = ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Templates\\8x8.mdl", new Vector(), null);
            yield return ScheduleMethod.wait(1);
        }
        private void editModeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Scheduler.AddEventVoid(deselectEntityMethod);
            Place_Mode_checkBox.Checked = false;
            EditMode.Visible = true;
            EntityMode.Visible = false;
            BlockMo.Visible = false;

            blockMode = false;
        }

        private void entityModeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            useNormalMap_checkBox.Checked = false;
            if (EntityMode.Visible == false)
            {
                if (tempEntity != null)
                    Scheduler.AddEventVoid(resetTempEntity);
                if (flyingEntity != null)
                    Scheduler.AddEventVoid(removeFlyingEntity);
                flyingEntity = tempEntity;
                if (listBox1.SelectedIndex > -1)
                    Scheduler.AddEventVoid(listBox1_SelectedIndex);
                listBox1.Enabled = false;
                if (flyingEntity == null)
                {
                    entityLight_Groupbox.Enabled = false;
                    entityFlags_Group.Enabled = false;
                    entity_Scale.Enabled = false;
                    ent_Pan.Enabled = false;
                    entityMaxScale.Enabled = false;
                    entityLight_Groupbox.Enabled = false;

                }
                else
                {
                    entityLight_Groupbox.Enabled = true;
                    entityFlags_Group.Enabled = true;
                    entity_Scale.Enabled = true;
                    ent_Pan.Enabled = true;
                    entityMaxScale.Enabled = true;
                    entityLight_Groupbox.Enabled = true;
                }
                if (tempEntity == null)
                {

                    entityLight_Groupbox.Enabled = false;
                    entityFlags_Group.Enabled = false;
                    entity_Scale.Enabled = false;
                    ent_Pan.Enabled = false;
                    entityMaxScale.Enabled = false;
                    entityLight_Groupbox.Enabled = false;

                }
                else
                {
                    entityLight_Groupbox.Enabled = true;
                    entityFlags_Group.Enabled = true;
                    entity_Scale.Enabled = true;
                    ent_Pan.Enabled = true;
                    entityMaxScale.Enabled = true;
                    entityLight_Groupbox.Enabled = true;
                }

                CubeTile.Checked = false;
                CylinderTile.Checked = false;
                flatCubeTile.Checked = false;
                flatCylinderTile.Checked = false;
                EditMode.Visible = false;
                EntityMode.Visible = true;
                BlockMo.Visible = false;
                blockMode = false;
            }
        }
        public static bool blockMode = true;

        private IEnumerable<ScheduleMethod> blockModeFlying()
        {

            yield return ScheduleMethod.wait(1);
        }
        private void blockModeToolStripMenuItem_Click(object sender, EventArgs e)
        {

            Scheduler.AddEventVoid(resetTempEntity);
            Place_Mode_checkBox.Checked = false;
            Place_Mode_checkBox.Checked = false;
            EditMode.Visible = false;
            EntityMode.Visible = false;
            BlockMo.Visible = true;
            modelCreate = false;
            blockMode = true;

        }
        public static string TextureNow;
        String textureString = "";
        public static BMAP Texture = null;
        private void textureView_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (textureView.SelectedItems.Count > 0)
            {
                if (File.Exists(yed_Ptr.returnPath() + "\\Textures\\" + textureView.SelectedItems[0].Text.Substring(0, textureView.SelectedItems[0].Text.Length - 4) + "_n.png"))
                {
                    normalMapExists_Label.ForeColor = System.Drawing.Color.Green;
                    normalMapExists_Label.Text = "Ready";
                    normalMapExists_Label.Font = new Font(normalMapExists_Label.Font, FontStyle.Bold);
                }
                else
                {
                    normalMapExists_Label.ForeColor = System.Drawing.Color.Black;
                    useNormalMap_checkBox.Enabled = false;
                    useNormalMap_checkBox.Checked = false;
                    normalMapExists_Label.Text = "Not Ready";
                    normalMapExists_Label.Font = new Font(normalMapExists_Label.Font, FontStyle.Italic);
                }
                Texture = BMAP.bmap_create(yed_Ptr.returnPath() + "\\Textures\\" + textureView.SelectedItems[0].Text);
                TextureNow = yed_Ptr.returnPath() + "\\Textures\\" + textureView.SelectedItems[0].Text;
                textureString = textureView.SelectedItems[0].Text;
            }
        }


        private void BlockMo_Paint(object sender, PaintEventArgs e)
        {

        }


        public static bool flatTileOn = false;
        public static bool flatCylinderOn = false;
        private void flatTile_CheckedChanged(object sender, EventArgs e)
        {
            if (flatCubeTile.Checked == true)
            {
                CubeTile.Checked = false;
                flatCubeTile.Checked = true;
                CylinderTile.Checked = false;
                flatCylinderTile.Checked = false;
                stepTile.Checked = false;
                flatStepTile.Checked = false;
                obstacleTile.Checked = false;
            }

        }

        private void CubeTile_CheckedChanged(object sender, EventArgs e)
        {
            if (CubeTile.Checked == true)
            {

               
                CubeTile.Checked = true;
                flatCubeTile.Checked = false;
                CylinderTile.Checked = false;
                flatCylinderTile.Checked = false;
                stepTile.Checked = false;
                flatStepTile.Checked = false;
                obstacleTile.Checked = false;
            }

        }

        private void CylinderTile_CheckedChanged(object sender, EventArgs e)
        {
            if (CylinderTile.Checked == true)
            {
                CubeTile.Checked = false;
                flatCubeTile.Checked = false;
                CylinderTile.Checked = true;
                flatCylinderTile.Checked = false;
                stepTile.Checked = false;
                flatStepTile.Checked = false;
                obstacleTile.Checked = false;
            }

        }

        private void checkBox2_CheckedChanged(object sender, EventArgs e)
        {
            if (flatCylinderTile.Checked == true)
            {
                CubeTile.Checked = false;
                flatCubeTile.Checked = false;
                CylinderTile.Checked = false;
                flatCylinderTile.Checked = true;
                stepTile.Checked = false;
                flatStepTile.Checked = false;
                obstacleTile.Checked = false;
            }
        }



        private void loadTileset()
        {

            OpenFileDialog openFileDialog1 = new OpenFileDialog();
            string pathSave = "";
            openFileDialog1.Filter = "Yume Map Project (*.ymp)|*.ymp";
            openFileDialog1.FilterIndex = 2;
            openFileDialog1.RestoreDirectory = true;
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                pathSave = openFileDialog1.FileName;
            }
        }

        private void saveTileset()
        {

        }

        public static void SerializeYMAPToXML(ymap blogObj, string path)
        {
            XmlSerializer serializer = new XmlSerializer(typeof(ymap));
            FileStream file = new FileStream(path,
                                             FileMode.Create);
            serializer.Serialize(file, blogObj);
            file.Close();
        }

        public static ymap DeserializeXmlToYMAP(string path)
        {
            XmlSerializer serializer = new XmlSerializer(typeof(ymap));
            FileStream file = new FileStream(path,
                                                FileMode.Open);
            ymap blogList = serializer.Deserialize(file) as ymap;
            file.Close();
            return blogList;
        }
        public static void SerializeYEDToXML(yed blogObj, string path)
        {
            XmlSerializer serializer = new XmlSerializer(typeof(yed));
            FileStream file = new FileStream(path,
                                             FileMode.Create);
            serializer.Serialize(file, blogObj);
            file.Close();
        }

        public static yed DeserializeXmlToYED(string path)
        {
            XmlSerializer serializer = new XmlSerializer(typeof(yed));
            FileStream file = new FileStream(path,
                                                FileMode.Open);
            yed blogList = serializer.Deserialize(file) as yed;
            file.Close();
            return blogList;
        }
        private void button1_Click_3(object sender, EventArgs e)
        {

        }
        int texture_width = 128;
        
        private void reloadTextureList()
        {
            if (PNG_radioButton.Checked == true)
            {
                imageList1.Images.Clear();
                textureView.Items.Clear();
                textureView.LargeImageList.Images.Clear();

                imageList1.ImageSize = new Size( texture_width,texture_width);
                int i = 0;

                string[] dirs = Directory.GetFiles(yed_Ptr.returnPath() + "\\Textures\\", "*.png");

                foreach (var file in dirs)
                {
                    if (!file.EndsWith("_n.png"))
                    {
                        imageList1.Images.Add(i + "", Image.FromFile(file).GetThumbnailImage(texture_width,texture_width,null,IntPtr.Zero));
                        textureView.Items.Add(file.Substring(file.LastIndexOf('\\') + 1, file.Length - file.LastIndexOf('\\') - 1), i);
                        i++;
                    }
                }

                textureView.LargeImageList = imageList1;
                return;
            }
            else
            {
                imageList1.Images.Clear();
                textureView.Items.Clear();
                textureView.LargeImageList.Dispose();

                int i = 0;
                string[] dirs = Directory.GetFiles(yed_Ptr.returnPath() + "\\Textures\\", "*.dds");
                foreach (var file in dirs)
                {

                    if (!file.EndsWith("_n.dds"))
                    {


                        i++;
                    }
                }
                i = 0;
                foreach (var file in dirs)
                {
                    if (!file.EndsWith("_n.dds"))
                    {
                        textureView.Items.Add(file.Substring(file.LastIndexOf('\\') + 1, file.Length - file.LastIndexOf('\\') - 1), i);
                        i++;
                    }
                }

                textureView.LargeImageList = imageList1;
                return;
            }
        }
        private void button2_Click_1(object sender, EventArgs e)
        {
            if (tempEntity != null)
            {
                tempEntity.ent_remove();
            }
        }

        private void selectedEntity_Click(object sender, EventArgs e)
        {

        }
        public IEnumerable<ScheduleMethod> listBox1_SelectedIndex()
        {

           
            yield return ScheduleMethod.wait(1);
    

            modelCreate = true;

            #region Change Dragged Model
            if (modelCreate == true)
            {
                if (flyingEntity == null && Place_Mode_checkBox.Checked == true)
                {


                    try
                    {
                        flyingEntity = ENTITY.ent_create(modelToChoose, EngVar.target, click_and_move);
                        flyingEntity.scale_xyz.vec_set(new Vector(Convert.ToDouble(entityScale.Value), Convert.ToDouble(entityScale.Value), Convert.ToDouble(entityScale.Value)));
                       
                    }
                    catch (AccessViolationException e)
                    {
                        Scheduler.AddEventVoid(listBox1_SelectedIndex);
                        yield break;
                    }

                    modelCreate = false;
                }
                else if (flyingEntity != null && Place_Mode_checkBox.Checked == true)
                {
                    try{
                    flyingEntity.INVISIBLE = true;
                    flyingEntity.ent_purge();
                    flyingEntity.ent_remove();
                    flyingEntity.ptr_remove();
                    flyingEntity = ENTITY.ent_create(modelToChoose, null, null);

                    flyingEntity.INVISIBLE = true;
                    flyingEntity.ent_purge();
                    flyingEntity.ent_remove();
                    flyingEntity.ptr_remove();
                    flyingEntity = ENTITY.ent_create(modelToChoose, EngVar.target, click_and_move);
                    flyingEntity.scale_xyz.vec_set(new Vector(Convert.ToDouble(entityScale.Value), Convert.ToDouble(entityScale.Value), Convert.ToDouble(entityScale.Value)));

                     }
                    catch (AccessViolationException e)
                    {
                        Scheduler.AddEventVoid(listBox1_SelectedIndex);
                        yield break;
                    }
                    modelCreate = false;
                }

            }
            #endregion
            listBox1.BeginInvoke(new Action(() =>{
                listBox1.Enabled = true;
            })
            );
            yield break;
        }


        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (initializedMap == true)
            {
                listBox1.Enabled = false;
                modelToChoose = listBox1.Text;
                Scheduler.AddEventVoidThreadSafe(listBox1_SelectedIndex);

                if (Place_Mode_checkBox.Checked == true)
                {

                    entityLight_Groupbox.Enabled = true;

                    if (lightRange_checkBox.Checked == false)
                    {
                        lightRange_GroupBox.Enabled = false;
                        color_GroupBox.Enabled = false;
                        entityLightrange_trackbar.Enabled = false;
                        changeOwnColor_checkBox.Enabled = false;
                    }
                    else if (lightRange_checkBox.Checked == true)
                    {
                        lightRange_GroupBox.Enabled = true;
                        color_GroupBox.Enabled = true;
                        entityLightrange_trackbar.Enabled = true;
                        changeOwnColor_checkBox.Enabled = true;
                    }

                    if (listBox1.SelectedIndex < 0 && lightRange_checkBox.Checked == false)
                    {
                        lightRange_GroupBox.Enabled = false;
                        color_GroupBox.Enabled = false;
                        entityLightrange_trackbar.Enabled = false;
                        changeOwnColor_checkBox.Enabled = false;
                    }
                    else if (listBox1.SelectedIndex > -1 && lightRange_checkBox.Checked == true)
                    {
                        lightRange_GroupBox.Enabled = true;
                        color_GroupBox.Enabled = true;
                        entityLightrange_trackbar.Enabled = true;
                        changeOwnColor_checkBox.Enabled = true;
                    }

                    lightRange_checkBox.Enabled = true;
                    entityFlags_Group.Enabled = true;
                    entity_Scale.Enabled = true;
                    ent_Pan.Enabled = true;

                    selectedEntity.Text = listBox1.SelectedItem.ToString();





                }
            }
        }
        Editor_Debug debug;
        private void debugModeToolStripMenuItem_Click(object sender, EventArgs e)
        {
        }

        private void menuStrip1_Resize(object sender, EventArgs e)
        {


        }

        private void Form1_ResizeEnd(object sender, EventArgs e)
        {
        }

        private void FlatCylinder_Resize(object sender, EventArgs e)
        {
            if(initialize_Engine == true)
            Scheduler.AddEventVoid(changeSize);
        }

        private IEnumerable<ScheduleMethod> changeSize()
        {
            EmbedWindow();
            yield return ScheduleMethod.wait(60);
            EngFun.video_set(
              engine_Window.Width,
              engine_Window.Height,
              0,
              0);
            yield break;
        }

        public static bool placeMode = false;
        private void Place_Mode_checkBox_CheckedChanged(object sender, EventArgs e)
        {
            if (Place_Mode_checkBox.Checked == false &&  flyingEntity == null)
            {
                whichEventForMapEditor.Enabled = true;
                tempEntity_YRPGObject = null;
                listBox1.Enabled = false;
                placeMode = false;
                ignoreEntities.Checked = false;
                ignoreEntities.Enabled = false;
                Scheduler.AddEventVoidThreadSafe(resetTempEntity);

                return;
            }
            else if(Place_Mode_checkBox.Checked == true&&  flyingEntity == null)
            {
                whichEventForMapEditor.Enabled = true;
                tempEntity_YRPGObject = null;
                ignoreEntities.Enabled = true;
                listBox1.Enabled = true;
                lightRange_checkBox.Checked = false;
                return;
              
            }
            if (Place_Mode_checkBox.Checked == false && flyingEntity != null)
            {
               
                Scheduler.AddEventVoidThreadSafe(removeFlyingEntity);
                Scheduler.AddEventVoidThreadSafe(resetTempEntity);
                entityLight_Groupbox.Enabled = false;
                entityFlags_Group.Enabled = false;
                whichEventForMapEditor.Enabled = false;
                ent_Pan.Enabled = false;
                entity_Scale.Enabled = false;
                entity_Scale.Enabled = false;
                selectedEntity.Text = "NONE";
                listBox1.Enabled = false;
                placeMode = false;

                 if (tempEntity_YRPGObject != null)
                    tempEntity_YRPGObject = null;
                return;

            }
            if (Place_Mode_checkBox.Checked == true && listBox1.SelectedIndex > -1 && initializedMap == true)
            {
                Scheduler.AddEventVoidThreadSafe(listBox1_SelectedIndex);
                if (Place_Mode_checkBox.Checked == true)
                {
                    Scheduler.AddEventVoid(deselectEntityMethod);
                    whichEventForMapEditor.Enabled = true;
                    entityLight_Groupbox.Enabled = true;
                    lightRange_GroupBox.Enabled = false;
                    color_GroupBox.Enabled = false;
                    lightRange_checkBox.Enabled = true;
                    entityFlags_Group.Enabled = true;

                    ent_Pan.Enabled = true;
                    entity_Scale.Enabled = true;
                    if (randomScale_Checkbox.Checked == true)
                        entityMaxScale.Enabled = true;
                    else
                        entityMaxScale.Enabled = false;
                    placeMode = true;
                    listBox1.Enabled = true;
                    lightRange_checkBox.Checked = false;
                    if (lightRange_checkBox.Checked == false)
                    {

                        changeOwnColor_checkBox.Checked = false;
                        changeOwnColor_checkBox.Enabled = false;
                        lightRange_GroupBox.Enabled = false;
                        entityLightrange_trackbar.Value = 0;
                        entityLightrange_Label.Text = "0";
                        entityLightrange_trackbar.Enabled = false;
                        entityRedVecTrack.Value = 0;
                        entityRedVecTrack.Enabled = false;
                        entityRedValue.Text = "0";
                        entityGreenVecTrack.Value = 0;
                        entityGreenVecTrack.Enabled = false;
                        entityGreenValue.Text = "0";
                        entityBlueVecTrack.Value = 0;
                        entityBlueVecTrack.Enabled = false;
                        entityBlueValue.Text = "0";
                        color_GroupBox.Enabled = false;
                    }
                    else
                    {
                        lightRange_GroupBox.Enabled = true;
                        color_GroupBox.Enabled = true;
                        entityLight_Groupbox.Enabled = true;
                        entityLightrange_trackbar.Enabled = true;
                        entityLightrange_Label.Enabled = true;
                        entityLight_Groupbox.Enabled = true;
                        changeOwnColor_checkBox.Checked = false;
                        changeOwnColor_checkBox.Enabled = true;

                        entityRedVecTrack.Enabled = true;
                        entityGreenVecTrack.Enabled = true;
                        entityBlueVecTrack.Enabled = true;
                    }
                    tempEntity_YRPGObject = null;
                    return;
                }
            }
            if (Place_Mode_checkBox.Checked == true && initializedMap == true) { whichEventForMapEditor.Enabled = true; listBox1.Enabled = true; return; }
        }
        public static bool getPlaceMode() { return placeMode; }
        private IEnumerable<ScheduleMethod> removeFlyingEntity()
        {
            if (flyingEntity != null)
            {
                flyingEntity.INVISIBLE = true;
                flyingEntity.ent_purge();
                flyingEntity.ent_remove();
            }
            yield return ScheduleMethod.wait(1);
        }



        private IEnumerable<ScheduleMethod> resetTempEntity()
        {

            Scheduler.AddEventVoid(deselectEntityMethod);
            tempEntity = DummyEntity;
            yield return ScheduleMethod.wait(1);
        }

        public bool checkWinFormat(String a)
        {
            if (a.Contains("/")) return false;
            if (a.Contains("\\")) return false;
            if (a.Contains(":")) return false;
            if (a.Contains("*")) return false;
            if (a.Contains("?")) return false;
            if (a.Contains("\"")) return false;
            if (a.Contains("<")) return false;
            if (a.Contains(">")) return false;
            if (a.Contains("|")) return false;
            if (a.Contains("|")) return false;
            return true;
        }

        ENTITY skyEntity = null;
        ENTITY groundEntity = null;
        public double skyLevel = 50;
        public double skyScale = 0.1;


        public IEnumerable<ScheduleMethod> changeSkyScaleDown()
        {
            skyLevel = yed_Ptr.skyLevel;
            if (skyEntity != null)
            {
                skyEntity.scale_x -= skyScale;
                skyEntity.scale_y -= skyScale;
                skyEntity.scale_z -= skyScale;
                if (current_Map_Object != null)
                {
                    current_Map_Object.skyAttributes.scale_Sky = skyEntity.scale_x;
                }
            }
            yield return ScheduleMethod.wait(1);
        }
        public IEnumerable<ScheduleMethod> changeSkyScaleUp()
        {
            skyScale = yed_Ptr.skyScale;
            if (skyEntity != null)
            {
                skyEntity.scale_x += skyScale;
                skyEntity.scale_y += skyScale;
                skyEntity.scale_z += skyScale;

                if (current_Map_Object != null)
                {
                    current_Map_Object.skyAttributes.scale_Sky = skyEntity.scale_x;
                }
            }

            yield return ScheduleMethod.wait(1);
        }

        public IEnumerable<ScheduleMethod> changeSkyLevelDown()
        {
            skyLevel = yed_Ptr.skyLevel;
            if (skyEntity != null)
            {
                EngVar.you = ENTITY.ent_next(null);
                while (EngVar.you != null)
                {
                    if (EngVar.you.str_for_entname().Equals("ENVITUBE.MDL"))
                    {
                        EngVar.you.z -= skyLevel;
                        if (current_Map_Object != null)
                        {
                            current_Map_Object.skyAttributes.position_z_Sky = EngVar.you.z;
                        }
                    }
                    EngVar.you = ENTITY.ent_next(EngVar.you);
                }
            }



            yield return ScheduleMethod.wait(1);
        }
        public IEnumerable<ScheduleMethod> changeSkyLevelUp()
        {
            skyLevel = yed_Ptr.skyLevel;
            if (skyEntity != null)
            {
                EngVar.you = ENTITY.ent_next(null);
                while (EngVar.you != null)
                {
                    if (EngVar.you.str_for_entname().Equals("ENVITUBE.MDL"))
                    {
                        EngVar.you.z += skyLevel;
                        if (current_Map_Object != null)
                        {
                            current_Map_Object.skyAttributes.position_z_Sky = EngVar.you.z;
                        }
                    }
                    EngVar.you = ENTITY.ent_next(EngVar.you);
                }
            }

            yield return ScheduleMethod.wait(1);
        }
        Boolean marked_cache = false;
        Editor_Tile tempTile;
        Editor_Entity tempEnt;
        void restart_Engine()
        {
            Scheduler.CloseEngineAndScheduler();
            EngFun.engine_open(ScriptToLoad + " -nx 250", null);
            EngVar.fps_max = 60;
            EngVar.d3d_lodfactor.vec_set(new Vector(5, 10, 20));
            EngVar.camera.clip_near = 1;
            EngVar.camera.clip_far = 50000;
            EngVar.camera.arc = 50;
            EngVar.max_entities = 10000;

            EngVar.preload_mode = 1;
            EngVar.d3d_antialias = 9;
            EngVar.d3d_anisotropy = 3;
         
            EngVar.d3d_mipmapping = 3;
            EngFun.video_window(null, null, 256, null);
            EngFun.video_set(engine_Window.Width, engine_Window.Height,0,0);
            EmbedWindow();
            resetEngine = true;
            loadNow = true;
            Scheduler.StartScheduler(myMainMethod);

        }
        bool resetEngine = true;
        private static BMAP tileTexture_BMAP;
        private IEnumerable<ScheduleMethod> createNewMap()
        {
            loadProcess = 0;
            i = 0;
           
            EngVar.you = ENTITY.ent_next(null);
            List<IntPtr> entityList_ = new List<IntPtr>();

            while (EngVar.you != null)
            {
                if (EngVar.you.str_for_entfile() != null)
                {
                    {
                        EngVar.you.INVISIBLE = true;
                    }
                }
                EngVar.you = ENTITY.ent_next(EngVar.you);
          
            }

            if (Fog.Visible == true)
            {
                Fog.BeginInvoke(new Action(() =>
                {
                    Fog.Visible = false;

                })
                );
            }
            if (Editor_Sky.Visible == true)
            {
                Editor_Sky.BeginInvoke(new Action(() =>
                {
                    Editor_Sky.Visible = false;

                })
                );
            }
            if (Sunlight.Visible == true)
            {
                Sunlight.BeginInvoke(new Action(() =>
                {
                    Sunlight.Visible = false;

                })
                );
            }
             if (EntityPosition.Visible == true)
            {
                EntityPosition.BeginInvoke(new Action(() =>
                {
                    EntityPosition.Visible = false;

                })
                );
            }
             if (Editor_Speed.Visible == true)
            {
                Fog.BeginInvoke(new Action(() =>
                {
                    Editor_Speed.Visible = false;

                })
                );
            }

            int latestID = findLatestID(0, current_Map_Object);
            int latestIDEntity = findLatestIDEntity(0, current_Map_Object);
            Boolean[] allNormalMaps = new Boolean[latestID];
            String[] allTextures = new String[latestID];

            List<Editor_Entity> allEntities = new List<Editor_Entity>();
            for (i = 0; i < latestID; i++)
            {

                allTextures[i] = "";
                allNormalMaps[i] = false;
            }
            for (i = 0; i < latestIDEntity; i++)
            {

                allEntities.Add(new Editor_Entity(-1));
            }
            foreach (Editor_Tile tile_ in current_Map_Object.tileList)
            {
                allTextures[tile_.id - 1] = tile_.picture;
                allNormalMaps[tile_.id - 1] = tile_.normalMap;
            }
            current_Map_Object.entityList.Sort(new Comparison<Editor_Entity>((x, y) => x.id.CompareTo(y.id)));
            foreach (Editor_Entity entity_ in current_Map_Object.entityList)
            {
                allEntities[(int)entity_.id - 1].id = entity_.id;
                allEntities[(int)entity_.id - 1].lightStrength = entity_.lightStrength;
                allEntities[(int)entity_.id - 1].lightRange_Value.x = entity_.lightRange_Value.x;
                allEntities[(int)entity_.id - 1].lightRange_Value.y = entity_.lightRange_Value.y;
                allEntities[(int)entity_.id - 1].lightRange_Value.z = entity_.lightRange_Value.z;
                allEntities[(int)entity_.id - 1].position = entity_.position;
                
            }
            EngVar.tex_share = 1;
            EngVar.you = ENTITY.ent_next(null);
            while (EngVar.you != null)
            {
                if (EngVar.you.ent_getskin(1) != null)EngVar.you.ent_getskin(1).bmap_purge();
                EngVar.you.material = null;
                EngVar.you.ent_remove();


                EngVar.you = ENTITY.ent_next(EngVar.you);

            } 
            yield return ScheduleMethod.wait(1);
                if (marked_cache == true)
                {
                    EngFun.level_free();
                    EngFun.level_load(null);
                    marked_cache = false;
                    
                }

            entityList_.Clear();
            entityList_ = null;
            
            yield return ScheduleMethod.wait(1);
            if (current_Map_Object.mapDesignation.Equals("Empty"))
            {
                yield break;
            }

            if (marked_cache == false)
            {
                EngFun.level_mark();
                marked_cache = true;
            }
            if (current_Map_Object.fog_Color > 0)
            {
                EngVar.fog_color = (double)current_Map_Object.fog_Color;
                EngVar.camera.fog_start = (double)current_Map_Object.fog_Begin;
                EngVar.camera.fog_end = (double)current_Map_Object.fog_End;
            }
            else
            {
                EngVar.fog_color = 0;
            }

            if (skyEntity != null) { skyEntity.INVISIBLE = true; if (skyEntity.ent_getskin(1) != null) skyEntity.ent_getskin(1).bmap_purge(); skyEntity.ent_purge(); skyEntity.ent_remove(); skyEntity.ptr_remove(); }
            if (groundEntity != null)
            {
                groundEntity.INVISIBLE = true; if (groundEntity.ent_getskin(1) != null) groundEntity.ent_getskin(1).bmap_purge(); groundEntity.ent_purge(); groundEntity.ent_remove(); groundEntity.ptr_remove();
            }
            foreach (Editor_Tile tile_ in current_Map_Object.tileList)
            {
                tempTile = tile_;
                if (tile_.tileType == 1)
                {

                     ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Tiles\\Tile.mdl", new Vector((double)tile_.position.x, (double)tile_.position.y, (double)tile_.position.z), block_Mode_Load);


                    
                }
                else
                    if (tile_.tileType == 2)
                    {
                        ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Tiles\\TileFlat.mdl", new Vector((double)tile_.position.x, (double)tile_.position.y, (double)tile_.position.z), block_Mode_Load);
                    }
                    else
                        if (tile_.tileType == 3)
                        {
                            ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Tiles\\Cylinder.mdl", new Vector((double)tile_.position.x, (double)tile_.position.y, (double)tile_.position.z), block_Mode_Load);
                        }
                        else
                            if (tile_.tileType == 4)
                            {
                                ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Tiles\\FlatCylinder.mdl", new Vector((double)tile_.position.x, (double)tile_.position.y, (double)tile_.position.z), block_Mode_Load);
                            }
                            else
                                if (tile_.tileType == 5)
                                {
                                    ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Tiles\\StepFlat.mdl", new Vector((double)tile_.position.x, (double)tile_.position.y, (double)tile_.position.z), block_Mode_Load);
                                }
                                else
                                    if (tile_.tileType == 6)
                                    {
                                        ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Tiles\\StepFlat.mdl", new Vector((double)tile_.position.x, (double)tile_.position.y, (double)tile_.position.z), block_Mode_Load);
                                    }
                                    else
                                        if (tile_.tileType == 7)
                                        {
                                            ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Tiles\\Obstacle.mdl", new Vector((double)tile_.position.x, (double)tile_.position.y, (double)tile_.position.z), block_Mode_Load);
                                        }
            }
            
            tempTile = null;
            foreach (Editor_Entity entity_ in current_Map_Object.entityList)
            {
                tempEnt = entity_;
                if (File.Exists(yed_Ptr.returnPath() + "\\Models\\" + tempEnt.model))
                {
                   
                   tempEntity = ENTITY.ent_create(tempEnt.model, new Vector((double)tempEnt.position.x, (double)tempEnt.position.y, (double)tempEnt.position.z), click_and_move_Load);
                
                }
                else
                {
                    MessageBox.Show("There was a problem during the loading process. The model with the name " + tempEnt.model + " was not found within the model folder. The affected Entity was not loaded.", "Loading Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
            currentMap = mapToChoose;
            this.BeginInvoke(new Action(() =>
            {
                if (current_Map_Object.mapDesignation.Equals("Empty") == false)
                    this.Text = "YED - " + current_Map_Object.mapDesignation;
                else
                    this.Text = "YED - No active map";

            })
            );
            EngVar.camera.x = 0;
            EngVar.camera.y = 0;
            EngVar.camera.z = 1000;
            EngVar.camera.pan = 0;
            EngVar.camera.tilt = -90;
            EngVar.camera.roll = 0;
            bool foundSky = false;
            bool foundGround = false;

            EngVar.you = ENTITY.ent_next(null);
            while (EngVar.you != null)
            {

                if (EngVar.you.str_for_entname().Equals("ENVITUBE.MDL"))
                        {
                            foundSky = true;
                            skyEntity = EngVar.you;
                            if (current_Map_Object.skyTexture != "")
                            {
                            }
                        }
                        else

                    if (EngVar.you.str_for_entname().Equals("8x8.mdl") || EngVar.you.str_for_entname().Equals("16x16.mdl") || EngVar.you.str_for_entname().Equals("32x32.mdl") || EngVar.you.str_for_entname().Equals("64x64.mdl"))
                            {
                                foundGround = true;
                            }

  

                EngVar.you = ENTITY.ent_next(EngVar.you);

            }
            if (foundSky == false)
            {
                skyEntity = ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Templates\\EnviTube.mdl", new Vector(0, 0, current_Map_Object.skyAttributes.position_z_Sky), sky_Mode);
                skyEntity.scale_x = current_Map_Object.skyAttributes.scale_Sky;
                skyEntity.scale_y = current_Map_Object.skyAttributes.scale_Sky;
                skyEntity.scale_z = current_Map_Object.skyAttributes.scale_Sky;
                if (!current_Map_Object.skyAttributes.texture_Sky.Equals("") && current_Map_Object.skyAttributes.noSky == false)
                {
                    BMAP tempBMAP = BMAP.bmap_create(current_Map_Object.skyAttributes.texture_Sky);
                    skyEntity.ent_setskin(tempBMAP, 1);
                    Editor_Sky.hideSky_checkBox.Checked = false;
                }
                if (Editor_Sky.hideSky_checkBox.Checked == true)
                {
                    skyEntity.INVISIBLE = true;
                }
            }
            yield return ScheduleMethod.wait(1);
            if (foundGround == false && !current_Map_Object.size.Equals("Custom"))
            {

                if (current_Map_Object.size.Equals("8"))
                {
                    groundEntity = ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Templates\\8x8.mdl", new Vector(), null);
                }
                if (current_Map_Object.size.Equals("16"))
                {
                    groundEntity = ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Templates\\16x16.mdl", new Vector(), null);
                }
                if (current_Map_Object.size.Equals("32"))
                {
                    groundEntity = ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Templates\\32x32.mdl", new Vector(), null);
                }
                if (current_Map_Object.size.Equals("64"))
                {
                    groundEntity = ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Templates\\32x32.mdl", new Vector(), null);
                }

                groundEntity.material = MATERIAL.mtl_create();
                groundEntity.group = 4;
                groundEntity.ent_setskin(BMAP_DICTIONARY["YRPG_Template_Grid_Line.png"], 1);
                groundEntity.skills[19] = 1;
            }
            else
            {
                foreach (Editor_Grid grid_ in current_Map_Object.gridLine)
                {
                  
                    ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Tiles\\TileFlat.mdl", new Vector((double)grid_.position.x, (double)grid_.position.y, 0), ground_Entity);

                }
                

            }
            loadProcess++;
            this.Sunlight.reloadSun();

         
            allNormalMaps =  null;
           allTextures = null;

            allEntities.Clear();
           

            loadProcess = 100;
            yield return ScheduleMethod.wait(5);
            current_Map_Object.ground = true;
            button3.BeginInvoke(new Action(() =>
            {
                button3.Enabled = true;
            })
        );
            yield return ScheduleMethod.wait(1);

        }


        private void newMapButton_Click(object sender, EventArgs e)
        {
            string value = " ";
            if (Editor_Input.InputBoxMap("Create New Map", "Designation:", ref value) == DialogResult.OK)
            {
                if (checkWinFormat(value) == false)
                {
                    MessageBox.Show("The entered designation contains illegal characters. Please avoid the using of  \\ / : * ? \" < > |");
                    return;
                }
               
                if (File.Exists(yed_Ptr.returnPath() + "\\Maps\\" + value + ".wmb"))
                {
                    MessageBox.Show("There is already a Yume Map with the designation '" + value + "'. Please change the designation or delete the existing map in order to create a map");
                    return;
                }
            }

        }
        bool found = false;
        bool checkEntitiesForHeroes = false;
        private IEnumerable<ScheduleMethod> checkEntForPlayerFlag()
        {
            EngVar.you = ENTITY.ent_next(null);
            while (EngVar.you != null)
            {

                if (EngVar.you.skills[17] == 1)
                {

                 
                    found = true;
                    checkEntitiesForHeroes = false;
                    break;

                }
                EngVar.you = ENTITY.ent_next(EngVar.you);


            }
            found = false;

            yield return ScheduleMethod.wait(1);
        }

        private IEnumerable<ScheduleMethod> entityPlayer_Scheduling()
        {
            if (selectedEntity.Text != "NONE")
            {
                if (flyingEntity != null && Place_Mode_checkBox.Checked == true)
                {
                    if (entity_Player.Checked == true)
                        flyingEntity.skills[17] = 1;
                    else
                        if (entity_Player.Checked == false)
                            flyingEntity.skills[17] = 0;
                }
                if (tempEntity != null && Place_Mode_checkBox.Checked == false)
                {
                    if (entity_Player.Checked == true)
                    {
                        tempEntity.skills[17] = 1;
                        if (tempEntity_YRPGObject != null)
                        {
                            tempEntity_YRPGObject.flags.player = 1;
                            saveTempEntity();
                        }
                    }
                    else
                        if (entity_Player.Checked == false)
                        {
                            tempEntity.skills[17] = 0;
                            if (tempEntity_YRPGObject != null)
                            {
                                tempEntity_YRPGObject.flags.player = 0;
                                saveTempEntity();
                            }
                        }
                }
            }
            entity_Player.BeginInvoke(new Action(() =>
            {
                entity_Player.Enabled = true;
            }
            )
            );
            yield break;
                
        }

        private void entity_Player_CheckedChanged(object sender, EventArgs e)
        {
            entity_Player.Enabled = false;
            Scheduler.AddEventVoidThreadSafe(entityPlayer_Scheduling);
        
          
        }
        TextDatei itemFile = new TextDatei();
        public void writeTextureScript()
        {

        }

        public Editor_Object findMap()
        {
            foreach (String map_ in allMaps)
            {
                ymap ymapTemp = DeserializeXmlToYMAP(yed_Ptr.returnPath() + "\\Maps\\" + map_ + ".ymp");
                Editor_Object object_ = ymapTemp.Editor_Object_Save;

            
                    if (object_.mapDesignation.Equals(currentMap))
                    {
                        return object_;
                    }
              
            }
            return null;
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            if (stepTile.Checked == true)
            {
                CubeTile.Checked = false;
                flatCubeTile.Checked = false;
                CylinderTile.Checked = false;
                flatCylinderTile.Checked = false;

                flatStepTile.Checked = false;
                stepTile.Checked = true;
                obstacleTile.Checked = false;
            }
        }

        private void checkBox3_CheckedChanged(object sender, EventArgs e)
        {
            if (flatStepTile.Checked == true)
            {
                CubeTile.Checked = false;
                flatCubeTile.Checked = false;
                CylinderTile.Checked = false;
                flatCylinderTile.Checked = false;
                stepTile.Checked = false;
                flatStepTile.Checked = true;
                obstacleTile.Checked = false;
            }
        }

        BMAP tempTexture;
        private void scale_Block_ValueChanged(object sender, EventArgs e)
        {

            scaleGlobalBlock = Convert.ToDouble(scaleZ_Block.Value);
            if (tempEntity != null && Place_Mode_checkBox.Checked == false)
            {
                tempEntity.scale_z = Convert.ToDouble(scaleZ_Block.Value);

                foreach (Editor_Tile object_ in current_Map_Object.tileList)
                {
                    if (object_.id == tempEntity.skills[18])
                    {
                        object_.tileZ = tempEntity.scale_z;
                        return;
                    }

                }


            }


        }
        double lightRange_Temp = 0;
        double lightRange_Red = 0;
        double lightRange_Green = 0;
        double lightRange_Blue = 0;
        private void entityLightrange_trackbar_Scroll(object sender, EventArgs e)
        {
            entityLightrange_Label.Text = "" + entityLightrange_trackbar.Value;
            if (selectedEntity.Text != "NONE")
            {
                if (flyingEntity != null && Place_Mode_checkBox.Checked == true)
                {
                    flyingEntity.lightrange = entityLightrange_trackbar.Value;
                }
                if (tempEntity != null && Place_Mode_checkBox.Checked == false)
                {
                    if (tempEntity_YRPGObject != null) tempEntity_YRPGObject.lightStrength = entityLightrange_trackbar.Value;
                    tempEntity.lightrange = entityLightrange_trackbar.Value;
                    saveTempEntity();
                }
            }
            lightRange_Temp = (double)entityLightrange_trackbar.Value;
        }

        private void label10_Click(object sender, EventArgs e)
        {
    
        }



        private void textureView_Click(object sender, EventArgs e)
        {
            Scheduler.AddEventVoid(resetTempEntity);
        }

        private void randomScale_Checkbox_CheckedChanged(object sender, EventArgs e)
        {
            if (randomScale_Checkbox.Checked == true)
            {
                entityMaxScale.Enabled = true;
            }
            else
            {
                entityMaxScale.Enabled = false;
            }
        }

        private void actionSpeedToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void optionsToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void checkBox4_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void entityMaxScale_ValueChanged(object sender, EventArgs e)
        {
            if (entityMaxScale.Value < entityScale.Value)
            {
                entityMaxScale.Value = entityScale.Value;
            }
        }

        private void checkBox2_CheckedChanged_1(object sender, EventArgs e)
        {

        }
        private IEnumerable<ScheduleMethod> entWavingGras_Scheduling()
        {
            if (selectedEntity.Text != "NONE")
            {
                if (flyingEntity != null && Place_Mode_checkBox.Checked == true)
                {
                    if (ent_WavingGras_checkBox.Checked == true)
                    {

                    }
                    else
                        if (ent_WavingGras_checkBox.Checked == false)
                        {

                        }
                }
                if (tempEntity != null && Place_Mode_checkBox.Checked == false)
                {
                    if (ent_WavingGras_checkBox.Checked == true)
                    {
                        tempEntity.skills[16] = 1;


                        tempEntity.raw_skill41 = EngFun.floatv(50);
                        tempEntity.raw_skill42 = EngFun.floatv(50);
                        tempEntity.raw_skill43 = EngFun.floatv(50);
                        tempEntity.raw_skill44 = EngFun.floatv(50);
                        tempEntity.material = gras_Mat;

                        if (tempEntity_YRPGObject != null)
                        {
                            tempEntity_YRPGObject.flags.gras = 1;
                            saveTempEntity();
                        }
                    }
                    else
                        if (ent_WavingGras_checkBox.Checked == false)
                        {
                            tempEntity.skills[16] = 0;
                            tempEntity.material = MATERIAL.mtl_create();
                            if (tempEntity_YRPGObject != null)
                            {
                                tempEntity_YRPGObject.flags.gras = 0;
                                saveTempEntity();
                            }
                        }
                }
            }
            ent_WavingGras_checkBox.BeginInvoke(new Action(() =>
            {
                ent_WavingGras_checkBox.Enabled = true;

            })
            );
            yield break;

        }
        private void entWavingGras_CheckedChanged(object sender, EventArgs e)
        {
            ent_WavingGras_checkBox.Enabled = false;
            Scheduler.AddEventVoid(entWavingGras_Scheduling);
         
        }

        TreeNode tempNode = null;
        private void newOneToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string value = " ";
            string a = "";
            if (Editor_Input.InputBox("Create Map Container", "Designation:", ref value) == DialogResult.OK)
            {
                if (tempNode == null) mapTree.SelectedNode = null;
                if (checkWinFormat(value) == false)
                {
                    MessageBox.Show("The entered designation contains illegal characters. Please avoid the using of  \\ / : * ? \" < > |");
                    return;
                }
        

                foreach (TreeNode node in mapTree.Nodes)
                {
                    if (node.Text.Equals(value))
                    {
                        MessageBox.Show("The project already contains a map container with this designation. Please choose another designation.");
                        return;
                    }
                }
                if (mapTree.SelectedNode != null)
                {
                    mapTree.SelectedNode.Nodes.Add(value.Trim());
                }
                else
                {
                    mapTree.Nodes.Add(value.Trim());
                }
            }
        }
        public  List<String> SaveNodes(TreeNode node)
        {
            List<String> container_ = new List<String>();
            container_.Add(node.Text);
            while (true)
            {
                if (node.Parent != null)
                {
                    container_.Add(node.Parent.Text);
                    node = node.Parent;
                }
                else
                    break;


            }
            container_.Reverse();
            return container_;
        }
        bool foundTree = false;
        private void checkNodeExists(TreeView tree, String name)
        {

            foreach (TreeNode child in tree.Nodes)
            {

                MessageBox.Show(child.Text);
                if (child.Text.Contains(".ymp"))
                {

                    if (child.Text.Substring(0, child.Text.Length - 5).Equals(name.Trim()))
                    {
                        MessageBox.Show("There is already a YED Map with the designation '" + name + "'. Please change the designation or delete the existing map in order to create a map");
                        foundTree = true;
                        return;
                    }
                }
                else
                    if (checkNodeExists(child.Nodes, name) == true) return;
            }
            foundTree = false;

        }
        private bool checkNodeExists(TreeNodeCollection tree, String name)
        {

            foreach (TreeNode child in tree)
            {
                if (foundTree) return true;
                MessageBox.Show(child.Text);
                if (child.Text.Contains(".ymp"))
                {

                    if (child.Text.Substring(0, child.Text.Length - 5).Equals(name.Trim()))
                    {
                        MessageBox.Show("There is already a YED Map with the designation '" + name + "'. Please change the designation or delete the existing map in order to create a map");
                        foundTree = true;
                        return true;

                    }
                }
                else
                    checkNodeExists(child.Nodes, name);
            }
            return false;

        }
        private void createToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Editor_Object tempMap = new Editor_Object();
            tempMap.mapDesignation = "DummyMap.ymp";
            prop_On = true;
            Editor_Map_Properties Editor_Map_Properties_ = new Editor_Map_Properties(yed_Ptr, tempMap, true, mapTree.SelectedNode);
            Editor_Map_Properties_.Show();
            this.Enabled = false;
        }

        public void setTreeIcons()
        {
            TreeNodeCollection nodes = mapTree.Nodes;

            foreach (TreeNode node in nodes)
            {
                if (node.Text.Contains(".ymp"))
                {
                    node.ImageIndex = 1;

                }
                else
                    node.ImageIndex = 0;

                TreeNodeCollection subnodes = node.Nodes;
                setTreeIcons(subnodes);
            }
        }

        public void setTreeIcons(TreeNodeCollection nodes)
        {


            foreach (TreeNode node in nodes)
            {
                if (node.Text.Contains(".ymp"))
                {
                    node.ImageIndex = 1;

                }
                else
                    node.ImageIndex = 0;

                TreeNodeCollection subnodes = node.Nodes;
                setTreeIcons(subnodes);
            }

        }
        private void contextMenuStrip1_Opening(object sender, CancelEventArgs e)
        {
           
            if(mapTree.SelectedNode != null)
            if (mapTree.SelectedNode.Text.EndsWith(".ymp"))
            {
                copyToolStripMenuItem.Enabled = true;
                pasteToolStripMenuItem.Enabled = false;
                createYMAPToolStripMenuItem.Enabled = false;
                MapContainerToolStripMenuItem.Enabled = false;
              
                removeYMAPToolStripMenuItem1.Enabled = true;
                removeMapContainerToolStripMenuItem.Enabled = false;
                newMapContainerToolStripMenuItem.Enabled = false;
                renameToolStripMenuItem.Enabled = false;
                pasteToolStripMenuItem.Enabled = false;
                
            }else
                if (mapTree.SelectedNode != null && !mapTree.SelectedNode.Text.EndsWith(".ymp"))
            {
                copyToolStripMenuItem.Enabled = false;
                pasteToolStripMenuItem.Enabled = true;
                YMAPToolStripMenuItem.Enabled = true;
              
                removeYMAPToolStripMenuItem1.Enabled = false;
                createYMAPToolStripMenuItem.Enabled = true;
                MapContainerToolStripMenuItem.Enabled = true;
                newMapContainerToolStripMenuItem.Enabled = false;
                removeMapContainerToolStripMenuItem.Enabled = true;
                
                renameToolStripMenuItem.Enabled = true;
            }
            if (mapTree.SelectedNode == null)
            {
                copyToolStripMenuItem.Enabled = false;
                pasteToolStripMenuItem.Enabled = false;
                YMAPToolStripMenuItem.Enabled = false;
              
                removeYMAPToolStripMenuItem1.Enabled = false;
                createYMAPToolStripMenuItem.Enabled = false;
                MapContainerToolStripMenuItem.Enabled = true;
                newMapContainerToolStripMenuItem.Enabled = true;
                removeMapContainerToolStripMenuItem.Enabled = false;
                renameToolStripMenuItem.Enabled = false;

            }
            if(current_Map_Object !=  null)
                if(mapTree.SelectedNode != null) 
            if (initializedMap && mapTree.SelectedNode.Text.Equals(current_Map_Object.mapDesignation + ".ymp"))
          
              
                {
                    propertiesToolStripMenuItem.Enabled = true;
                }
           
            else
            {
                propertiesToolStripMenuItem.Enabled = false;
            }
            if(mapTree.SelectedNode != null)
            if (mapToCopy != null && mapTree.SelectedNode.Text.EndsWith(".ymp") ) pasteToolStripMenuItem.Enabled = false;
            else
                pasteToolStripMenuItem.Enabled = true;

        }

        private void renameToolStripMenuItem1_Click(object sender, EventArgs e)
        {

            String tempString = mapTree.SelectedNode.Text;
            string value = " ";
            if (Editor_Input.InputBox("Rename Map", "Designation:", ref value) == DialogResult.OK)
            {
                if (checkWinFormat(value) == false)
                {
                    MessageBox.Show("The entered designation contains illegal characters. Please avoid the using of  \\ / : * ? \" < > |");
                    return;
                }
           
                if (value.Trim().Equals(""))
                {

                    return;
                }
                foreach (String object_ in allMaps)
                {
                    ymap ymapObject = DeserializeXmlToYMAP(yed_Ptr.returnPath() + "\\Maps\\" + object_ + ".ymp");
                    Editor_Object map = ymapObject.Editor_Object_Save;

                 
                        if (map.mapDesignation.Equals(value))
                        {
                            MessageBox.Show("There is already a Yume Map with the designation '" + value + "'. Please change the designation or delete the existing map in order to create a map");
                            return;
                        }
                }

            }
            String tempNumber = mapTree.SelectedNode.Text;
            tempNumber = tempNumber.Substring(0, 4);

            mapTree.SelectedNode.Text = tempNumber+"_"+(value + ".ymp");
            int j = 0;
            for (int x = 0; x < allMaps.Count; x++)
            {
                if (allMaps[x].Equals(tempString.Substring(0, tempString.Length - 5)))
                {
                    ymap renameMap = DeserializeXmlToYMAP(yed_Ptr.returnPath() + "\\Maps\\" + allMaps[x] + ".ymp");
                    renameMap.Editor_Object_Save.mapDesignation = tempNumber+"_"+ value;
                    SerializeYMAPToXML(renameMap, yed_Ptr.returnPath() + "\\Maps\\temp_" +separateMimeType(tempString) + ".ymp");
                    if (currentMap != null)
                        if (currentMap.Equals(tempString))
                        {
                            currentMap = tempNumber + "_" + value + ".ymp";
                            this.Text = "YED - " + current_Map_Object.mapDesignation;
                        }
                }

                for (j = 0; j < allMaps.Count; j++)
                {
                    if (allMaps[j].Equals(tempString))
                    {
                        allMaps[j] = tempNumber + "_" + value;

                    }

                }
                
            }
            if(current_Map_Object != null)
            if(current_Map_Object.mapDesignation.Equals(tempString))
            {
            current_Map_Object.mapDesignation = tempNumber+"_"+value;
            ymap tempMap = new ymap();
            tempMap.Editor_Object_Save = current_Map_Object;
            SerializeYMAPToXML(tempMap, yed_Ptr.returnPath() + "\\Maps\\temp_" + tempString + ".ymp");
            }
            if(this.Text.Equals("YED - " + separateMimeType(tempString))){
                this.Text = "YED - " + current_Map_Object.mapDesignation;
            }
        }
        public IEnumerable<ScheduleMethod> searchSky()
        {
            if(current_Map_Object!= null)
            if (skyEntity != null)
                if (Editor_Sky.hideSky_checkBox.Checked == true)
                {
                    skyEntity.INVISIBLE = true;
                    current_Map_Object.skyAttributes.noSky = true;
                }
                else
                {
                    skyEntity.INVISIBLE = false;
                    current_Map_Object.skyAttributes.noSky = false;
                }



            yield return ScheduleMethod.wait(1);
        }

        public IEnumerable<ScheduleMethod> assignSkyTexture()
        {
            if (skyTexture.Equals("") || skyEntity == null) yield break;
            skyEntity.ent_setskin(BMAP_SKY_DICTIONARY[skyTexture], 1);
            if (current_Map_Object != null)
            {
                current_Map_Object.skyAttributes.texture_Sky = skyTexture;
            }

            yield break;
        }

        private void removeToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            var result = MessageBox.Show("Do you really want to delete this map?", "Delete Map", MessageBoxButtons.OKCancel);
            if (result == DialogResult.OK)
            {

                for (int x = 0; x < allMaps.Count; x++)
                {
               
                    if (allMaps[x].Equals(StringHelper.separateMimeType(mapTree.SelectedNode.Text)))
                    {
                        allMaps.RemoveAt(x);
                    }
                }

                if (currentMap != null)
                    if ((currentMap).Equals(mapTree.SelectedNode.Text))
                    {
                        Editor_Object EmptyMap = new Editor_Object("Empty", "null");
                        current_Map_Object = EmptyMap;
                        initializedMap = false;
                        Scheduler.AddEventVoidThreadSafe(createNewMap);
                    }
                if (currentMap == null)
                {
                    Editor_Object EmptyMap = new Editor_Object("Empty", "null");
                    current_Map_Object = EmptyMap;
                    initializedMap = false;
                    Scheduler.AddEventVoidThreadSafe(createNewMap);
                }
                mapTree.SelectedNode.Remove();
                yedMainObject.YMAP_LIST = allMaps;
             
            }
        }

        private void renameToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void removeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            DialogResult result = MessageBox.Show("Do you really want to delete this Map Container and all of its Map Containers and Maps?", "Delete Container", MessageBoxButtons.OKCancel, MessageBoxIcon.Question);

            if (result == DialogResult.OK)
            {

                    for(int i = 0; i < allMaps.Count; i++)
                {
                    ymap tempYMAP = DeserializeXmlToYMAP(yed_Ptr.returnPath() + "\\Maps\\" + allMaps[i] + ".ymp");
                    Editor_Object map = tempYMAP.Editor_Object_Save;


            

                    if (map.mapContainer[mapTree.SelectedNode.Level].Equals(mapTree.SelectedNode.Text))
                    {

                        File.Delete(yed_Ptr.returnPath() + "\\Maps\\" + allMaps[i] + ".wmp");
                        File.Delete(yed_Ptr.returnPath() + "\\Maps\\" + allMaps[i] + ".wmb");
                        File.Delete(yed_Ptr.returnPath() + "\\Maps\\" + allMaps[i] + ".$$m");
                        File.Delete(yed_Ptr.returnPath() + "\\Maps\\" + allMaps[i] + ".$$w");
                        File.Delete(yed_Ptr.returnPath() + "\\Maps\\" + allMaps[i] + ".ymp");
                        allMaps.RemoveAt(i);
                        i = -1;

                    }
               
            }
                mapTree.SelectedNode.Remove();
                mapTree.SelectedNode = null;
                yedMainObject.YMAP_LIST = allMaps;

                SerializeYEDToXML(yedMainObject, yed_Ptr.returnPath() + "\\Maps\\" + justProjectTitle() + ".ymp");
            }

        }
        private int findLatestID(int latestNumber, Editor_Object object_)
        {
            foreach (Editor_Tile tiles in object_.tileList)
            {
                if (tiles.id > latestNumber)
                {
                    return findLatestID(tiles.id, object_);
                }
            }
            return latestNumber;
        }

        private int findLatestIDEntity(int latestNumber,Editor_Object object_)
        {
            foreach (Editor_Entity entity_ in object_.entityList)
            {
                if (entity_.id > latestNumber)
                {
                    return findLatestIDEntity((int)entity_.id, object_);
                }
            }
            return latestNumber;
        }
        private void entityRotationToolStripMenuItem_Click(object sender, EventArgs e)
        {
            EntityPosition.Visible = true;
        }

        private void speedSettingsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Editor_Speed.Show();
        }

        private void sunToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Sunlight.Visible = true;
        }

        private void fogToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            Fog.Visible = true;
            if (current_Map_Object != null)
            {
                Fog.trackBar1.Value = current_Map_Object.fog_Begin;
                Fog.trackBar2.Value = current_Map_Object.fog_End;
                Fog.comboBox1.SelectedIndex = current_Map_Object.fog_Color;
            }
        }

        private void texture32x32_radioButton_CheckedChanged(object sender, EventArgs e)
        {
            if (texture32x32_radioButton.Checked == true)
            {
                texture_width = 32;
                reloadTextureList();
            }
       
        }

        private void texture64x64_radioButton_CheckedChanged(object sender, EventArgs e)
        {
            if (texture64x64_radioButton.Checked == true)
            {
                texture_width = 64;
                reloadTextureList();
            }
         
        }

        private void texture96x96_radioButton_CheckedChanged(object sender, EventArgs e)
        {
            if (texture96x96_radioButton.Checked == true)
            {
                texture_width = 96;
                reloadTextureList();
            }
          
        }

        private void texture128x128_radioButton_CheckedChanged(object sender, EventArgs e)
        {
            if (texture128x128_radioButton.Checked == true)
            {
                texture_width = 128;
                reloadTextureList();
            }
            
        }

        private void radioButton2_CheckedChanged(object sender, EventArgs e)
        {
            reloadTextureList();
        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
        }

        private void skySettingToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Editor_Sky.Show();
        }



        private void mapTree_DragDrop(object sender, DragEventArgs e)
        {
            Point targetPoint = mapTree.PointToClient(new Point(e.X, e.Y));
            TreeNode targetNode = mapTree.GetNodeAt(targetPoint);
            TreeNode draggedNode = (TreeNode)e.Data.GetData(typeof(TreeNode));
            if (!draggedNode.Equals(targetNode) && targetNode != null)
            {
                draggedNode.Remove();
                targetNode.Nodes.Add(draggedNode);
                targetNode.Expand();
            }
        }



        private void mapTree_MouseDown(object sender, MouseEventArgs e)
        {

            tempNode = mapTree.GetNodeAt(e.X, e.Y);
            mapTree.SelectedNode = tempNode;

            if (mapTree.SelectedNode == null)
            {
                button3.Enabled = false;
                mapTree.SelectedImageIndex = 0;
                return;
            }
        }

        private void renameMapContainerToolStripMenuItem_MouseUp(object sender, MouseEventArgs e)
        {

        }

        private void renameMapContainerToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void renameMapContainerToolStripMenuItem_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void mapTree_Click(object sender, EventArgs e)
        {
           
        }

        private void mapTree_NodeMouseClick(object sender, TreeNodeMouseClickEventArgs e)
        {
            tempNode = mapTree.GetNodeAt(e.X, e.Y);
        }

        private void obstacleTile_CheckedChanged(object sender, EventArgs e)
        {
            if (obstacleTile.Checked == true)
            {
                CubeTile.Checked = false;
                flatCubeTile.Checked = false;
                CylinderTile.Checked = false;
                flatCylinderTile.Checked = false;
                flatStepTile.Checked = false;
                stepTile.Checked = false;
                obstacleTile.Checked = true;
            }

        }
        bool brushTiles = true;
        private void brushTiles_Button_Click(object sender, EventArgs e)
        {
            stepTile.Enabled = true;
            flatStepTile.Enabled = true;
            obstacleTile.Enabled = true;
            brushTiles = true;
            brushTiles_Button.ForeColor = System.Drawing.SystemColors.Highlight;
            fillTiles_Button.ForeColor = System.Drawing.SystemColors.ControlText;


        }

        private void fillTiles_Button_Click(object sender, EventArgs e)
        {

            stepTile.Checked = false;
            flatStepTile.Checked = false;
            obstacleTile.Checked = false;
            stepTile.Enabled = false;
            flatStepTile.Enabled = false;
            obstacleTile.Enabled = false;
            brushTiles = false;
            fillTiles_Button.ForeColor = System.Drawing.SystemColors.Highlight;
            brushTiles_Button.ForeColor = System.Drawing.SystemColors.ControlText;

        }
        private IEnumerable<ScheduleMethod> entUnlit_Scheduling()
        {
            if (selectedEntity.Text != "NONE")
            {
                if (flyingEntity != null && Place_Mode_checkBox.Checked == true)
                {
                    if (ent_Unlit_CheckBox.Checked == true)
                        flyingEntity.UNLIT = true;
                    else
                        if (ent_Unlit_CheckBox.Checked == false)
                            flyingEntity.UNLIT = false;
                }
                if (tempEntity != null && Place_Mode_checkBox.Checked == false)
                {
                    if (ent_Unlit_CheckBox.Checked == true)
                    {
                        tempEntity.UNLIT = true;
                        if (tempEntity_YRPGObject != null)
                        {
                            tempEntity_YRPGObject.flags.unlit = 1;
                            saveTempEntity();
                        }
                    }
                    else
                        if (ent_Unlit_CheckBox.Checked == false)
                        {
                            tempEntity.UNLIT = false;
                            if (tempEntity_YRPGObject != null)
                            {
                                tempEntity_YRPGObject.flags.unlit = 0;
                                saveTempEntity();
                            }
                        }
                }
            }
            ent_Unlit_CheckBox.BeginInvoke(new Action(() =>
            {
                ent_Unlit_CheckBox.Enabled = true;
            })
            );
            yield break;
        }
        private void ent_Unlit_CheckBox_CheckedChanged(object sender, EventArgs e)
        {
            ent_Unlit_CheckBox.Enabled = false;
            Scheduler.AddEventVoidThreadSafe(entUnlit_Scheduling);
        }

        private void lightRange_checkBox_CheckedChanged(object sender, EventArgs e)
        {
            if (lightRange_checkBox.Checked == false)
            {
                if (tempEntity_YRPGObject != null) tempEntity_YRPGObject.lightRange_Active = false;
                changeOwnColor_checkBox.Checked = false;
                changeOwnColor_checkBox.Enabled = false;
                lightRange_GroupBox.Enabled = false;
                entityLightrange_trackbar.Value = 0;
                entityLightrange_Label.Text = "0";
                entityLightrange_trackbar.Enabled = false;
                entityRedVecTrack.Value = 0;
                entityRedVecTrack.Enabled = false;
                entityRedValue.Text = "0";
                entityGreenVecTrack.Value = 0;
                entityGreenVecTrack.Enabled = false;
                entityGreenValue.Text = "0";
                entityBlueVecTrack.Value = 0;
                entityBlueVecTrack.Enabled = false;
                entityBlueValue.Text = "0";
                color_GroupBox.Enabled = false;
                saveTempEntity();
            }
            else
            {
                if (tempEntity_YRPGObject != null) tempEntity_YRPGObject.lightRange_Active = true;
                lightRange_GroupBox.Enabled = true;
                color_GroupBox.Enabled = true;
                entityLight_Groupbox.Enabled = true;
                entityLightrange_trackbar.Enabled = true;
                entityLightrange_Label.Enabled = true;
                entityLight_Groupbox.Enabled = true;
                changeOwnColor_checkBox.Checked = false;
                changeOwnColor_checkBox.Enabled = true;
                entityRedVecTrack.Enabled = true;
                entityGreenVecTrack.Enabled = true;
                entityBlueVecTrack.Enabled = true;
                saveTempEntity();

            }

        }

        private void changeOwnColor_checkBox_CheckedChanged(object sender, EventArgs e)
        {
            if (selectedEntity.Text != "NONE")
            {
                if (flyingEntity != null && Place_Mode_checkBox.Checked == true)
                {
                    if (changeOwnColor_checkBox.Checked == true)
                        flyingEntity.LIGHT = true;
                    else
                        if (changeOwnColor_checkBox.Checked == false)
                            flyingEntity.LIGHT = false;
                }
                if (tempEntity != null && Place_Mode_checkBox.Checked == false)
                {
                    if (changeOwnColor_checkBox.Checked == true)
                    {
                        tempEntity.LIGHT = true;
                        if (tempEntity_YRPGObject != null) tempEntity_YRPGObject.selfColor_Active = true;
                        saveEntity();
                    }
                    else
                        if (changeOwnColor_checkBox.Checked == false)
                        {
                            tempEntity.LIGHT = false;
                            if (tempEntity_YRPGObject != null) tempEntity_YRPGObject.selfColor_Active = false;
                            saveEntity();
                        }
                }
            }
        }

        void saveOptions()
        {

            YRPGMap_Options.entity_lift = Editor_Speed_Values.ent_Lift;
            YRPGMap_Options.entity_lift_fast = Editor_Speed_Values.ent_LiftFast;
            YRPGMap_Options.entity_move = Editor_Speed_Values.ent_Push;
            YRPGMap_Options.entity_move_fast = Editor_Speed_Values.ent_PushFast;
            YRPGMap_Options.entity_pan = Editor_Speed_Values.ent_Pan;
            YRPGMap_Options.entity_pan_fast = Editor_Speed_Values.ent_PanFast;
            YRPGMap_Options.map_lift = Editor_Speed_Values.map_Lift;
            YRPGMap_Options.map_Lift_fast = Editor_Speed_Values.map_LiftFast;
            YRPGMap_Options.map_move = Editor_Speed_Values.map_Move;
            YRPGMap_Options.map_move_fast = Editor_Speed_Values.map_MoveFast;
        }
        void loadOptions()
        {
            Editor_Speed_Values.ent_Lift = YRPGMap_Options.entity_lift;
            Editor_Speed_Values.ent_LiftFast = YRPGMap_Options.entity_lift_fast;
            Editor_Speed_Values.ent_Push = YRPGMap_Options.entity_move;
            Editor_Speed_Values.ent_PushFast = YRPGMap_Options.entity_move_fast;
            Editor_Speed_Values.ent_Pan = YRPGMap_Options.entity_pan;
            Editor_Speed_Values.ent_PanFast = YRPGMap_Options.entity_pan_fast;
            Editor_Speed_Values.map_Lift = YRPGMap_Options.map_lift;
            Editor_Speed_Values.map_LiftFast = YRPGMap_Options.map_Lift_fast;
            Editor_Speed_Values.map_Move = YRPGMap_Options.map_move;
            Editor_Speed_Values.map_MoveFast = YRPGMap_Options.map_move_fast;
        }

        private void save_Icon_Click(object sender, EventArgs e)
        {
            this.Enabled = false;

                    bool tempFound = false;
            string[] dirs = Directory.GetFiles(yed_Ptr.returnPath() + "\\Maps\\", "*.ymp");
            foreach (var file in dirs)
            {
                foreach (String maps in allMaps)
                {
                    if (maps.Equals(separateSlash(separateMimeType(file))))
                    {
                        tempFound = true;
                    }
                }
                if (tempFound == false)
                {
                    try
                    {
                        File.Delete(file);
                    }
                    catch (FileNotFoundException fnfe)
                    {

                    }
                }
            }

              for(int i = 0; i < allMaps.Count; i++)
            {
                if (File.Exists(yed_Ptr.returnPath() + "\\Maps\\temp_" + allMaps[i] + ".ymp"))
                {
                    ymap transferMap = DeserializeXmlToYMAP(yed_Ptr.returnPath() + "\\Maps\\temp_" + allMaps[i] + ".ymp");
                    if (!transferMap.Editor_Object_Save.mapDesignation.Equals(allMaps[i]))
                    {
                        SerializeYMAPToXML(transferMap, yed_Ptr.returnPath() + "\\Maps\\" + transferMap.Editor_Object_Save.mapDesignation + ".ymp");
                        allMaps[i] = transferMap.Editor_Object_Save.mapDesignation;
                    }
                    else
                    {
                        SerializeYMAPToXML(transferMap, yed_Ptr.returnPath() + "\\Maps\\" + allMaps[i] + ".ymp");
                        File.Delete(yed_Ptr.returnPath() + "\\Maps\\temp_" + allMaps[i] + ".ymp");
                    }
                }
                  if(current_Map_Object != null)
                  if(current_Map_Object.mapContainer != null)
                if (!current_Map_Object.mapDesignation.Equals("") && !current_Map_Object.mapContainer.Equals(""))
                {
                    ymap tempMap = new ymap();
                    tempMap.Editor_Object_Save = current_Map_Object;
                    SerializeYMAPToXML(tempMap,yed_Ptr.returnPath() + "\\Maps\\"+current_Map_Object.mapDesignation+".ymp");

                }
              
            }
         
           dirs = Directory.GetFiles(yed_Ptr.returnPath() + "\\Maps\\", "*.ymp");
            foreach (var file in dirs)
            {
                if ((separateSlash(file)).StartsWith("temp_"))
                {
                    foreach (String maps in allMaps)
                    {
                        if (separateSlash(separateMimeType(file)).Equals("temp_" + maps))
                        {
                            File.Delete(file); break;
                        }
                        
                    }
                

                }

     

            }
            yedMainObject.Editor_Options_Save = YRPGMap_Options;
            yedMainObject.Editor_Speed_Values_Save = Editor_Speed_Values;
            yedMainObject.YMAP_LIST = allMaps;
            SerializeYEDToXML(yedMainObject, yed_Ptr.returnPath() + "\\Maps\\" + justProjectTitle() + ".yed");
            writeTextureScript();
            saveOptions();
            saveNow = false;
          
            this.Enabled = true;
        }

        private void config_Icon_Click(object sender, EventArgs e)
        {
            if (Editor_Speed.Visible == true)
                  Editor_Speed.Visible = false;
            else
                Editor_Speed.Visible = true;
        }

        private void entityRotation_Icon_Click(object sender, EventArgs e)
        {
            if(EntityPosition.Visible  == true)
                EntityPosition.Visible = false;
            else
            EntityPosition.Visible = true;
        }

        private void sun_Icon_Click(object sender, EventArgs e)
        {
            if (Sunlight.Visible == true)
                Sunlight.Visible = false;
            else
            Sunlight.Visible = true;
        }

        private void fog_Icon_Click(object sender, EventArgs e)
        {
            if (Fog.Visible == true)
            {
                Fog.Visible = false;
            }
            else
            {
                Fog.Visible = true;
                if (current_Map_Object != null)
                {
                    Fog.trackBar1.Value = current_Map_Object.fog_Begin;
                    Fog.trackBar2.Value = current_Map_Object.fog_End;
                    Fog.comboBox1.SelectedIndex = current_Map_Object.fog_Color;
                    Fog.fogBeginText.Text = Fog.trackBar1.Value.ToString();
                    Fog.fogEndText.Text = Fog.trackBar2.Value.ToString();
                }
            }
        }

        private void sky_Icon_Click(object sender, EventArgs e)
        {
            Editor_Sky.Show();
        }
       public bool prop_On = false;
       public Editor_Map_Properties Editor_Map_Properties;
        private void propertiesToolStripMenuItem_Click(object sender, EventArgs e)
        {
            prop_On = true;
            Editor_Map_Properties = new Editor_Map_Properties(yed_Ptr,current_Map_Object, false);
            Editor_Map_Properties.Show();
            this.Enabled = false;
        }


        ENTITY tempGround = null;
           private IEnumerable<ScheduleMethod> ground_Entity(IntPtr p)
        {
            tempGround = ENTITY.createFromPointer(p);
            tempGround.skills[19] = 1;
            tempGround.group = 4;
            tempGround.ent_cloneskin();
            tempGround.material = MATERIAL.mtl_create();
            tempGround.ent_setskin(BMAP_DICTIONARY["YRPG_Template_Grid_Line.png"], 1);

            yield return ScheduleMethod.wait(1);
        }
           ENTITY tracingEnt = null;
           public IEnumerable<ScheduleMethod> removeAffectedObjects()
           {
               
               if (ENTITY.c_trace(new Vector(EngVar.you.x, EngVar.you.y, EngVar.you.z + 5000), new Vector(EngVar.you.x, EngVar.you.y, EngVar.you.z - 100), Flags.POLYGON) > 0)
               {
                   Scheduler.AddEventVoidThreadSafe(removeAffectedObjects);
               }
               yield break;
           }
           public IEnumerable<ScheduleMethod> createGroundCustomSized()
           {
               if (groundEntity != null)
               {
                   groundEntity.INVISIBLE = true; if (groundEntity.ent_getskin(1) != null) groundEntity.ent_getskin(1).bmap_purge(); groundEntity.ent_purge(); groundEntity.ent_remove(); groundEntity.ptr_remove();
               }
               current_Map_Object.gridLine.Clear();
               EngVar.you = ENTITY.ent_next(null);
               while (EngVar.you != null)
               {
                   ENTITY tempEntity_ = null;
                   if (EngVar.you.skills[19] == 1)
                   {
                       EngVar.you.ent_remove();
                   }
                   EngVar.you = ENTITY.ent_next(EngVar.you);
               }

               double tempDecimal_Y = (double)current_Map_Object.customSizeY / 2.0;
               int sizeA_Y = 0;
               int sizeB_Y = 0;

               if (Math.IEEERemainder(tempDecimal_Y, 2.0) < 0.0)
               {
                   sizeA_Y = current_Map_Object.customSizeY / 2;
                   sizeB_Y = current_Map_Object.customSizeY - sizeA_Y;
               }
               else
                   if (Math.IEEERemainder(tempDecimal_Y, 2.0) > 0.0)
                   {
                       sizeA_Y = current_Map_Object.customSizeY / 2;
                       sizeB_Y = current_Map_Object.customSizeY - sizeA_Y;
                   }
                   else
                       if ((Math.IEEERemainder(2.0, tempDecimal_Y) == 0.0 && tempDecimal_Y > 0) || (Math.IEEERemainder(2.0, tempDecimal_Y) == 0 && tempDecimal_Y > 0))
                       {
                           sizeA_Y = current_Map_Object.customSizeY / 2;
                           sizeB_Y = current_Map_Object.customSizeY / 2;
                       }
                       else
                           if ((int)tempDecimal_Y * 2 == current_Map_Object.customSizeY)
                           {
                               sizeA_Y = current_Map_Object.customSizeY / 2;
                               sizeB_Y = current_Map_Object.customSizeY / 2;
                           }

               if (tempDecimal_Y == 0)
               {
                   sizeA_Y = 1;

               }

               double tempDecimal_X = (double)current_Map_Object.customSizeX / 2.0;
               int sizeA_X = 0;
               int sizeB_X = 0;

               if (Math.IEEERemainder(tempDecimal_X, 2.0) < 0.0)
               {
                   sizeA_X = current_Map_Object.customSizeX / 2;
                   sizeB_X = current_Map_Object.customSizeX - sizeA_X;
               }
               else
                   if (Math.IEEERemainder(tempDecimal_X, 2.0) > 0.0)
                   {
                       sizeA_X = current_Map_Object.customSizeX / 2;
                       sizeB_X = current_Map_Object.customSizeX - sizeA_X;
                   }
                   else
                       if ((Math.IEEERemainder(2.0, tempDecimal_X) == 0.0 && tempDecimal_X > 0) || (Math.IEEERemainder(2.0, tempDecimal_X) == 0 && tempDecimal_X > 0))
                       {
                           sizeA_X = current_Map_Object.customSizeX / 2;
                           sizeB_X = current_Map_Object.customSizeX / 2;
                       }
                       else
                           if ((int)tempDecimal_X * 2 == current_Map_Object.customSizeX)
                           {
                               sizeA_X = current_Map_Object.customSizeX / 2;
                               sizeB_X = current_Map_Object.customSizeX / 2;
                           }

               if (tempDecimal_X == 0)
               {
                   sizeA_X = 1;

               }

               sizeA_X = (sizeA_X * -1);
               sizeB_Y = (sizeB_Y * -1);


               int j = 0;
               while (sizeA_X < sizeB_X)
               {

                   for (int i = 0; i > sizeB_Y - 1; i--)
                   {
                       //ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Tiles\\TileFlat.mdl", new Vector(sizeA_X*128, i*128, 0), ground_Entity);
                       current_Map_Object.gridLine.Add(new Editor_Grid(new vector(sizeA_X * 128, i * 128, 0)));

                   }

                   for (int i = 0; i < sizeA_Y; i++)
                   {
                       //ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Tiles\\TileFlat.mdl", new Vector(sizeA_X * 128, i * 128, 0), ground_Entity);
                       current_Map_Object.gridLine.Add(new Editor_Grid(new vector(sizeA_X * 128, i * 128, 0)));
                   }

                   sizeA_X++;
               }
               ymap tempMap = new ymap();
               tempMap.Editor_Object_Save = current_Map_Object;
               SerializeYMAPToXML(tempMap, yed_Ptr.returnPath() + "\\Maps\\temp_" + current_Map_Object.mapDesignation + ".ymp");
               yield break;
           }

        public IEnumerable<ScheduleMethod> changeGroundCustomSized()
        {
            if (groundEntity != null)
            {
                groundEntity.INVISIBLE = true; if (groundEntity.ent_getskin(1) != null) groundEntity.ent_getskin(1).bmap_purge(); groundEntity.ent_purge(); groundEntity.ent_remove(); groundEntity.ptr_remove();
            }
            current_Map_Object.gridLine.Clear();
              EngVar.you = ENTITY.ent_next(null);
              while (EngVar.you != null)
              {
                  ENTITY tempEntity_ = null;
                  if (EngVar.you.skills[19] == 1)
                  {
                      EngVar.you.ent_remove();
                  }
                  EngVar.you = ENTITY.ent_next(EngVar.you);
              }
            
              double tempDecimal_Y = (double)current_Map_Object.customSizeY / 2.0;
            int sizeA_Y = 0;
            int sizeB_Y = 0;

            if (Math.IEEERemainder(tempDecimal_Y,2.0) < 0.0)
              {
                  sizeA_Y = current_Map_Object.customSizeY / 2;
                  sizeB_Y = current_Map_Object.customSizeY - sizeA_Y;
              }
            else
                if (Math.IEEERemainder(tempDecimal_Y, 2.0) > 0.0)
                {
                    sizeA_Y = current_Map_Object.customSizeY / 2;
                    sizeB_Y = current_Map_Object.customSizeY - sizeA_Y;
                }else
                    if ((Math.IEEERemainder(2.0, tempDecimal_Y) == 0.0 && tempDecimal_Y > 0) || (Math.IEEERemainder(2.0, tempDecimal_Y) == 0 && tempDecimal_Y > 0))
                {
                    sizeA_Y = current_Map_Object.customSizeY / 2;
                    sizeB_Y = current_Map_Object.customSizeY / 2;
                }
                    else
                        if ((int)tempDecimal_Y * 2 == current_Map_Object.customSizeY)
                        {
                            sizeA_Y = current_Map_Object.customSizeY / 2;
                            sizeB_Y = current_Map_Object.customSizeY / 2;
                        }
              
                if (tempDecimal_Y == 0)
                {
                    sizeA_Y = 1;
                      
                }

                double tempDecimal_X = (double)current_Map_Object.customSizeX / 2.0;
                int sizeA_X = 0;
                int sizeB_X = 0;

                if (Math.IEEERemainder(tempDecimal_X, 2.0) < 0.0)
                {
                    sizeA_X = current_Map_Object.customSizeX / 2;
                    sizeB_X = current_Map_Object.customSizeX - sizeA_X;
                }
                else
                    if (Math.IEEERemainder(tempDecimal_X, 2.0) > 0.0)
                    {
                        sizeA_X = current_Map_Object.customSizeX / 2;
                        sizeB_X = current_Map_Object.customSizeX - sizeA_X;
                    }
                    else
                        if ((Math.IEEERemainder(2.0, tempDecimal_X) == 0.0 && tempDecimal_X > 0) || (Math.IEEERemainder(2.0, tempDecimal_X) == 0 && tempDecimal_X > 0))
                        {
                            sizeA_X = current_Map_Object.customSizeX / 2;
                            sizeB_X = current_Map_Object.customSizeX / 2;
                        }
                        else
                            if ((int)tempDecimal_X * 2 == current_Map_Object.customSizeX)
                            {
                                sizeA_X = current_Map_Object.customSizeX / 2;
                                sizeB_X = current_Map_Object.customSizeX / 2;
                            }

                if (tempDecimal_X == 0)
                {
                    sizeA_X = 1;

                }

            sizeA_X = (sizeA_X*-1);
            sizeB_Y = (sizeB_Y*-1);


            int j = 0;
            while (sizeA_X < sizeB_X)
            {

                for (int i = 0; i > sizeB_Y - 1; i--)
                {
                    ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Tiles\\TileFlat.mdl", new Vector(sizeA_X*128, i*128, 0), ground_Entity);
                    current_Map_Object.gridLine.Add(new Editor_Grid(new vector(sizeA_X*128, i*128, 0)));

                }

                for (int i = 0; i < sizeA_Y; i++)
                {
                    ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Tiles\\TileFlat.mdl", new Vector(sizeA_X * 128, i * 128, 0), ground_Entity);
                    current_Map_Object.gridLine.Add(new Editor_Grid(new vector(sizeA_X * 128, i * 128, 0)));
                }

                sizeA_X++;
            }
             ymap tempMap = new ymap();
            tempMap.Editor_Object_Save = current_Map_Object;
            SerializeYMAPToXML(tempMap,yed_Ptr.returnPath()+"\\Maps\\temp_"+current_Map_Object.mapDesignation+".ymp");
            yield break;
        }

        public IEnumerable<ScheduleMethod> changeGround()
        {
            if (groundEntity != null)
            {
                groundEntity.INVISIBLE = true; if (groundEntity.ent_getskin(1) != null) groundEntity.ent_getskin(1).bmap_purge(); groundEntity.ent_purge(); groundEntity.ent_remove(); groundEntity.ptr_remove();
            }
            else yield break;

            if (current_Map_Object.size.Equals("8"))
            {
                groundEntity = ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Templates\\8x8.mdl", new Vector(), null);
            }
            if (current_Map_Object.size.Equals("16"))
            {
                groundEntity = ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Templates\\16x16.mdl", new Vector(), null);
            }
            if (current_Map_Object.size.Equals("32"))
            {
                groundEntity = ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Templates\\32x32.mdl", new Vector(), null);
            }
            if (current_Map_Object.size.Equals("64"))
            {
                groundEntity = ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Templates\\32x32.mdl", new Vector(), null);
            }

            groundEntity.material = MATERIAL.mtl_create();
            groundEntity.ent_setskin(BMAP_DICTIONARY["YRPG_Template_Grid_Line.png"], 1);
            groundEntity.skills[19] = 1;
            yield return ScheduleMethod.wait(1);
        }

        private void entity_Player_Click(object sender, EventArgs e)
        {
            if (selectedEntity.Text != "NONE")
            {
                if (flyingEntity != null && Place_Mode_checkBox.Checked == true)
                {
                        if (entity_Player.Checked == true)
                        {
                            foreach (Editor_Entity ent_ in current_Map_Object.entityList)
                            {
                                if (ent_.flags.player == 1)
                                {
                                    MessageBox.Show("There is already an Entity with the player flag.");
                                    EngVar.camera.x = (double)ent_.position.x;
                                    EngVar.camera.y = (double)ent_.position.y;
                                    EngVar.camera.roll = 0;

                                    entity_Player.Checked = false;
                                    return;
                                }
                            }
                            flyingEntity.skills[17] = 1;
                        }
                        else
                            if (entity_Player.Checked == false)
                                flyingEntity.skills[17] = 0;
                }
                if (tempEntity != null && Place_Mode_checkBox.Checked == false)
                {
                    if (entity_Player.Checked == true)
                    {
                        foreach (Editor_Entity ent_ in current_Map_Object.entityList)
                        {
                            if (ent_.flags.player == 1)
                            {
                                MessageBox.Show("There is already an Entity with the player flag.");
                                EngVar.camera.x = (double)ent_.position.x;
                                EngVar.camera.y = (double)ent_.position.y;
                                EngVar.camera.roll = 0;
                                entity_Player.Checked = false;
                                return;
                            }
                        }
                        tempEntity.skills[17] = 1;
                        if (tempEntity_YRPGObject != null)
                        {

                            tempEntity_YRPGObject.flags.player = 1;
                            saveTempEntity();
                        }
                    }
                    else
                        if (entity_Player.Checked == false)
                        {
                            tempEntity.skills[17] = 0;
                            if (tempEntity_YRPGObject != null)
                            {

                                tempEntity_YRPGObject.flags.player = 0;
                                saveTempEntity();
                            }
                        }
                }
            }
 
        }
        private IEnumerable<ScheduleMethod> rotateEditorCamera()
        {
            rotateCamera_button.BeginInvoke(new Action(() =>
            {
                rotateCamera_button.Enabled = false;
            })
            );
            cameraIsRotating = true;
    
                for (double i = 0; i != 90; i+=45)
                {
                    EngVar.camera.pan+=45;
                    yield return ScheduleMethod.waitForFrames(1);
                }
                rotateCamera_button.BeginInvoke(new Action(() =>
                {
                    rotateCamera_button.Enabled = true;
                })
                );
                if (EngVar.camera.pan >= 360) EngVar.camera.pan = 0;
            cameraIsRotating = false;
            yield break;
        }
        Boolean cameraIsRotating = false;
        int  rotateCamera = 0;
        private void rotateCamera_button_Click(object sender, EventArgs e)
        {
            if (rotateCamera == 3)
            {
                rotateCamera = 0;

            }
            else
            {
                rotateCamera++;
            }
                Scheduler.AddEventVoidThreadSafe(rotateEditorCamera);
        }
        ymap mapToCopy = null;
        private void copyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (File.Exists(yed_Ptr.returnPath() + "\\Maps\\temp_" + separateFromLast(mapTree.SelectedNode.Text,'.')+".ymp"))
            {
                mapToCopy = DeserializeXmlToYMAP(yed_Ptr.returnPath() + "\\Maps\\temp_" + separateFromLast(mapTree.SelectedNode.Text, '.') + ".ymp");

            }
            else
                if (File.Exists(yed_Ptr.returnPath() + "\\Maps\\" + separateFromLast(mapTree.SelectedNode.Text,'.') + ".ymp"))
            {
                mapToCopy = DeserializeXmlToYMAP(yed_Ptr.returnPath() + "\\Maps\\" + separateFromLast(mapTree.SelectedNode.Text, '.') + ".ymp");

            }
        }

        private void pasteYMAPToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string value = separateFromFirst(mapToCopy.Editor_Object_Save.mapDesignation,'_');
            List<int> mapNumbers = new List<int>();
            
            foreach (String object_ in allMaps) mapNumbers.Add(Convert.ToInt16(object_.Substring(0, 4)));
                   
                       mapNumbers.Sort();
                       int i = 0;
                       for (i = 0; i < mapNumbers.Count; i++)
                       {
                           if (mapNumbers[0] > 1)
                           {
                               i = 1; break;
                           }
                           if (mapNumbers.Count - 1 == i) { i = i + 2; break; }
                           if (mapNumbers[i] + 1 != mapNumbers[i + 1])
                           {
                               i = mapNumbers[i] + 1; break;
                           }
                       }
                       if (i == 0) i = 1;
                       string formater = "0000";
                       allMaps.Add(i.ToString(formater) + "_" + value);
                       Editor_Object tempMap = (new Editor_Object(i.ToString(formater) + "_" + value, SaveNodes(mapTree.SelectedNode), Editor_Input.sizeMap));
                       mapToCopy.Editor_Object_Save.mapDesignation = i.ToString(formater) + "_" + value;
                       mapToCopy.Editor_Object_Save.mapContainer = SaveNodes(mapTree.SelectedNode);
                       SerializeYMAPToXML(mapToCopy, yed_Ptr.returnPath() + "\\Maps\\" + mapToCopy.Editor_Object_Save.mapDesignation + ".ymp");
                       mapTree.SelectedNode.Nodes.Add(i.ToString(formater) + "_" + value + ".ymp");
                       mapList.Add(new Editor_Map(value));
                       setTreeIcons();
                   
        }
        private IEnumerable<ScheduleMethod> redeleteBlock()
        {
            undo_button.BeginInvoke(new Action(() =>{ undo_button.Enabled = false;}));
            if (blockUndoList.Count < 1) yield break;
            EngVar.you = ENTITY.ent_next(null);
            while (EngVar.you != null)
            {
                if (EngVar.you.skills[19] == 3)
                {
                    if (blockUndoList[blockUndoList.Count - 1].id == EngVar.you.skills[18])
                    {
                        if (EngVar.you.skills[22] == 1)
                        {
                            Scheduler.AddEventVoidThreadSafe(deselectEntityMethod);
                        }
                        for (int i = 0; i < current_Map_Object.tileList.Count; i++)
                        {
                            if (current_Map_Object.tileList[i].id == blockUndoList[blockUndoList.Count - 1].id)
                            {
                                current_Map_Object.tileList.RemoveAt(i);
                                break;
                            }
                        }
                        blockUndoList.RemoveAt(blockUndoList.Count - 1);
                        undo_button.BeginInvoke(new Action(() =>
                        {
                            if (blockUndoList.Count > 0)
                                undo_button.Enabled = true;
                        })
                      );
                        EngVar.you.INVISIBLE = true;
                        EngVar.you.ent_purge();
                        EngVar.you.ent_remove();
                        break;
                    }
                }
                EngVar.you = ENTITY.ent_next(EngVar.you);
            }
            yield break;
        }
        private IEnumerable<ScheduleMethod> redeleteEntity()
        {
            entityUndo_button.BeginInvoke(new Action(() => { entityUndo_button.Enabled = false; }));
            if (entityUndoList.Count < 1) yield break;
            EngVar.you = ENTITY.ent_next(null);
            while (EngVar.you != null)
            {
                if (EngVar.you.skills[19] == 2)
                {
                    if (entityUndoList[entityUndoList.Count - 1].id == EngVar.you.skills[18])
                    {
                        if (EngVar.you.skills[22] == 1)
                        {
                            Scheduler.AddEventVoidThreadSafe(deselectEntityMethod);
                        }
                        for (int i = 0; i < current_Map_Object.entityList.Count; i++)
                        {
                            if (current_Map_Object.entityList[i].id == entityUndoList[entityUndoList.Count - 1].id)
                            {
                                current_Map_Object.entityList.RemoveAt(i);
                                break;
                            }
                        }
                        entityUndoList.RemoveAt(entityUndoList.Count - 1);
                       
                        EngVar.you.INVISIBLE = true;
                        EngVar.you.ent_purge();
                        EngVar.you.ent_remove();
                        break;
                    }
                }
                EngVar.you = ENTITY.ent_next(EngVar.you);
            }
           
            entityUndo_button.BeginInvoke(new Action(() =>
            {
                if (entityUndoList.Count < 1)
                    entityUndo_button.Enabled = false;
                else entityUndo_button.Enabled = true;

            })
                       );
            yield break;
        }
        private IEnumerable<ScheduleMethod> recreateBlock()
        {
            undo_button.BeginInvoke(new Action(() =>
            {
                undo_button.Enabled = false;
            })
            );
            if (blockUndoList.Count < 1) yield break;
            tempTile = blockUndoList[blockUndoList.Count - 1];
            if (tempTile.tileType == 1)
            {
                ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Tiles\\Tile.mdl", new Vector((double)tempTile.position.x, (double)tempTile.position.y, (double)tempTile.position.z), block_Mode_Recreate);
            }
            else
                if (tempTile.tileType == 2)
                {
                    ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Tiles\\TileFlat.mdl", new Vector((double)tempTile.position.x, (double)tempTile.position.y, (double)tempTile.position.z), block_Mode_Recreate);
                }
                else
                    if (tempTile.tileType == 3)
                    {
                        ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Tiles\\Cylinder.mdl", new Vector((double)tempTile.position.x, (double)tempTile.position.y, (double)tempTile.position.z), block_Mode_Recreate);
                    }
                    else
                        if (tempTile.tileType == 4)
                        {
                            ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Tiles\\FlatCylinder.mdl", new Vector((double)tempTile.position.x, (double)tempTile.position.y, (double)tempTile.position.z), block_Mode_Recreate);
                        }
                        else
                            if (tempTile.tileType == 5)
                            {
                                ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Tiles\\StepFlat.mdl", new Vector((double)tempTile.position.x, (double)tempTile.position.y, (double)tempTile.position.z), block_Mode_Recreate);
                            }
                            else
                                if (tempTile.tileType == 6)
                                {
                                    ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Tiles\\StepFlat.mdl", new Vector((double)tempTile.position.x, (double)tempTile.position.y, (double)tempTile.position.z), block_Mode_Recreate);
                                }
                                else
                                    if (tempTile.tileType == 7)
                                    {
                                        ENTITY.ent_create(yed_Ptr.returnPath() + "\\Maps\\Tiles\\Obstacle.mdl", new Vector((double)tempTile.position.x, (double)tempTile.position.y, (double)tempTile.position.z), block_Mode_Recreate);
                                    }
            blockUndoList.RemoveAt(blockUndoList.Count - 1);
            undo_button.BeginInvoke(new Action(() =>
            {
                if (blockUndoList.Count > 0)
                undo_button.Enabled = true;
            })
          );
        
            yield break;
        }
        private void undo_button_Click(object sender, EventArgs e)
        {
            if (blockUndoList.Count < 1) return;
            
            if (blockUndoList[blockUndoList.Count-1].marked.Equals("Delete"))
            {
                Scheduler.AddEventVoidThreadSafe(recreateBlock);
            }
            else if (blockUndoList[blockUndoList.Count - 1].marked.Equals("Create"))
            {
                Scheduler.AddEventVoidThreadSafe(redeleteBlock);
            } 
        }

        private void mapTree_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            if (loadNow == false && saveNow == false)
            {
                if (mapTree.SelectedNode == null) return;
                if (mapTree.SelectedNode.Text.Equals("")) return;
                if (!mapTree.SelectedNode.Text.Contains(".ymp")) return;
                button3.Enabled = false;
                if (tempNode_ != null)
                {
                    tempNode_.ForeColor = SystemColors.ControlText;
                }
                tempNode_ = mapTree.SelectedNode;
                mapTree.SelectedNode.ForeColor = SystemColors.Highlight;
                loadNow = true;
                Place_Mode_checkBox.Checked = false;
                mapTree.Enabled = false;
            }
        }

        private void changeSkin_button_Click(object sender, EventArgs e)
        {
            this.Enabled = false;
            if (tempEntity == null)
            {
                customSkin.assignTexture_Button.Enabled = false;
                customSkin.originalTexture_button.Enabled = false;
            }
            else
            {
                customSkin.assignTexture_Button.Enabled = true;
                customSkin.originalTexture_button.Enabled = true;
            }
            customSkin.Show();
        }
        private void contextMenuStrip1_Opening(object sender, EventArgs e)
        {

        }

        private void pasteToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string value = separateFromFirst(mapToCopy.Editor_Object_Save.mapDesignation, '_');
            List<int> mapNumbers = new List<int>();

            foreach (String object_ in allMaps) mapNumbers.Add(Convert.ToInt16(object_.Substring(0, 4)));

            mapNumbers.Sort();
            int i = 0;
            for (i = 0; i < mapNumbers.Count; i++)
            {
                if (mapNumbers[0] > 1)
                {
                    i = 1; break;
                }
                if (mapNumbers.Count - 1 == i) { i = i + 2; break; }
                if (mapNumbers[i] + 1 != mapNumbers[i + 1])
                {
                    i = mapNumbers[i] + 1; break;
                }
            }
            if (i == 0) i = 1;
            string formater = "0000";
            allMaps.Add(i.ToString(formater) + "_" + value);
            Editor_Object tempMap = (new Editor_Object(i.ToString(formater) + "_" + value, SaveNodes(mapTree.SelectedNode), Editor_Input.sizeMap));
            mapToCopy.Editor_Object_Save.mapDesignation = i.ToString(formater) + "_" + value;
            mapToCopy.Editor_Object_Save.mapContainer = SaveNodes(mapTree.SelectedNode);
            SerializeYMAPToXML(mapToCopy, yed_Ptr.returnPath() + "\\Maps\\" + mapToCopy.Editor_Object_Save.mapDesignation + ".ymp");
            mapTree.SelectedNode.Nodes.Add(i.ToString(formater) + "_" + value + ".ymp");
            mapList.Add(new Editor_Map(value));
            setTreeIcons();
        }

        private void renameToolStripMenuItem_Click_1(object sender, EventArgs e)
        {
            String tempString = mapTree.SelectedNode.Text;
            string value = " ";
            if (Editor_Input.InputBox("Rename Container", "Designation:", ref value) == DialogResult.OK)
            {
                if (checkWinFormat(value) == false)
                {
                    MessageBox.Show("The entered designation contains illegal characters. Please avoid the using of  \\ / : * ? \" < > |");
                    return;
                }

                if (value.Trim().Equals(""))
                {
                    return;
                }

                String tempNumber = mapTree.SelectedNode.Text;
                string[] dirs = Directory.GetFiles(yed_Ptr.returnPath() + "\\Maps\\", "*.ymp");
                foreach (var file in dirs)
                {
                    ymap tempMap = DeserializeXmlToYMAP(yed_Ptr.returnPath() + "\\Maps\\" + StringHelper.separateSlash(file));

                    if (tempMap.Editor_Object_Save.mapContainer[0].Equals(value))
                    {
                        MessageBox.Show("There is already a Map Container with this designation. Please choose another designation for this Map Container.","Illegal Designation",MessageBoxButtons.OKCancel,MessageBoxIcon.Information);
                        return;
                    }

                }


                tempNumber = mapTree.SelectedNode.Text;
            dirs = Directory.GetFiles(yed_Ptr.returnPath() + "\\Maps\\", "*.ymp");
            foreach (var file in dirs)
            {
                ymap tempMap = DeserializeXmlToYMAP(yed_Ptr.returnPath() + "\\Maps\\" + StringHelper.separateSlash(file));

                if (tempMap.Editor_Object_Save.mapContainer[0].Equals(mapTree.SelectedNode.Text))
                {
                    tempMap.Editor_Object_Save.mapContainer.Clear();
                    tempMap.Editor_Object_Save.mapContainer.Add(value);
                    SerializeYMAPToXML(tempMap, yed_Ptr.returnPath() + "\\Maps\\temp_" + tempMap.Editor_Object_Save.mapDesignation + ".ymp");
                }

                }
               
            }
            mapTree.SelectedNode.Text = value;
        }
        ENTITY tempUndoEnt;
        public List<Editor_Entity> entityUndoList = new List<Editor_Entity>();

        private void entityUndo_button_Click(object sender, EventArgs e)
        {
            if (entityUndoList.Count < 1) return;

            undo_button.BeginInvoke(new Action(() =>
            {
                undo_button.Enabled = false;
            })
    );
            

            if (entityUndoList[entityUndoList.Count - 1].marked.Equals("Delete"))
            {

              ENTITY.ent_create(entityUndoList[entityUndoList.Count - 1].model, new Vector((double)entityUndoList[entityUndoList.Count - 1].position.x, (double)entityUndoList[entityUndoList.Count - 1].position.y, (double)entityUndoList[entityUndoList.Count - 1].position.z), recreate_click_and_move);
                
            }
            else if (entityUndoList[entityUndoList.Count - 1].marked.Equals("Create"))
            {
               Scheduler.AddEventVoidThreadSafe(redeleteEntity);
            } 



        }

        private void entityInvisible_CheckBox_CheckedChanged(object sender, EventArgs e)
        {
            entityInvisible_CheckBox.Enabled = false;
            Scheduler.AddEventVoidThreadSafe(entityInvisible_Scheduling);
        }


        private IEnumerable<ScheduleMethod> entityInvisible_Scheduling()
        {
            if (selectedEntity.Text != "NONE")
            {
                if (flyingEntity != null && Place_Mode_checkBox.Checked == true)
                {
                    if (entityInvisible_CheckBox.Checked == true)
                        flyingEntity.skills[14] = 1;
                    else
                        if (entityTranslucent.Checked == false)
                            flyingEntity.skills[14] = 0;
                }
                if (tempEntity != null && Place_Mode_checkBox.Checked == false)
                {
                    if (entityInvisible_CheckBox.Checked == true)
                    {
                      
                        if (tempEntity_YRPGObject != null)
                        {
                            tempEntity.skills[14] = 1;
                            tempEntity_YRPGObject.flags.invisible = 1;
                            saveTempEntity();
                        }
                    }
                    else
                        if (entityInvisible_CheckBox.Checked == false)
                        {
                          
                            if (tempEntity_YRPGObject != null)
                            {
                                tempEntity.skills[14] = 0;
                                tempEntity_YRPGObject.flags.invisible = 0;
                                saveTempEntity();
                            }
                        }
                }
            }

            entityTranslucent.BeginInvoke(new Action(() =>
            {
                entityInvisible_CheckBox.Enabled = true;
            })
            );
            yield break;
        }
    }
}
public class yed
{
    public List<String> YMAP_LIST { get; set; }
    public Editor_Speed_Values Editor_Speed_Values_Save { get; set; }
    public Editor_Options Editor_Options_Save { get; set; }
}
public class ymap
{
    public Editor_Object Editor_Object_Save { get; set; }
}

 public partial class Form4 : Form
    {



        public static DialogResult InputBox(string title, string promptText, ref string value)
        {
            Form form = new Form();
            Label label = new Label();
            TextBox textBox = new TextBox();
            Button buttonOk = new Button();
            Button buttonCancel = new Button();

            form.Text = title;
            label.Text = promptText;
            textBox.Text = value;

            buttonOk.Text = "OK";
            buttonCancel.Text = "Cancel";
            buttonOk.DialogResult = DialogResult.OK;
            buttonCancel.DialogResult = DialogResult.Cancel;

            label.SetBounds(9, 20, 372, 13);
            textBox.SetBounds(12, 36, 372, 20);
            buttonOk.SetBounds(228, 72, 75, 23);
            buttonCancel.SetBounds(309, 72, 75, 23);

            label.AutoSize = true;
            textBox.Anchor = textBox.Anchor | AnchorStyles.Right;
            buttonOk.Anchor = AnchorStyles.Bottom | AnchorStyles.Right;
            buttonCancel.Anchor = AnchorStyles.Bottom | AnchorStyles.Right;

            form.ClientSize = new Size(396, 107);
            form.Controls.AddRange(new Control[] { label, textBox, buttonOk, buttonCancel });
            form.ClientSize = new Size(Math.Max(300, label.Right + 10), form.ClientSize.Height);
            form.FormBorderStyle = FormBorderStyle.FixedDialog;
            form.StartPosition = FormStartPosition.CenterScreen;
            form.MinimizeBox = false;
            form.MaximizeBox = false;
            form.AcceptButton = buttonOk;
            form.CancelButton = buttonCancel;

            DialogResult dialogResult = form.ShowDialog();
            value = textBox.Text;
            return dialogResult;
        }


    }
	
	  public class Editor_Entity
    {
       public int id;
       public String model;
       public bool lightRange_Active = false;
       public bool selfColor_Active = false;
       public int lightStrength = 0;
       public vector lightRange_Value = new vector(0, 0, 0);
       public vector position = new vector();
       public double pan = 0;
       public double scale = 1;
       public Editor_Flags flags = new Editor_Flags();
       public String event_ = "";
       public String marked = "";



       public Editor_Entity()
       {
           
       }

       public Editor_Entity(int id, String model, bool lightRange_Active, bool selfColor_Active, int lightStrength, vector lightRange_Value, vector position, double pan, double scale, Editor_Flags flags, String event_)
       {
           this.id = id;
           this.model = model;
           this.lightRange_Active = lightRange_Active;
           this.selfColor_Active = selfColor_Active;
           this.lightStrength = lightStrength;
           this.lightRange_Value = lightRange_Value;
           this.position = position;
           this.pan = pan;
           this.scale = scale;
           this.flags = flags;
           this.event_ = event_;
       }
       public Editor_Entity(List<Editor_Entity> entity_)
       {
        
       }
       public Editor_Entity(int id){
           this.id = id;
           }


      
      
    }
	 public partial class Editor_Entity_Custom_Skin : Form
    {
        Editor editor_Ptr = null;
        ImageList listOfImages = null;
        public Editor_Entity_Custom_Skin(Editor ptr )
        {
            this.editor_Ptr  = ptr;
            InitializeComponent();

            textureSky_listView.LargeImageList = editor_Ptr.imageList1;
            this.FormClosing += new System.Windows.Forms.FormClosingEventHandler(this.Form1_FormClosing);
        }
    
        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            editor_Ptr.Enabled = true;
            this.Hide();

        }
        private void assignTexture_Button_Click(object sender, EventArgs e)
        {
            if (editor_Ptr.tempEntity != null)
            {
                editor_Ptr.tempEntity.ent_setskin(editor_Ptr.BMAP_DICTIONARY[textureSky_listView.SelectedItems[0].Text],(double)skinNumber_numericUpDown.Value);
              
            }
        }

        private void Editor_Entity_Custom_Skin_Load(object sender, EventArgs e)
        {

        }

        private void originalTexture_button_Click(object sender, EventArgs e)
        {
            editor_Ptr.tempEntity.ent_reload();
        }
    }
	
	 public class Editor_EntityMap
    {
       public ENTITY entity;
       public String modelName;
        public double pan;
        public double roll;
        public double tilt;
        public Vector posxyz;

        public Editor_EntityMap()
        {
        }

        public Editor_EntityMap(String modelName,Vector posxyz, double pan, double roll, double tilt)
        {
            this.modelName = modelName;
            this.posxyz = posxyz;
            this.pan = pan;
            this.roll = roll;
            this.tilt = tilt;
        }
    }
	
	 public partial class Editor_EntityPosition : Form
    {
        Editor ptr = null;
        public Editor_EntityPosition(Editor ptr)
        {
            InitializeComponent();
            this.ptr = ptr;
            this.FormClosing += new System.Windows.Forms.FormClosingEventHandler(Form1_FormClosing);
        }
        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();

        }
        private void button4_Click(object sender, EventArgs e)
        {
            Editor.preparedDouble = 270;
            if (Editor.getPlaceMode() == false)
            {
                if (ptr.tempEntity != null)
                {
                    ptr.tempEntity.pan = 270;
             

                             if(ptr.tempTile_YRPGObject != null){
                                 ptr.tempTile_YRPGObject.pan = 270;
                                 ptr.saveTempTile();
                             }
                    

                }
            }
            else
                if (Editor.flyingEntity != null)
                {
                    Editor.flyingEntity.pan = 270;
                    Editor.entity_Rotation = 270;
                }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            Editor.preparedDouble = 0;
            if (Editor.getPlaceMode() == false)
            {
                if (ptr.tempEntity != null)
                {
                    ptr.tempEntity.pan = 0;
                    if (ptr.tempTile_YRPGObject != null)
                    {
                        ptr.tempTile_YRPGObject.pan = 0;
                        ptr.saveTempTile();
                    }
                }
            }
            else
                if (Editor.flyingEntity != null)
                {
                    Editor.flyingEntity.pan = 0;
                    Editor.entity_Rotation = 0;
                }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Editor.preparedDouble = 90;
            if (Editor.getPlaceMode() == false)
            {
                if (ptr.tempEntity != null)
                {
                    ptr.tempEntity.pan = 90;
                    if (ptr.tempTile_YRPGObject != null)
                    {
                        ptr.tempTile_YRPGObject.pan = 90;
                        ptr.saveTempTile();
                    }
                }
            }
            else
                if (Editor.flyingEntity != null)
                {
                    Editor.flyingEntity.pan = 90;
                    Editor.entity_Rotation = 90;
                }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            Editor.preparedDouble = 180;
            if (Editor.getPlaceMode() == false)
            {
                if (ptr.tempEntity != null)
                 {
                     ptr.tempEntity.pan = 180;
                if (ptr.tempTile_YRPGObject != null)
                {
                    ptr.tempTile_YRPGObject.pan = 180;
                    ptr.saveTempTile();
                }
                 }
            }
            else
            if (Editor.flyingEntity != null)
            {
                Editor.flyingEntity.pan = 180;
                Editor.entity_Rotation = 180;
            }
        }

        private void button5_Click(object sender, EventArgs e)
        {
            this.Visible = false;
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox1.Checked == true) this.TopMost = true; else this.TopMost = false;
        }
    }
	public class Editor_Flags
    {
        public int overlay = 0;
        public int passable = 0;
        public int bright = 0;
        public int translucent = 0;
        public int shadow = 0;
        public int unlit = 0;
        public int gras = 0;
        public int player = 0;
        public int invisible = 0;

        public Editor_Flags()
        {

        }

        public Editor_Flags(int overlay, int passable, int bright, int translucent, int shadow, int unlit, int gras, int player, int invisible)
        {
            this.overlay = overlay;
            this.passable = passable;
            this.bright = bright;
            this.translucent = translucent;
            this.shadow = shadow;
            this.unlit = unlit;
            this.gras = gras;
            this.player = player;
            this.invisible = invisible;
        }
    }
	
	  public partial class Editor_Fog : Form
    {
        Editor yrpg_ptr;
        public Editor_Fog(Editor ptr)
        {
          
            InitializeComponent();
            this.FormClosing += new System.Windows.Forms.FormClosingEventHandler(Form1_FormClosing);
            this.yrpg_ptr = ptr;
        }
        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {

            e.Cancel = true;
            this.Hide();

        }
        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            
                fogBeginText.Text = "" + trackBar1.Value;
                EngVar.camera.fog_start = trackBar1.Value;
                yrpg_ptr.current_Map_Object.fog_Begin = trackBar1.Value;
        }

        private void trackBar2_Scroll(object sender, EventArgs e)
        {
            fogEndText.Text = "" + trackBar2.Value;
            EngVar.camera.fog_end = trackBar2.Value;
            yrpg_ptr.current_Map_Object.fog_End = trackBar2.Value;
            EngVar.camera.clip_far = EngVar.camera.fog_end+20000;
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (comboBox1.Text == "No Fog")
            {
                EngVar.fog_color = 0;
                EngVar.camera.clip_far = 50000;
                yrpg_ptr.current_Map_Object.fog_Color = 0;
            }
            if (comboBox1.Text == "Blue")
            {
                EngVar.fog_color = 1;
                yrpg_ptr.current_Map_Object.fog_Color = 1;
                EngVar.d3d_fogcolor1.red = 0;
                EngVar.d3d_fogcolor1.green = 0;
                EngVar.d3d_fogcolor1.blue = 255;


                yrpg_ptr.current_Map_Object.fogcolor.x = (decimal)EngVar.d3d_fogcolor1.red;
                yrpg_ptr.current_Map_Object.fogcolor.y = (decimal)EngVar.d3d_fogcolor1.green;
                yrpg_ptr.current_Map_Object.fogcolor.z = (decimal)EngVar.d3d_fogcolor1.blue;
            }
            if (comboBox1.Text == "Red")
            {
                EngVar.fog_color = 1;
                yrpg_ptr.current_Map_Object.fog_Color = 3;
                EngVar.d3d_fogcolor1.red = 255;
                EngVar.d3d_fogcolor1.green = 0;
                EngVar.d3d_fogcolor1.blue = 0;


                yrpg_ptr.current_Map_Object.fogcolor.x = (decimal)EngVar.d3d_fogcolor1.red;
                yrpg_ptr.current_Map_Object.fogcolor.y = (decimal)EngVar.d3d_fogcolor1.green;
                yrpg_ptr.current_Map_Object.fogcolor.z = (decimal)EngVar.d3d_fogcolor1.blue;
            }
            if (comboBox1.Text == "White")
            {
                EngVar.fog_color = 1;
                yrpg_ptr.current_Map_Object.fog_Color = 1;
                EngVar.d3d_fogcolor1.red = 255;
                EngVar.d3d_fogcolor1.green = 255;
                EngVar.d3d_fogcolor1.blue = 255;


                yrpg_ptr.current_Map_Object.fogcolor.x = (decimal)EngVar.d3d_fogcolor1.red;
                yrpg_ptr.current_Map_Object.fogcolor.y = (decimal)EngVar.d3d_fogcolor1.green;
                yrpg_ptr.current_Map_Object.fogcolor.z = (decimal)EngVar.d3d_fogcolor1.blue;
            }
            if (comboBox1.Text == "Green")
            {
                EngVar.fog_color = 1;
                yrpg_ptr.current_Map_Object.fog_Color = 4;
                EngVar.d3d_fogcolor1.red = 0;
                EngVar.d3d_fogcolor1.green = 255;
                EngVar.d3d_fogcolor1.blue = 0;


                yrpg_ptr.current_Map_Object.fogcolor.x = (decimal)EngVar.d3d_fogcolor1.red;
                yrpg_ptr.current_Map_Object.fogcolor.y = (decimal)EngVar.d3d_fogcolor1.green;
                yrpg_ptr.current_Map_Object.fogcolor.z = (decimal)EngVar.d3d_fogcolor1.blue;
            }
            if (comboBox1.Text == "Black")
            {
                EngVar.fog_color = 1;
                yrpg_ptr.current_Map_Object.fog_Color = 5;
                EngVar.d3d_fogcolor1.red = 0;
                EngVar.d3d_fogcolor1.green = 0;
                EngVar.d3d_fogcolor1.blue = 0;


                yrpg_ptr.current_Map_Object.fogcolor.x = (decimal)EngVar.d3d_fogcolor1.red;
                yrpg_ptr.current_Map_Object.fogcolor.y = (decimal)EngVar.d3d_fogcolor1.green;
                yrpg_ptr.current_Map_Object.fogcolor.z = (decimal)EngVar.d3d_fogcolor1.blue;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.Visible = false;
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox1.Checked == true)
            {
                this.TopMost = true;
            }
            else
            {
                this.TopMost = false;
            }
        }
    }
	 public class Editor_Grid : Editor_Tile
    {
        vector xyz = new vector();
        public Editor_Grid() { }

        public Editor_Grid(vector xyz) {
            this.position = xyz;
        }

 
    }
	 public partial class Editor_Map_Properties : Form
    {
        Editor_Object map;
        Editor ptr;
        MusicForm Music_Player;
        String number = "";
        bool newMap = false;
        bool created = false;
        TreeNode mapNode = null;
        public bool Created()
        {
            return created;
        }
        public Editor_Map_Properties(Editor ptr, Editor_Object map, bool newMap)
        {
          
            InitializeComponent();
            this.newMap = newMap;
            this.ptr = ptr;
            this.map = map;
              this.mapName_textBox.Text = map.mapDesignation.Substring(5, map.mapDesignation.Length - 5);
                this.number = map.mapDesignation.Substring(0, 4);
            
            Music_Player = new MusicForm(ptr);
            load_MusicFiles();
            musicVolume_numericUpDown.Value = (decimal)map.musicVolume;
            enviSoundVolume_numericUpDown.Value = (decimal)map.enviVolume;

       
          
            if((decimal)map.customSizeX> 0)
                x_numericUpDown.Value = (decimal)map.customSizeX;
            if ((decimal)map.customSizeY > 0)
            y_numericUpDown.Value = (decimal)map.customSizeY;
            
       
            this.FormClosing += new System.Windows.Forms.FormClosingEventHandler(this.MapProperties_FormClosing);
        }


        public Editor_Map_Properties(Editor ptr, Editor_Object map, bool newMap, TreeNode container)
        {

            InitializeComponent();

            mapNode = container;
            this.newMap = newMap;
            if (newMap == true) created = true;
            this.ptr = ptr;
            this.map = map;
            if (!newMap)
            {
                this.mapName_textBox.Text = map.mapDesignation.Substring(5, map.mapDesignation.Length - 5);
                this.number = map.mapDesignation.Substring(0, 4);
            }
            else
            {
                this.mapName_textBox.Text = "New Map";
                this.number = "Custom";
            }
         

            Music_Player = new MusicForm(ptr);
            load_MusicFiles();
            musicVolume_numericUpDown.Value = (decimal)map.musicVolume;
            enviSoundVolume_numericUpDown.Value = (decimal)map.enviVolume;



            if ((decimal)map.customSizeX > 0)
                x_numericUpDown.Value = (decimal)map.customSizeX;
            if ((decimal)map.customSizeY > 0)
                y_numericUpDown.Value = (decimal)map.customSizeY;


            this.FormClosing += new System.Windows.Forms.FormClosingEventHandler(this.MapProperties_FormClosing);
        }
        private void MapProperties_FormClosing(object sender,FormClosingEventArgs e)
        {
            this.ptr.Enabled = true;
            this.ptr.prop_On= false;
            //e.Cancel = true;
            //this.Hide();
        }

        public void load_MusicFiles(){
              string[] dirs = Directory.GetFiles(ptr.returnPath() + "\\Music\\", "*.ogg");
            music_comboBox.Items.Clear();
            music_comboBox.Items.Add("-");
            bool musicFound = false;
              foreach (var file in dirs)
              {
                  if(file.EndsWith(".ogg")){
                      music_comboBox.Items.Add(file.Substring(file.LastIndexOf('\\') + 1, file.Length - file.LastIndexOf('\\') - 1));
                      if (file.Substring(file.LastIndexOf('\\') + 1, file.Length - file.LastIndexOf('\\') - 1).Equals(map.mapMusic) && !map.mapMusic.Equals("-"))
                      {
                          music_comboBox.SelectedItem = map.mapMusic;
                          musicFound = true;
                      }
                  }

                  }
              if (musicFound == false)
              {
                  music_comboBox.SelectedItem = "-";
              }
              else
                  music_comboBox.SelectedItem = map.mapMusic;


               dirs = Directory.GetFiles(ptr.returnPath() + "\\Sounds\\", "*.ogg");
               environmentSound_comboBox.Items.Clear();
               environmentSound_comboBox.Items.Add("-");
               musicFound = false;
              foreach (var file in dirs)
              {
                  if (file.EndsWith(".ogg"))
                  {
                      environmentSound_comboBox.Items.Add(file.Substring(file.LastIndexOf('\\') + 1, file.Length - file.LastIndexOf('\\') - 1));
                      if (file.Substring(file.LastIndexOf('\\') + 1, file.Length - file.LastIndexOf('\\') - 1).Equals(map.enviSound) && !map.enviSound.Equals("-"))
                      {
                          environmentSound_comboBox.SelectedItem = map.enviSound;
                          musicFound = true;
                      }
                  }

              }
              if (musicFound == false)
              {
                  environmentSound_comboBox.SelectedItem = "-";
              }
              else

                  environmentSound_comboBox.SelectedItem = map.enviSound;
              
        }
        private void accept_button_Click(object sender, EventArgs e)
        {
            string formater = "0000";
            int j = 0;
            String tempName = "";

            if (!map.mapDesignation.Equals(""))
            {
                tempName = mapName_textBox.Text.Trim();
            }
            else
            {
                new ErrorHandling("You have to choose a designation for a map", "Map Creation Error");
                return;
            }
            if (newMap)
            {
                List<int> mapNumbers = new List<int>();
                foreach (String object_ in ptr.allMaps)
                {
                    mapNumbers.Add(Convert.ToInt16(object_.Substring(0, 4)));
                }
                mapNumbers.Sort();
                int i = 0;
                for (i = 0; i < mapNumbers.Count; i++)
                {
                    if (mapNumbers[0] > 1)
                    {
                        i = 1; break;
                    }
                    if (mapNumbers.Count - 1 == i) { i = i + 2; break; }
                    if (mapNumbers[i] + 1 != mapNumbers[i + 1])
                    {
                        i = mapNumbers[i] + 1; break;
                    }

                }
                if (i == 0) i = 1;
                j = i;
                ptr.allMaps.Add(i.ToString(formater) + "_" + tempName);
                map = (new Editor_Object(i.ToString(formater) + "_" + tempName, ptr.SaveNodes(mapNode), ""));
                //current_Map_Object = EditorObject_List[EditorObject_List.Count - 1];
                

            }
       
            map.enviVolume = (int)enviSoundVolume_numericUpDown.Value;
            map.musicVolume = (int)musicVolume_numericUpDown.Value;
    if(!newMap)
            this.ptr.mapTree.SelectedNode.Text = number + "_" + mapName_textBox.Text +".ymp";
            if(!newMap)
            map.mapDesignation = number + "_" + mapName_textBox.Text;
            map.mapMusic = music_comboBox.SelectedItem.ToString();
            map.enviSound = environmentSound_comboBox.SelectedItem.ToString();
 

                map.size = "Custom";
                map.customSizeX = (int)x_numericUpDown.Value;
                map.customSizeY = (int)y_numericUpDown.Value;
    


  
           
            ymap tempMap = new ymap();
            tempMap.Editor_Object_Save = map;
         
            if(!this.Created())
            if (map.mapDesignation.Equals("Empty") == false)
                ptr.Text = "YED - Map Editor - " + ptr.separateMimeType(map.mapDesignation);
                else
                    this.Text = "YED - Map Editor - No active map";
            this.ptr.Enabled = true;
            this.ptr.prop_On = false;


            if (this.Created())
            {

                mapNode.Nodes.Add(j.ToString(formater) + "_" + tempName+ ".ymp");
                Editor.SerializeYMAPToXML(tempMap, ptr.returnPath() + "\\Maps\\"+j.ToString(formater) + "_" + tempName + ".ymp");
                ptr.mapList.Add(new Editor_Map(mapName_textBox.Text));

                // File.Copy(yrpg_Ptr.returnPath() + "\\Maps\\Templates\\EMPTY_MAP.wmb", yrpg_Ptr.returnPath() + "\\Maps\\" + i.ToString(formater) + "_" + value + ".wmb", true);
                // File.Copy(yrpg_Ptr.returnPath() + "\\Maps\\Templates\\EMPTY_MAP.wmp", yrpg_Ptr.returnPath() + "\\Maps\\" + i.ToString(formater) + "_" + value + ".wmp", true);
                // File.Copy(yrpg_Ptr.returnPath() + "\\Maps\\Templates\\EMPTY_MAP.$$m", yrpg_Ptr.returnPath() + "\\Maps\\" + i.ToString(formater) + "_" + value + ".$$m", true);
                //  File.Copy(yrpg_Ptr.returnPath() + "\\Maps\\Templates\\EMPTY_MAP.$$m", yrpg_Ptr.returnPath() + "\\Maps\\" + i.ToString(formater) + "_" + value + ".ymp", true);
                //  File.Copy(yrpg_Ptr.returnPath() + "\\Maps\\Templates\\EMPTY_MAP.$$w", yrpg_Ptr.returnPath() + "\\Maps\\" + i.ToString(formater) + "_" + value + ".$$w", true);

              
                //Scheduler.AddEventVoid(createNewMap);
                ptr.setTreeIcons();
            }
            else
            {

                try
                {
                    File.Delete(j.ToString(formater) + "_" + tempName + ".ymp");
                }
                catch (FileNotFoundException ea)
                {
                    return;
                }


            }
            ptr.current_Map_Object = tempMap.Editor_Object_Save;
            created = true;
            if (newMap)
            {
                AcknexWrapper.Scheduler.AddEventVoidThreadSafe(ptr.createGroundCustomSized);
            }
            else
            {
                AcknexWrapper.Scheduler.AddEventVoidThreadSafe(ptr.changeGroundCustomSized);
                
            }
       
            this.Close();
        }

        private void cancel_button_Click(object sender, EventArgs e)
        {
            this.ptr.Enabled = true;
            this.ptr.prop_On = false;
            created = false;
            this.Close();
        }
         
        private void button1_Click(object sender, EventArgs e)
        {

         MusicForm.engine.StopPlayback();
           Music_Player.Visible = false;
        
           Music_Player.trackBar1.Value = (int)musicVolume_numericUpDown.Value;
            Music_Player.envi_Sound = false;
            string[] dirs = Directory.GetFiles(ptr.returnPath() + "\\Music\\", "*.ogg");
            Music_Player.listBox7.Items.Clear();
            Music_Player.listBox7.Items.Add("-");
            bool musicFound = false;
            foreach (var file in dirs)
            {
                if (file.EndsWith(".ogg"))
                {
                    Music_Player.listBox7.Items.Add(file.Substring(file.LastIndexOf('\\') + 1, file.Length - file.LastIndexOf('\\') - 1));
                    if (file.Substring(file.LastIndexOf('\\') + 1, file.Length - file.LastIndexOf('\\') - 1).Equals(map.mapMusic) && !map.mapMusic.Equals("-"))
                    {
                        Music_Player.listBox7.SelectedItem = map.mapMusic;
                        musicFound = true;
                    }
                }

            }
            if (musicFound == false)
            {
                Music_Player.listBox7.SelectedItem = "-";
            }
            Music_Player.Show();
        }

        private void mapName_textBox_KeyPress(object sender, KeyPressEventArgs e)
        {
           
            if (e.KeyChar == (char)Keys.Space)
            {
                e.Handled = true;
            }
            if (e.KeyChar == (char)Keys.OemPeriod)
            {
                e.Handled = true;
            }
            if (e.KeyChar == (char)Keys.OemSemicolon)
            {
                e.Handled = true;
            }

            if (e.KeyChar == (char)Keys.Oemcomma)
            {
                e.Handled = true;
            }
        }

        private void openSoundPlayer_button_Click(object sender, EventArgs e)
        {

           Music_Player.Visible = false;
           MusicForm.engine.StopPlayback();
      
           Music_Player.trackBar1.Value = (int)enviSoundVolume_numericUpDown.Value;
            Music_Player.envi_Sound = true;
            string[] dirs = Directory.GetFiles(ptr.returnPath() + "\\Sounds\\", "*.ogg");
            Music_Player.listBox7.Items.Clear();
            Music_Player.listBox7.Items.Add("-");
            bool musicFound = false;
            foreach (var file in dirs)
            {
                if (file.EndsWith(".ogg"))
                {
                    Music_Player.listBox7.Items.Add(file.Substring(file.LastIndexOf('\\') + 1, file.Length - file.LastIndexOf('\\') - 1));
                    if (file.Substring(file.LastIndexOf('\\') + 1, file.Length - file.LastIndexOf('\\') - 1).Equals(map.mapMusic) && !map.mapMusic.Equals("-"))
                    {
                        Music_Player.listBox7.SelectedItem = map.mapMusic;
                        musicFound = true;
                    }
                }

            }
            if (musicFound == false)
            {
                Music_Player.listBox7.SelectedItem = "-";
            }
            Music_Player.Show();
        }

    
    }
	    public class Editor_Map_Properties_Attributes
    {
   
        public String mapDesignation = "";
        public String mapMusic = "";
        public String enviSound = "";
        public int encounterFrequency = 0;
        public String enemyGroup = "";
        

        public Editor_Map_Properties_Attributes()
        {

        }

    }
	 public class Editor_Object
    {

        //        public BMAP texture = BMAP.bmap_create();
        public List<Editor_Grid> gridLine = new List<Editor_Grid>();
        public List<Editor_Tile> tileList = new List<Editor_Tile>();
        public List<Editor_Entity> entityList = new List<Editor_Entity>();

        public Editor_Sky_Attributes skyAttributes = new Editor_Sky_Attributes();
        public String mapDesignation = "";
        public String mapMusic = "";
        public int musicVolume = 0;
        public String enviSound = "";
        public int enviVolume = 0;
        public int encounterFrequency = 0;
        public bool encounter_On = false;
        public String enemyGroup = "";
        public String size = "";
        public int customSizeX = 0;
        public int customSizeY = 0;
        public bool ground = false;
        public List<String> mapContainer;
        public String skyTexture = "";
        
        public vector suncolor = new vector(128, 128, 128);
        public vector ambientcolor = new vector(128, 128, 128);
        public double sunlight = 100;
        public double ambientlight = 50;
        public double sunlight_pan = 0;
        public double sunlight_roll = 50000;
        public double sunlight_tilt = 30;
        public Int16 fog_Color = 0;
        public int fog_Begin = 0;
        public int fog_End = 0;
        public vector fogcolor = new vector(0, 0, 0);

        public Editor_Object(Editor_Object object_)
        {
            this.tileList = object_.tileList;
            this.tileList = object_.tileList;
            this.tileList = object_.tileList;
            this.tileList = object_.tileList;
            this.tileList = object_.tileList;
            this.tileList = object_.tileList;
            this.tileList = object_.tileList;
            this.tileList = object_.tileList;
            this.tileList = object_.tileList;
            this.tileList = object_.tileList;
            this.tileList = object_.tileList;
            this.tileList = object_.tileList;
        }

        public Editor_Object(String mapDesignation, List<String> mapContainer, String size)
        {
            this.mapDesignation = mapDesignation;
            this.mapContainer = mapContainer;
            this.size = size;
        }

        public Editor_Object(String mapDesignation, String dummy)
        {
            this.mapDesignation = mapDesignation;

        }

        public Editor_Object()
        {
        }


        //12356789
        public void addNewTile(String picture, bool normal_Map, Vector position, int tileType, double scale_Z, double pan)
        {
            tileList.Sort(new Comparison<Editor_Tile>((x, y) => x.id.CompareTo(y.id)));
            if (tileList.Count == 0)
            {
                this.tileList.Add(new Editor_Tile(1, picture, normal_Map, scale_Z, new vector((decimal)position.x, (decimal)position.y, (decimal)position.z), pan, tileType));
   
                return;
            }
            for (int int_ = 0; int_ < tileList.Count; int_++)
            {

                if (int_ + 1 < tileList.Count)
                {
                    if (tileList[int_ + 1].id > (int_ + 2))
                    {
                        this.tileList.Add(new Editor_Tile(int_ + 2, picture, normal_Map, scale_Z, new vector((decimal)position.x, (decimal)position.y, (decimal)position.z), pan, tileType));
                    
                        return;
                    }

                }
                else
                    if (int_ + 1 == tileList.Count)
                    {
                        this.tileList.Add(new Editor_Tile(tileList.Count + 1, picture, normal_Map, scale_Z, new vector((decimal)position.x, (decimal)position.y, (decimal)position.z), pan, tileType));
                    
                        return;
                    }
            }

        }

        public void removeExistingTile(int id)
        {
            tileList.Sort(new Comparison<Editor_Tile>((x, y) => x.id.CompareTo(y.id)));
            for (int i = 0; i < tileList.Count; i++)
            {
                if (tileList[i].id == id) tileList.RemoveAt(i);

            }
        }

 




        public void addNewEntity(String model, bool lightRange_Active, bool selfColor_Active, int lightStrength, vector lightRange_Value, vector position, double pan, double scale, Editor_Flags flags, String event_)
        {
            entityList.Sort(new Comparison<Editor_Entity>((x, y) => x.id.CompareTo(y.id)));
            if (entityList.Count == 0)
            {
                this.entityList.Add(new Editor_Entity(1, model, lightRange_Active, selfColor_Active, lightStrength, lightRange_Value, position, pan, scale, flags, event_));
                this.entityList[this.entityList.Count - 1].position = position;
                return;
            }
            for (int int_ = 0; int_ < entityList.Count; int_++)
            {

                if (int_ + 1 < entityList.Count)
                {
                    if (entityList[int_ + 1].id > (int_ + 2))
                    {
                        this.entityList.Add(new Editor_Entity(int_ + 2, model, lightRange_Active, selfColor_Active, lightStrength, lightRange_Value, position, pan, scale, flags, event_));
                        this.entityList[this.entityList.Count - 1].position = position;
                        return;
                    }
                  
                }
                else
                    if (int_ + 1 == entityList.Count)
                    {
                        this.entityList.Add(new Editor_Entity(entityList.Count + 1, model, lightRange_Active, selfColor_Active, lightStrength, lightRange_Value, position, pan, scale, flags, event_));
                        this.entityList[this.entityList.Count - 1].position = position;
                        return;
                    }
            }

        }

        public void removeExistingEntity(double id)
        {
            entityList.Sort(new Comparison<Editor_Entity>((x, y) => x.id.CompareTo(y.id)));
            for (int i = 0; i < entityList.Count; i++)
            {
                if (entityList[i].id == id) entityList.RemoveAt(i);

            }
        }
    }
    
    
    }




    public class Editor_Tile{
        public int id;
        public String picture;
        public bool normalMap;
        public vector position = new vector(0,0,0);
        public int tileType = 0;
        public double tileZ = 1;
        public double pan = 0;
        public String marked = "";

        public Editor_Tile(int id, String picture, bool normalMap, double z, vector xyz, double pan, int tileType)
        {
            this.id = id;
            this.picture = picture;
            this.normalMap = normalMap;
            this.tileZ = z;
            this.position = xyz;
            this.tileType = tileType;
            this.position.x = Math.Round(this.position.x);
            this.position.y = Math.Round(this.position.y);
            this.position.z = Math.Round(this.position.z);
            this.pan = pan;
        }

        public Editor_Tile(Editor_Tile tile_)
        {
            this.id = tile_.id;
            this.picture = tile_.picture;
            this.normalMap = tile_.normalMap;
            this.position = tile_.position;
            this.tileType = tile_.tileType;
            this.tileZ = tile_.tileZ;
    

        }

        public Editor_Tile()
        {

        }
		
		 public class Editor_Options
    {
        public double entity_move = 8;
        public double entity_move_fast = 10;
        public double entity_lift = 8;
        public double entity_lift_fast = 10;
        public double entity_pan = 8;
        public double entity_pan_fast = 10;
        public double map_lift = 8;
        public double map_Lift_fast = 10;
        public double map_move = 8;
        public double map_move_fast = 10;

        public Editor_Options()
        {
        }

    }
	
	 public partial class Editor_Sky : Form
    {
        Editor yrpg_Ptr;
        int i = 0;
        public Editor_Sky(Editor yrpg_Ptr)
        {
            InitializeComponent();
            this.yrpg_Ptr = yrpg_Ptr;
            string[] dirs = Directory.GetFiles(yrpg_Ptr.returnPath() + "\\Textures\\Skymap\\", "*.png");
            imageList1.ImageSize = new Size(128, 128);
            foreach (var file in dirs)
            {

                //ImageEngineImage img = new ImageEngineImage(file);
                imageList1.Images.Add(i + "", Image.FromFile(file));
                textureSky_listView.Items.Add(file.Substring(file.LastIndexOf('\\') + 1, file.Length - file.LastIndexOf('\\') - 1), i);
                i++;


            }
            this.FormClosing += new System.Windows.Forms.FormClosingEventHandler(this.Form1_FormClosing);
            //this.Editor_Speed_Values = Editor_Speed_Values;
        }

        private void reloadTextureList()
        {
            try
            {
                if (BMP_RadioButton.Checked == true)
                {
                    imageList1.Images.Clear();
                    textureSky_listView.Items.Clear();
                    textureSky_listView.LargeImageList.Images.Clear();
                    int i = 0;

                    string[] dirs = Directory.GetFiles(yrpg_Ptr.returnPath() + "\\Textures\\Skymap\\", "*.bmp");

                    foreach (var file in dirs)
                    {
                        imageList1.Images.Add(i + "", Image.FromFile(file));
                        textureSky_listView.Items.Add(file.Substring(file.LastIndexOf('\\') + 1, file.Length - file.LastIndexOf('\\') - 1), i);
                        i++;
                    }
                    i = 0;
                    foreach (var file in dirs)
                    {
                        textureSky_listView.Items.Add(file.Substring(file.LastIndexOf('\\') + 1, file.Length - file.LastIndexOf('\\') - 1), i);
                        i++;
                    }
                    textureSky_listView.LargeImageList = imageList1;
                    return;
                }
                else
                    if (TGA_RadioButton.Checked == true)
                    {
                        imageList1.Images.Clear();
                        textureSky_listView.Items.Clear();
                        textureSky_listView.LargeImageList.Images.Clear();
                        int i = 0;

                        string[] dirs = Directory.GetFiles(yrpg_Ptr.returnPath() + "\\Textures\\Skymap\\", "*.tga");

                        foreach (var file in dirs)
                        {
                            imageList1.Images.Add(i + "", Image.FromFile(file));
                            textureSky_listView.Items.Add(file.Substring(file.LastIndexOf('\\') + 1, file.Length - file.LastIndexOf('\\') - 1), i);
                            i++;
                        }
                        i = 0;
                        foreach (var file in dirs)
                        {
                            textureSky_listView.Items.Add(file.Substring(file.LastIndexOf('\\') + 1, file.Length - file.LastIndexOf('\\') - 1), i);
                            i++;
                        }
                        textureSky_listView.LargeImageList = imageList1;
                        return;
                    }
                    else
                        if (PNG_radioButton.Checked == true)
                        {

                            imageList1.Images.Clear();
                            textureSky_listView.Items.Clear();
                            textureSky_listView.LargeImageList.Images.Clear();



                    
                
                            string[] dirs = Directory.GetFiles(yrpg_Ptr.returnPath() + "\\Textures\\Skymap\\", "*.png");
                            foreach (var file in dirs)
                            {

                                if (!file.EndsWith("_n.png"))
                                {


                                    Bitmap bmp = new Bitmap(128, 128);
                                    using (Graphics g = Graphics.FromImage(bmp))
                                    {
                                        g.DrawImage(Image.FromFile(file), new Rectangle(0, 0, bmp.Width, bmp.Height));
                                    }
                                    imageList1.Images.Add(bmp);



                                    // imageList1.Images.Add(i + "", Image.FromFile(file).GetThumbnailImage(texture_width, texture_width, null, IntPtr.Zero));
                                    textureSky_listView.Items.Add(file.Substring(file.LastIndexOf('\\') + 1, file.Length - file.LastIndexOf('\\') - 1), i);
                                    i++;

                                  


                                }
                            }
                        }
                        else
                        {
                            byte[] stream = new byte[50000];
                            imageList1.Images.Clear();
                            textureSky_listView.Items.Clear();
                            textureSky_listView.LargeImageList.Images.Clear();
                            //////////////ImageEngineImage img;
                            int i = 0;
                            string[] dirs = Directory.GetFiles(yrpg_Ptr.returnPath() + "\\Textures\\Skymap\\", "*.dds");
                            foreach (var file in dirs)
                            {
                                ////////   img = null;
                                try
                                {
                                    Stream stream_ = new MemoryStream();
                                    ////////////   img = new ImageEngineImage(file);
                                    /////////  img.Save(stream_, ImageEngineFormat.JPG, false);


                                    /////  if (img != null)
                                    imageList1.Images.Add(i + "", Bitmap.FromStream(stream_));//img.GetGDIBitmap(true, 0));

                                    i++;
                                }
                                catch (Exception e)
                                {

                                }
                            }
                            i = 0;
                            foreach (var file in dirs)
                            {
                                textureSky_listView.Items.Add(file.Substring(file.LastIndexOf('\\') + 1, file.Length - file.LastIndexOf('\\') - 1), i);
                                i++;
                            }

                            textureSky_listView.LargeImageList = imageList1;
                            return;
                        }
            }
            catch (OutOfMemoryException OME)
            {
               
            }
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();

        }

        private void DDS_radioButton_CheckedChanged(object sender, EventArgs e)
        {
            reloadTextureList();
        }

        private void PNG_radioButton_CheckedChanged(object sender, EventArgs e)
        {
          // reloadTextureList();
        }

        private void texture32x32_radioButton_CheckedChanged(object sender, EventArgs e)
        {
            if (texture32x32_radioButton.Checked == true)
            {
                imageList1.ImageSize = new Size(32, 32);
                reloadTextureList();
            }
        }

        private void texture96x96_radioButton_CheckedChanged(object sender, EventArgs e)
        {
             if(texture96x96_radioButton.Checked == true){
            imageList1.ImageSize = new Size(96, 96);
            reloadTextureList();
             }
        }

        private void texture64x64_radioButton_CheckedChanged(object sender, EventArgs e)
        {
             if(texture64x64_radioButton.Checked == true){
            imageList1.ImageSize = new Size(64, 64);
            reloadTextureList();
             }
        }

        private void texture128x128_radioButton_CheckedChanged(object sender, EventArgs e)
        {
             if(texture128x128_radioButton.Checked == true){
            imageList1.ImageSize = new Size(128, 128);
            reloadTextureList();
             }
        }

        private void hideSky_checkBox_CheckedChanged(object sender, EventArgs e)
        {
            Scheduler.AddEventVoidThreadSafe(yrpg_Ptr.searchSky);
        }

        private void assignTexture_Button_Click(object sender, EventArgs e)
        {
            Scheduler.AddEventVoidThreadSafe(yrpg_Ptr.assignSkyTexture);
        }

        private void textureSky_listView_Click(object sender, EventArgs e)
        {
            if(textureSky_listView.SelectedItems.Count > 0)
            yrpg_Ptr.setSkyTexture(textureSky_listView.SelectedItems[0].Text);
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox1.Checked == true)
            {
                this.TopMost = true;
            }
            else
            {
                this.TopMost = false;
            }
        }

        private void horizontUP_Button_Click(object sender, EventArgs e)
        {
            Scheduler.AddEventVoidThreadSafe(yrpg_Ptr.changeSkyLevelUp);
        }

        private void horizontDOWN_Button_Click(object sender, EventArgs e)
        {
            Scheduler.AddEventVoidThreadSafe(yrpg_Ptr.changeSkyLevelDown);
          
        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void BMP_RadioButton_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void scaleUP_Button_Click(object sender, EventArgs e)
        {
            Scheduler.AddEventVoidThreadSafe(yrpg_Ptr.changeSkyScaleUp);
        }

        private void scaleDOWN_Button_Click(object sender, EventArgs e)
        {
            Scheduler.AddEventVoidThreadSafe(yrpg_Ptr.changeSkyScaleDown);
        }

        private void scale_NumericUpDown_ValueChanged(object sender, EventArgs e)
        {
            yrpg_Ptr.skyScale = (double)scale_NumericUpDown.Value;
        }

        private void horizont_NumericUpDown_ValueChanged(object sender, EventArgs e)
        {
            yrpg_Ptr.skyLevel = (double)horizont_NumericUpDown.Value;
        }
    }
	
	public class Editor_Sky_Attributes
    {
        public bool noSky = true;
        public double scale_Sky = 2.6025390625;
        public double position_z_Sky = -4520;
        public String texture_Sky = "";
      
        public Editor_Sky_Attributes()
        {
        }

    }
	
	  public partial class Editor_Speed : Form
    {
        Editor editor_ptr;
        //Editor_Speed_Values Editor_Speed_Values;
        public Editor_Speed(Editor_Speed_Values Editor_Speed_Values, Editor ptr)
        {
            InitializeComponent();
            this.FormClosing += new System.Windows.Forms.FormClosingEventHandler(this.Form1_FormClosing);
            //this.Editor_Speed_Values = Editor_Speed_Values;
        editor_ptr = ptr;
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();

        }
        public double getEntityMove()
        {
            return Convert.ToDouble(move.Value);
        }

        public double getEntityMoveFast()
        {
            return Convert.ToDouble(moveFast.Value);
        }

        public double getEntityPush()
        {
            return Convert.ToDouble(push.Value);
        }

        public double getEntityPushFast()
        {
            return Convert.ToDouble(pushFast.Value);
        }

        public double getEntityLift()
        {
            return Convert.ToDouble(lift.Value);
        }

        public double getEntityLiftFast()
        {
            return Convert.ToDouble(liftFast.Value);
        }

        public double getEntityPan()
        {
            return Convert.ToDouble(pan.Value);
        }

        public double getEntityLiftPanFast()
        {
            return Convert.ToDouble(panFast.Value);
        }

        public double getEntityMapMove()
        {
            return Convert.ToDouble(mLift.Value);
        }

        private void pan_ValueChanged(object sender, EventArgs e)
        {
            Editor_Speed_Values.ent_Pan = Convert.ToDouble(pan.Value);
            editor_ptr.YRPGMap_Options.entity_pan = Editor_Speed_Values.ent_Pan;
            
        }

        private void panFast_ValueChanged(object sender, EventArgs e)
        {
            Editor_Speed_Values.ent_PanFast = Convert.ToDouble(panFast.Value);
            editor_ptr.YRPGMap_Options.entity_pan_fast = Editor_Speed_Values.ent_PanFast;
        }

        private void push_ValueChanged(object sender, EventArgs e)
        {
            Editor_Speed_Values.ent_Push = Convert.ToDouble(push.Value);
            editor_ptr.YRPGMap_Options.entity_move = Editor_Speed_Values.ent_Push;
        }

        private void pushFast_ValueChanged(object sender, EventArgs e)
        {
            Editor_Speed_Values.ent_PushFast = Convert.ToDouble(pushFast.Value);
            editor_ptr.YRPGMap_Options.entity_move_fast = Editor_Speed_Values.ent_PushFast;
        }

        private void lift_ValueChanged(object sender, EventArgs e)
        {
            Editor_Speed_Values.ent_Lift = Convert.ToDouble(lift.Value);
            editor_ptr.YRPGMap_Options.entity_lift = Editor_Speed_Values.ent_Lift;
        }

        private void liftFast_ValueChanged(object sender, EventArgs e)
        {
            Editor_Speed_Values.ent_LiftFast = Convert.ToDouble(liftFast.Value);
            editor_ptr.YRPGMap_Options.entity_lift_fast = Editor_Speed_Values.ent_LiftFast;
        }

        private void move_ValueChanged(object sender, EventArgs e)
        {
            Editor_Speed_Values.map_Move = Convert.ToDouble(move.Value);
            editor_ptr.YRPGMap_Options.map_move = Editor_Speed_Values.map_Move;
        }

        private void moveFast_ValueChanged(object sender, EventArgs e)
        {
            Editor_Speed_Values.map_MoveFast = Convert.ToDouble(moveFast.Value);
            editor_ptr.YRPGMap_Options.map_move_fast = Editor_Speed_Values.map_MoveFast;
        }

        private void mLift_ValueChanged(object sender, EventArgs e)
        {
            Editor_Speed_Values.map_Lift = Convert.ToDouble(mLift.Value);
            editor_ptr.YRPGMap_Options.map_lift = Editor_Speed_Values.map_Lift;
        }

        private void mLiftFast_ValueChanged(object sender, EventArgs e)
        {
            Editor_Speed_Values.map_LiftFast = Convert.ToDouble(mLiftFast.Value);
            editor_ptr.YRPGMap_Options.map_Lift_fast = Editor_Speed_Values.map_LiftFast;
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox1.Checked == true)
            {
                this.TopMost = true;
            }
            else
            {
                this.TopMost = false;
            }
        }

    }
	
	 public class Editor_Speed_Values
    {
        public static double ent_Pan = 5;
        public static double ent_PanFast = 10;
        public static double ent_Push = 5;
        public static double ent_PushFast = 10;
        public static double ent_Lift = 5;
        public static double ent_LiftFast = 10;
        public static double map_Move = 5;
        public static double map_MoveFast = 10;
        public static double map_Lift = 5;
        public static double map_LiftFast = 10;
        public Editor_Speed_Values()
        {

        }
        
        public Editor_Speed_Values(double ent_Pan, double ent_PanFast, double ent_Push, double ent_PushFast, double ent_Lift, double ent_LiftFast,
                                   double map_Move, double map_MoveFast, double map_Lift)
        {
  

        }
    }
	
	 public partial class Editor_Sunlight : Form
    {
        Editor ptr = null;
        public Editor_Sunlight(Editor ptr)
        {
            this.ptr = ptr;
            InitializeComponent();
            this.FormClosing += new System.Windows.Forms.FormClosingEventHandler(Form1_FormClosing);
        }
        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();

        }
                private delegate void reloadSunHandle();

        public void reloadSun()
        {
            if(mapAmbient.InvokeRequired)
            {
                mapAmbient.BeginInvoke(new reloadSunHandle(reloadSun));
            }
            else{
             
         mapAmbientValue.Value =(int) ptr.current_Map_Object.ambientlight;
         sunColorRedValue.Value = (int)ptr.current_Map_Object.suncolor.x;
         sunColorBlueValue.Value = (int)ptr.current_Map_Object.suncolor.z;
         sunColorGreenValue.Value = (int)ptr.current_Map_Object.suncolor.y;
         sunLightValue.Value = (int)ptr.current_Map_Object.sunlight;
         ambientBlueValue.Value = (int)ptr.current_Map_Object.ambientcolor.z;
         ambientRedValue.Value = (int)ptr.current_Map_Object.ambientcolor.x;
         ambientGreenValue.Value = (int)ptr.current_Map_Object.ambientcolor.y;

         ambientColorBlue.Text = "" + ambientBlueValue.Value;
         ambientColorGreen.Text = "" + ambientGreenValue.Value;
         ambientColorRed.Text = "" + ambientRedValue.Value;


         sunLightT.Text = "" + sunLightValue.Value;
         mapAmbient.Text = "" + mapAmbientValue.Value;
         sunColorRed.Text = "" + sunColorRedValue.Value;
         sunColorBlue.Text = "" + sunColorBlueValue.Value;
         sunColorGreen.Text = "" + sunColorGreenValue.Value;

         sunLightAngel.Value = (int)ptr.current_Map_Object.sunlight_roll;
         sunLightPan.Value = (int)ptr.current_Map_Object.sunlight_pan;
        sunLightTilt.Value =  (int)ptr.current_Map_Object.sunlight_tilt;
                sunLightRoll_Label.Text = ptr.current_Map_Object.sunlight_roll.ToString();
                sunLightPan_Label.Text = ptr.current_Map_Object.sunlight_pan.ToString();
                sunLightTilt_Label.Text = ptr.current_Map_Object.sunlight_tilt.ToString();


                EngVar.camera.ambient = Convert.ToDouble(mapAmbientValue.Value);
                EngVar.sun_color.red = Convert.ToDouble(sunColorRedValue.Value);
                EngVar.sun_color.blue = Convert.ToDouble(sunColorBlueValue.Value);
                EngVar.sun_color.green = Convert.ToDouble(sunColorGreenValue.Value);
                EngVar.sun_light = Convert.ToDouble(sunLightValue.Value);
                EngVar.ambient_color.red = Convert.ToDouble(ambientRedValue.Value);
                EngVar.ambient_color.blue = Convert.ToDouble(ambientBlueValue.Value);
                EngVar.ambient_color.green = Convert.ToDouble(ambientGreenValue.Value);
                EngVar.sun_angle.tilt = sunLightTilt.Value;
                EngVar.sun_angle.roll = sunLightAngel.Value;
                EngVar.sun_angle.pan = sunLightPan.Value;
        }
        }
        private void mapAmbientValue_Scroll(object sender, EventArgs e)
        {
         mapAmbient.Text = "" + mapAmbientValue.Value;
         EngVar.camera.ambient = Convert.ToDouble(mapAmbientValue.Value);
         if (ptr.current_Map_Object != null)
         {
             ptr.current_Map_Object.ambientlight = mapAmbientValue.Value;
         }
        }

        private void sunColorRedValue_Scroll(object sender, EventArgs e)
        {
            sunColorRed.Text = "" + sunColorRedValue.Value;
            EngVar.sun_color.red = Convert.ToDouble(sunColorRedValue.Value);
            if (ptr.current_Map_Object != null)
            {
                ptr.current_Map_Object.suncolor.x = sunColorRedValue.Value;
            }
        }

        private void sunColorBlueValue_Scroll(object sender, EventArgs e)
        {
            sunColorBlue.Text = "" + sunColorBlueValue.Value;
            EngVar.sun_color.blue = Convert.ToDouble(sunColorBlueValue.Value);
            if (ptr.current_Map_Object != null)
            {
                ptr.current_Map_Object.suncolor.z = sunColorBlueValue.Value;
            }
        }

        private void sunColorGreenValue_Scroll(object sender, EventArgs e)
        {
            sunColorGreen.Text = "" + sunColorGreenValue.Value;
            EngVar.sun_color.green = Convert.ToDouble(sunColorGreenValue.Value);
            if (ptr.current_Map_Object != null)
            {
                ptr.current_Map_Object.suncolor.y = sunColorGreenValue.Value;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.Visible = false;
        }
   
        private void sunLightValue_Scroll(object sender, EventArgs e)
        {
            sunLightT.Text = "" + sunLightValue.Value;
            EngVar.sun_light = Convert.ToDouble(sunLightValue.Value);
            if (ptr.current_Map_Object != null)
            {
                ptr.current_Map_Object.sunlight = sunLightValue.Value;
            }
        }

        private void ambientRedValue_Scroll(object sender, EventArgs e)
        {
            EngVar.ambient_color.red = Convert.ToDouble(ambientRedValue.Value);
            ambientColorRed.Text = "" + ambientRedValue.Value;
            if (ptr.current_Map_Object != null)
            {
                ptr.current_Map_Object.ambientcolor.x = ambientRedValue.Value;
            }
        }

        private void ambientBlueValue_Scroll(object sender, EventArgs e)
        {
            EngVar.ambient_color.blue = Convert.ToDouble(ambientBlueValue.Value);
            ambientColorBlue.Text = "" + ambientBlueValue.Value;
            if (ptr.current_Map_Object != null)
            {
                ptr.current_Map_Object.ambientcolor.z = ambientBlueValue.Value;
            }
        }

        private void ambientGreenValue_Scroll(object sender, EventArgs e)
        {
            EngVar.ambient_color.green = Convert.ToDouble(ambientGreenValue.Value);
            ambientColorGreen.Text = "" + ambientGreenValue.Value;
            if (ptr.current_Map_Object != null)
            {
                ptr.current_Map_Object.ambientcolor.y = ambientGreenValue.Value;
            }
        }

        private void Sunlight_Load(object sender, EventArgs e)
        {

        }

        private void sunLightAngel_Scroll(object sender, EventArgs e)
        {
            EngVar.sun_angle.roll = sunLightAngel.Value;
            sunLightRoll_Label.Text = EngVar.sun_angle.roll.ToString();
        }

        private void sunLightTilt_Scroll(object sender, EventArgs e)
        {
            EngVar.sun_angle.tilt = sunLightTilt.Value;
            sunLightTilt_Label.Text = EngVar.sun_angle.tilt.ToString();
        }

        private void sunLightPan_Scroll(object sender, EventArgs e)
        {
            EngVar.sun_angle.pan = sunLightPan.Value;
            sunLightPan_Label.Text = EngVar.sun_angle.pan.ToString();
        }

        private void label1_Click(object sender, EventArgs e)
        {
           
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox1.Checked == true)
            {
                this.TopMost = true;
            }
            else
            {
                this.TopMost = false;
            }
        }

        private void defaultSettings_button_Click(object sender, EventArgs e)
        {
            defaultSettings_button.Enabled = false;
            mapAmbientValue.Value = 150;
            sunColorRedValue.Value = 150;
            sunColorBlueValue.Value = 150;
            sunColorGreenValue.Value = 150;
            sunLightValue.Value = 1;
            ambientBlueValue.Value = 150;
            ambientRedValue.Value = 150;
            ambientGreenValue.Value = 150;

            ambientColorBlue.Text = "" + ambientBlueValue.Value;
            ambientColorGreen.Text = "" + ambientGreenValue.Value;
            ambientColorRed.Text = "" + ambientRedValue.Value;


            sunLightT.Text = "" + sunLightValue.Value;
            mapAmbient.Text = "" + mapAmbientValue.Value;
            sunColorRed.Text = "" + sunColorRedValue.Value;
            sunColorBlue.Text = "" + sunColorBlueValue.Value;
            sunColorGreen.Text = "" + sunColorGreenValue.Value;

            sunLightAngel.Value = 50000;
            sunLightPan.Value = 150;
            sunLightTilt.Value = 150;
            sunLightRoll_Label.Text = ptr.current_Map_Object.sunlight_roll.ToString();
            sunLightPan_Label.Text = ptr.current_Map_Object.sunlight_pan.ToString();
            sunLightTilt_Label.Text = ptr.current_Map_Object.sunlight_tilt.ToString();


            EngVar.camera.ambient = 150;
            EngVar.sun_color.red = 150;
            EngVar.sun_color.blue = 150;
            EngVar.sun_color.green = 150;
            EngVar.sun_light = 1;
            EngVar.ambient_color.red = 150;
            EngVar.ambient_color.blue = 150;
            EngVar.ambient_color.green = 150;
            EngVar.sun_angle.tilt = 50000;
            EngVar.sun_angle.roll = 150;
            EngVar.sun_angle.pan = 150;
            defaultSettings_button.Enabled = true;
        }
    }
	
	  public class Events
    {
        public String main_Node = "";
        public String sub_Node = "";
        public int finished = 0;
        public List<String> eventCommands = new List<String>();
        public List<String> booleans = new List<String>();
        public String name;
        public String information;
        public bool deactivate_Menu = false;
        public float[] camera = new float[36];
        public bool openEvent = false;
        public bool battleEvent = false;
        public decimal id;
        public string fullID;
        
        
       public String getName()
        {
            return this.name;
        }
       public Events()
       {
           

       }
       public Events(String name, String information, decimal id)
        {
            this.name = name;
            this.information = information;
          
            this.id = id;

        }



    }
	

    public class IniFile
    {
        public string path;

        [DllImport("kernel32")]
        private static extern long WritePrivateProfileString(string section,
            string key, string val, string filePath);
        [DllImport("kernel32")]
        private static extern int GetPrivateProfileString(string section,
                 string key, string def, StringBuilder retVal,
            int size, string filePath);
        public IniFile(string INIPath)
        {
            path = INIPath;
        }
 
        public void IniWriteValue(string Section, string Key, string Value)
        {
            WritePrivateProfileString(Section, Key, Value, this.path);
        }
        public string IniReadValue(string Section, string Key)
        {
            StringBuilder temp = new StringBuilder(255);
            int i = GetPrivateProfileString(Section, Key, "", temp,
                                            255, this.path);
            return temp.ToString();

        }
    }
	
	public partial class MusicForm : Form 
    {
        Editor yrpg_ptr;
        public static ZPlay engine = new ZPlay();
        public MusicForm(Editor ptr)
        {
            this.yrpg_ptr = ptr;
            InitializeComponent(); this.FormClosing += new System.Windows.Forms.FormClosingEventHandler(this.Form1_FormClosing);
        }
        public MusicForm()
        {
        
            InitializeComponent(); this.FormClosing += new System.Windows.Forms.FormClosingEventHandler(this.Form1_FormClosing);
        }
        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            
            this.Visible = false;
            e.Cancel = true;
        }
    

        private void Form2_Load(object sender, EventArgs e)
        {

        }
        public bool envi_Sound = false;
        public bool map_Music = false;

        private void playButton_Click(object sender, EventArgs e)
        {

           engine.StopPlayback();
        

                // To play a sound, we only to call play2D(). The second parameter
                // tells the engine to play it looped.
                try
                {
                engine.StopPlayback();
                if (envi_Sound == true)
                {
                    change_Volume();
                    engine.OpenFile(yrpg_ptr.pathSave + "\\Sounds\\" + listBox7.SelectedItem, TStreamFormat.sfAutodetect);
                    TStreamTime startpos = new TStreamTime();
                    TStreamTime endpos = new TStreamTime();
                    engine.GetPosition(ref startpos);
                    TStreamInfo info = new TStreamInfo();
                    engine.GetStreamInfo(ref info);
                    endpos = info.Length;
                    engine.PlayLoop(TTimeFormat.tfSecond, ref startpos, TTimeFormat.tfSecond, ref endpos, 99, true);
                    //engine.StartPlayback();
                }
                else
                {
                    change_Volume();
                    engine.OpenFile(yrpg_ptr.pathSave + "\\Music\\" + listBox7.SelectedItem, TStreamFormat.sfAutodetect);
                    TStreamTime startpos = new TStreamTime();
                    TStreamTime endpos = new TStreamTime();
                    engine.GetPosition(ref startpos);
                    TStreamInfo info = new TStreamInfo();
                    engine.GetStreamInfo(ref info);
                    endpos = info.Length;
                    engine.PlayLoop(TTimeFormat.tfSecond, ref startpos, TTimeFormat.tfSecond, ref endpos, 99, true);
                }
            }
                  catch (FileNotFoundException a)
                {

                }

          
           

        }

        private void stopButton_Click(object sender, EventArgs e)
        {
      
            {
              engine.StopPlayback();
            }
         
        }

        private void listBox7_SelectedIndexChanged(object sender, EventArgs e)
        {
            if(yrpg_ptr != null)
                if(yrpg_ptr != null)
                    if(yrpg_ptr.Editor_Map_Properties != null)
                        if (yrpg_ptr.prop_On == true)
            {if(!envi_Sound)
                yrpg_ptr.Editor_Map_Properties.music_comboBox.SelectedItem = listBox7.SelectedItem;
            else
                yrpg_ptr.Editor_Map_Properties.environmentSound_comboBox.SelectedItem = listBox7.SelectedItem;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.Visible = false;
        }

        private void listBox7_MouseDoubleClick(object sender, MouseEventArgs e)
        {

            try
            {
              

                    // To play a sound, we only to call play2D(). The second parameter
                    // tells the engine to play it looped.
                    engine.StopPlayback();
                    if (envi_Sound == true)
                    {
                        change_Volume();
                        engine.OpenFile(yrpg_ptr.pathSave + "\\Sounds\\" + listBox7.SelectedItem, TStreamFormat.sfAutodetect);
                        TStreamTime startpos = new TStreamTime();
                        TStreamTime endpos = new TStreamTime();
                        engine.GetPosition(ref startpos);
                        TStreamInfo info = new TStreamInfo();
                        engine.GetStreamInfo(ref info);
                        endpos = info.Length;
                        engine.PlayLoop(TTimeFormat.tfSecond, ref startpos, TTimeFormat.tfSecond, ref endpos, 99, true);
                    }
                    else
                    {
                        change_Volume();
                        engine.OpenFile(yrpg_ptr.pathSave + "\\Music\\" + listBox7.SelectedItem, TStreamFormat.sfAutodetect);
                        TStreamTime startpos = new TStreamTime();
                        TStreamTime endpos = new TStreamTime();
                        engine.GetPosition(ref startpos);
                        TStreamInfo info = new TStreamInfo();
                        engine.GetStreamInfo(ref info);
                        endpos = info.Length;
                        engine.PlayLoop(TTimeFormat.tfSecond, ref startpos, TTimeFormat.tfSecond, ref endpos, 99, true);
                    }


                
       
            }
            catch (FileNotFoundException b)
            {

            }
        }
        private void change_Volume()
        {
            float a = (float)trackBar1.Value; /// (float)100;

            engine.SetMasterVolume((int)a,(int)a);
            label1.Text = trackBar1.Value + "%";
        }
        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            if (yrpg_ptr != null)
                if(yrpg_ptr != null)
                    if(yrpg_ptr.Editor_Map_Properties != null)
                        if(yrpg_ptr.prop_On == true)
            {
                if(envi_Sound)
                yrpg_ptr.Editor_Map_Properties.enviSoundVolume_numericUpDown.Value = trackBar1.Value;
                if(!envi_Sound)
                    yrpg_ptr.Editor_Map_Properties.musicVolume_numericUpDown.Value = trackBar1.Value;
            }
            float a = (float)trackBar1.Value;/// (float)100;

            engine.SetMasterVolume((int)a, (int)a);
            label1.Text = trackBar1.Value + "%";

        }
    }
	  public static class Program
    {
        /// <summary>
        /// Der Haupteinstiegspunkt für die Anwendung.
        /// </summary>
       [STAThread]
       
      public static void Main()
        {
          
            IniFile ini = new VRPGText.IniFile(".\\YED.ini");
            if (ini.IniReadValue("Executable Path", "Single_Start_Project_Path").Equals(""))
            {
                MessageBox.Show("Please set up a Workspace and restart YED.","Workspace not found",MessageBoxButtons.OK,MessageBoxIcon.Information);
                try
                {
                    Process np = new Process();
                    np.StartInfo.FileName = ".\\YED_Config.exe";
                    np.Start();
                    return;
                }
                catch(Win32Exception error_A)
                {
                    MessageBox.Show("The tool 'YED_Config.exe' was not found.", "YED Error_001", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }
            }
                String workspace_Path = ini.IniReadValue("Executable Path", "Single_Start_Project_Path");

                if (!Directory.Exists(workspace_Path + "\\Textures\\"))
                {
                    MessageBox.Show("The choosen workspace structure is corrupted.\r\nYED cannot find the 'Texture' folder.", "YED Error_004", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    try
                    {
                       // if(System.Diagnostics.Process.GetProcessesByName(System.IO.Path.GetFileNameWithoutExtension(System.Reflection.Assembly.GetEntryAssembly().Location)).Count() > 1)
                        Process np = new Process();
                        np.StartInfo.FileName = ".\\YED_Config.exe";
                        np.Start();
                        return;
                    }
                    catch (Win32Exception error_A)
                    {
                        MessageBox.Show("The tool 'YED_Config.exe' was not found.", "YED Error_001", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        return;
                    }
                    return;
                }

                if (!Directory.Exists(workspace_Path + "\\Textures\\Skymap\\"))
                {
                    MessageBox.Show("The choosen workspace structure is corrupted.\r\nYED cannot find the 'Skymap Texture' folder.", "YED Error_005", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    try
                    {
                        // if(System.Diagnostics.Process.GetProcessesByName(System.IO.Path.GetFileNameWithoutExtension(System.Reflection.Assembly.GetEntryAssembly().Location)).Count() > 1)
                        Process np = new Process();
                        np.StartInfo.FileName = ".\\YED_Config.exe";
                        np.Start();
                        return;
                    }
                    catch (Win32Exception error_A)
                    {
                        MessageBox.Show("The tool 'YED_Config.exe' was not found.", "YED Error_001", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        return;
                    }
                    return;
                }

                if (!Directory.Exists(workspace_Path + "\\Maps\\Templates\\"))
                {
                    MessageBox.Show("The choosen workspace structure is corrupted.\r\nYED cannot find the 'Map Templates' folder.", "YED Error_006", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    try
                    {
                        Process np = new Process();
                        np.StartInfo.FileName = ".\\YED_Config.exe";
                        np.Start();
                        return;
                    }
                    catch (Win32Exception error_A)
                    {
                        MessageBox.Show("The tool 'YED_Config.exe' was not found.", "YED Error_001", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        return;
                    }
                    return;
                }

                if (!Directory.Exists(workspace_Path + "\\Maps\\Tiles\\"))
                {
                    MessageBox.Show("The choosen workspace structure is corrupted.\r\nYED cannot find the 'Map Tiles' folder.", "YED Error_007", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    try
                    {
                        Process np = new Process();
                        np.StartInfo.FileName = ".\\YED_Config.exe";
                        np.Start();
                        return;
                    }
                    catch (Win32Exception error_A)
                    {
                        MessageBox.Show("The tool 'YED_Config.exe' was not found.", "YED Error_001", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        return;
                    }
                    return;
                }

                if (!Directory.Exists(workspace_Path + "\\Models\\"))
                {
                    MessageBox.Show("The choosen workspace structure is corrupted.\r\nYED cannot find the 'Models' folder.", "YED Error_008", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    try
                    {
                        Process np = new Process();
                        np.StartInfo.FileName = ".\\YED_Config.exe";
                        np.Start();
                        return;
                    }
                    catch (Win32Exception error_A)
                    {
                        MessageBox.Show("The tool 'YED_Config.exe' was not found.", "YED Error_001", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        return;
                    }
                    return;
                }

                if (!Directory.Exists(workspace_Path + "\\Music\\"))
                {
                    MessageBox.Show("The choosen workspace structure is corrupted.\r\nYED cannot find the 'Music' folder.", "YED Error_009", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    try
                    {
                        Process np = new Process();
                        np.StartInfo.FileName = ".\\YED_Config.exe";
                        np.Start();
                        return;
                    }
                    catch (Win32Exception error_A)
                    {
                        MessageBox.Show("The tool 'YED_Config.exe' was not found.", "YED Error_001", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        return;
                    }
                    return;
                }

                if (!Directory.Exists(workspace_Path + "\\Sounds\\"))
                {
                    MessageBox.Show("The choosen workspace structure is corrupted.\r\nYED cannot find the 'Sound' folder.", "YED Error_010", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    try
                    {
                        Process np = new Process();
                        np.StartInfo.FileName = ".\\YED_Config.exe";
                        np.Start();
                        return;
                    }
                    catch (Win32Exception error_A)
                    {
                        MessageBox.Show("The tool 'YED_Config.exe' was not found.", "YED Error_001", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        return;
                    }
                    return;
                }

                if (!Directory.Exists(workspace_Path + "\\Scripts\\"))
                {
                    MessageBox.Show("The choosen workspace structure is corrupted.\r\nYED cannot find the 'Scripts' folder.", "YED Error_011", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    try
                    {
                        Process np = new Process();
                        np.StartInfo.FileName = ".\\YED_Config.exe";
                        np.Start();
                        return;
                    }
                    catch (Win32Exception error_A)
                    {
                        MessageBox.Show("The tool 'YED_Config.exe' was not found.", "YED Error_001", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        return;
                    }
                    return;
                }
           
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
       
                Editor YED = new Editor();
            
                    Application.Run(YED);
             
            
             
        }
    }
	
	 public static class StringHelper
    {
        public static String separateSlash(String object_)
        {
            if (object_.Contains("\\"))
                return object_.Substring(object_.LastIndexOf('\\') + 1, object_.Length - object_.LastIndexOf('\\') - 1);
            else
                return object_;

        }
        public static String separateFromFirst(String object_, char sign)
        {
            if (object_.Contains(sign))
                return object_.Substring(object_.LastIndexOf(sign) + 1, object_.Length - object_.LastIndexOf(sign) - 1);
            else
                return object_;

        }
        public static String separateFromLast(String object_, char sign)
        {
            if (object_.Contains(sign))
                return object_.Substring(0, object_.LastIndexOf(sign));
            else
                return object_;

        }
        public static String StringAfterLast(String object_, char sign)
        {
            if (object_.Contains(sign))
                return object_.Substring(object_.LastIndexOf(sign)+1,object_.Length-object_.LastIndexOf(sign)-1);
            else
                return object_;

        }
        public static String separateMimeType(String object_)
        {
            if (object_.Contains("."))
                return object_.Substring(0, object_.LastIndexOf("."));
            else
                return object_;
        }

        public static String betweenLastTwoSigns(String source, Char sign, Char sign2)
        {
            int i = 0;
            int a = 0;
            int o = 0;
            for (i = 0; i < source.Length; i++)
            {
                if (source[i] == sign)
                {
                    a = i;
                }


                if (source[i] == sign2)
                {
                    o = i;
                }

            } return source.Substring(a + 1, o - a - 1);

        }
        public static String betweenTwoSigns(String source, Char sign)
        {
            return source.Substring(source.IndexOf(sign) + 1, source.LastIndexOf(sign) - 1 - source.IndexOf(sign));
        }
        public static String betweenTwoSigns(String source, Char sign1, Char sign2)
        {
            return source.Substring(source.IndexOf(sign1) + 1, source.LastIndexOf(sign2) - 1 - source.IndexOf(sign1));
        }
        public static String betweenTwoFirstSigns(String source, Char sign1, Char sign2)
        {
            return source.Substring(source.IndexOf(sign1) + 1, source.IndexOf(sign2) - 1 - source.IndexOf(sign1));
        }
        public static String betweenTwoStringsLast(String source, String string1, String string2)
        {
            //MessageBox.Show( source.Substring(source.IndexOf(string1) + string1.Length, source.LastIndexOf(string2) - source.IndexOf(string1) - string1.Length));
            return source.Substring(source.IndexOf(string1) + string1.Length, source.LastIndexOf(string2) - source.IndexOf(string1) - string1.Length); //- source.IndexOf(string1));
        }
        public static String betweenTwoStringsFirst(String source, String string1, String string2)
        {
            //MessageBox.Show( source.Substring(source.IndexOf(string1) + string1.Length, source.LastIndexOf(string2) - source.IndexOf(string1) - string1.Length));
            return source.Substring(source.IndexOf(string1) + string1.Length, source.IndexOf(string2) - source.IndexOf(string1) - string1.Length); //- source.IndexOf(string1));
        }
    }